/* -----------------------------------------------------------------------------
	fobOpTEheXg
	t@C  : sound_test.as
			: hakuhin (c) 2006/02/17
	
			: eXgpTEh
 ----------------------------------------------------------------------------- */

function SoundTestCreate(task,param){
	TaskCreate(
		SoundTestInit,
		SoundTestExec,
		SoundTestDel,
		task,PRIO_SYSTEM,LEVEL_MENU,param
	);
}


function SoundTestInit(obj,task,param){
	var i;
	obj.task = task;
	obj.mc = _root.createEmptyMovieClip("sound_test_menu", 200);

	obj.x = 0;
	obj.y = 0;
	obj.step = 0;
	obj.bgm = 0;
	obj.se = 0;
	
	var type = [
	"BGM [     ]",
	"SE  [     ]",
	"EXIT"
	];
	
	var text = new TextFormat();
	text.font = "MS UI Gothic";
	text.size = 12;

	obj.mc.createTextField("sound_menu",obj.mc.getNextHighestDepth(), 10, 20, 100, 20);
	obj.mc.sound_menu.text = "SOUND TEST";
	obj.mc.sound_menu.selectable = false;
	obj.mc.sound_menu.setTextFormat(text);

	for(i=0;i<type.length;i++){
		obj.mc.createTextField("menu" + i,obj.mc.getNextHighestDepth(), 30, 40 + i * 20, 100, 20);
		eval("obj.mc.menu"+i).text = type[i];
		eval("obj.mc.menu"+i).selectable = false;
		eval("obj.mc.menu"+i).setTextFormat(text);
	}
	
	obj.mc.createTextField("cur",obj.mc.getNextHighestDepth(), 10, 30, 30, 20);
	obj.mc.cur.text = ">>";
	obj.mc.cur.selectable = false;
	obj.mc.cur.setTextFormat(text);
	
	obj.mc.createTextField("bgm",obj.mc.getNextHighestDepth(), 70, 40 + 0 * 20, 100, 20);
	obj.mc.bgm.text = 0;
	obj.mc.bgm.selectable = false;
	obj.mc.bgm.setTextFormat(text);
	
	obj.mc.createTextField("se",obj.mc.getNextHighestDepth(), 60, 40 + 1 * 20, 100, 20);
	obj.mc.se.text = 0;
	obj.mc.se.selectable = false;
	obj.mc.se.setTextFormat(text);
}

function SoundTestExec(obj){
	obj.mc.cur._x = 10;
	obj.mc.cur._y = obj.y * 20 + 40;

	switch(obj.step){
	case 0:
		obj.step = 1;
		break;
	case 1:

		if(KeyData[0].Menu & KEY_UP)	obj.y --;
		if(KeyData[0].Menu & KEY_DOWN)	obj.y ++;

		if(obj.y < 0)	obj.y = 2;
		if(obj.y > 2)	obj.y = 0;


		switch(obj.y){
		case 0:
			if(KeyData[0].Menu & KEY_LEFT)	obj.bgm --;
			if(KeyData[0].Menu & KEY_RIGHT)	obj.bgm ++;
			if(obj.bgm < 0)				obj.bgm += BGM_ID_MAX;
			if(obj.bgm >= BGM_ID_MAX)	obj.bgm -= BGM_ID_MAX;
			obj.mc.bgm.text = obj.bgm;
			if(KeyData[0].Trg & KEY_A){
				SoundAllStop(obj.bgm_id);
				obj.bgm_id = SoundPlay(obj.bgm,100,0,SOUND_PRIO_BGM,false);
			}
			break;
		case 1:
			if(KeyData[0].Menu & KEY_LEFT)	obj.se --;
			if(KeyData[0].Menu & KEY_RIGHT)	obj.se ++;
			if(obj.se < 0)			obj.se += SE_ID_MAX;
			if(obj.se >= SE_ID_MAX)	obj.se -= SE_ID_MAX;
			obj.mc.se.text = obj.se;
			if(KeyData[0].Trg & KEY_A){
				SoundPlay(obj.se + SE_ID_START,100,0,SOUND_PRIO_SE,false);
			}
			break;
		case 2:
			if(KeyData[0].Trg & KEY_A){
				obj.step = 99;
			}
			break;
		}



		if(KeyData[0].Trg & KEY_B){
			SoundAllStop(obj.bgm_id);
		}

		if(KeyData[0].Trg & KEY_PAUSE){
			obj.step = 99;
		}


		
		break;
	case 99:
		SoundAllStop();
		TaskDelete(obj.task);	// e^XNƏ
		DebugMenuTaskCreate(null,null);
		return;
		break;
	}


}

function SoundTestDel(obj){
	obj.mc.removeMovieClip();
}

