/* -----------------------------------------------------------------------------
	C䉌֐
	t@C  : cannon_fire.as
			: hakuhin (c) 2006/12/20
	
			: C䉌֐
 ----------------------------------------------------------------------------- */

CANNON_FIRE_PTC_NUM = 8;


// J[e[u
CannonFirePtcExpTable = [
	{	// 01t[ 
		time:	15,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,128)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{time: -1}
];

function PtcCannonFireCreate(pos,dir){
	var param = {depth : EffectDepthGet(),pos : pos,dir : dir};
	var order = {
		target	 : _root.sprite,
		depth    : param.depth.depth,	// p[eBN[x
		res      : "ryousyo",			// \[X
		emt_init : CannonFireEmtInit,		// G~b^֐
		emt_exec : CannonFireEmtExec,		// G~b^ړ֐
		emt_del  : CannonFireEmtDel,		// G~b^j֐
		ptc_init : CannonFirePtcInit,		// p[eBN֐
		ptc_exec : CannonFirePtcExec,		// p[eBNړ֐
		ptc_del  : CannonFirePtcDel,		// p[eBNj֐
		gen_num  : CANNON_FIRE_PTC_NUM,		// 
		gen_time : 99,					// Ԋu
		emt_time : CANNON_FIRE_PTC_NUM,		// G~b^I
		kill_time: 15,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(STAGE_TASK,LEVEL_STAGE,order);
}

function CannonFireEmtInit(obj,emt){
	obj.pos = Vec2dClone(obj.param.pos);
	emt.dir = obj.param.dir;
	emt.rot = 0;
	CannonFireEmtExec(obj,emt);
}

function CannonFireEmtExec(obj,emt){
	var pos = obj.pos;
	emt._x = pos.x;
	emt._y = pos.y;
}

function CannonFireEmtDel(obj,emt){
	EffectDepthPurge(obj.param.depth);
}
function CannonFirePtcInit(emt,ptc){
	ptc.time = 15;
	ptc.blendMode = "add";
	ptc.pos = Vec2dCreate(emt.dir * 5,0);
	ptc.spd = Vec2dCreate(Math.random() * 6,Math.random() * 4 - 2);
	ptc.spd.x *= emt.dir;
	ptc.color = ColorCreate(ptc);
	
	ColorTableSet(ptc.color,CannonFirePtcExpTable,null);
}

function CannonFirePtcExec(emt,ptc){
	ptc.spd = Vec2dScale(ptc.spd,0.8);

	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;

	ColorExecute(ptc.color);
}

function CannonFirePtcDel(emt,ptc){
	delete obj.color;
}

