/* -----------------------------------------------------------------------------
	UCN֐
	t@C  : center_blur.as
			: hakuhin (c) 2006/11/13
	
			: UCNo\
 ----------------------------------------------------------------------------- */

// \[Xp^[Qbg
CENTER_BLUR_LENGTH 	= 1.03;
CENTER_BLUR_ALPHA	=0.5;



/* --------------------------------
	vC[^XN
 -------------------------------- */
function CenterBlurCreate(task,param){
	return TaskCreate(
		CenterBlurInitalize,
		CenterBlurExecute,
		CenterBlurDelete,
		task,PRIO_EFFECT,LEVEL_PLAYER,param
	);
}


// ʏ
function CenterBlurInitalize(obj,task,param){
	obj.task = task;
	obj.frame = 0;
	obj.pos = Vec2dCreate(0,0);
	obj.mc = _root.createEmptyMovieClip("blur" + DEPTH_FADE, DEPTH_FADE);
	
	var trans = new flash.geom.Transform(obj.mc);
	var color = new flash.geom.ColorTransform(1, 1, 1, CENTER_BLUR_ALPHA, 0, 0, 0, 0);
	trans.colorTransform = color;

	
	obj.bmpData = new flash.display.BitmapData(SCREEN_WIDTH, SCREEN_HEIGHT,true);
	obj.bmpBuffer = new flash.display.BitmapData(SCREEN_WIDTH, SCREEN_HEIGHT,true);
	CenterBlurExecute(obj);
}


// ʏ
function CenterBlurExecute(obj){
    //obt@`prbg}bvɓ]
    obj.bmpData.copyPixels(obj.bmpBuffer, new flash.geom.Rectangle(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT), new flash.geom.Point(0, 0));

    // obt@ɃLv`[
    var m = new flash.geom.Matrix(1 , 0, 0, 1, 0, 0);
    obj.bmpBuffer.fillRect(new flash.geom.Rectangle(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT), 0x00FFFFFF);
    obj.bmpBuffer.draw(_root, m);


    // `ItZbgps
    var m = new flash.geom.Matrix(1, 0, 0, 1, 0, 0);
    m.translate(-SCREEN_WIDTH_HALF,-SCREEN_HEIGHT_HALF);
    m.scale(CENTER_BLUR_LENGTH,CENTER_BLUR_LENGTH);
    m.translate(SCREEN_WIDTH_HALF,SCREEN_HEIGHT_HALF);

    // ɏd˂ĕ`
   obj.mc.clear();
    obj.mc.beginBitmapFill(obj.bmpData, m, true, true);
    obj.mc.moveTo(0, 0);
    obj.mc.lineTo(0, SCREEN_HEIGHT);
    obj.mc.lineTo(SCREEN_WIDTH, SCREEN_HEIGHT);
    obj.mc.lineTo(SCREEN_WIDTH, 0);
    obj.mc.endFill();
	
	var d = 1 - obj.frame / 30;
	if(d > 1)	d = 1;
	obj.mc._alpha = d * 100;

	if( ++ obj.frame > 30){
		TaskDelete(obj.task);
		return;
	}
}


function CenterBlurDelete(obj){
	obj.bmpData.dispose();
	obj.bmpBuffer.dispose();
	obj.mc.removeMovieClip();
}
