/* -----------------------------------------------------------------------------
	p[eBN֐
	t@C  : fire_ptc.as
			: hakuhin (c) 2007/01/22
	
			: p[eBN֐
 ----------------------------------------------------------------------------- */

// J[e[u
FirePtcExpTable = [
	{	// 01t[ 
		time:	20,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,0.25,0.1,0,0,0,0,255)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,0.5,0,0,0,0,0,64)
	},{
		time:	-1,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,0,0,0,0,0,0)
	},{time: -1}
];

function PtcFireCreate(pos){
	var param = {depth : EffectDepthGet(),pos : pos};
	var order = {
		target	 : _root.back_rayer1,
		depth    : param.depth.depth,	// p[eBN[x
		res      : "snow_ptc_l",		// \[X
		emt_init : FireEmtInit,		// G~b^֐
		emt_exec : FireEmtExec,		// G~b^ړ֐
		emt_del  : FireEmtDel,			// G~b^j֐
		ptc_init : FirePtcInit,		// p[eBN֐
		ptc_exec : FirePtcExec,		// p[eBNړ֐
		ptc_del  : FirePtcDel,			// p[eBNj֐
		gen_num  : 3,					// 
		gen_time : 1,					// Ԋu
		emt_time : 0x7FFFFFFF,			// G~b^I
		kill_time: 15,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(STAGE_TASK,LEVEL_STAGE,order);
	
	var i;
	for(i=0;i<60;i++){
		ParticleTaskExec(id.obj);
	}
}

function FireEmtInit(obj,emt){
}

function FireEmtExec(obj,emt){
}

function FireEmtDel(obj,emt){
	EffectDepthPurge(obj.param.depth);
}
function FirePtcInit(emt,ptc){
	ptc.time = 20;
	ptc.blendMode = "add";
	ptc.pos = { x : Math.random() * (GAME_WIDTH - 40) + 20, y : GAME_HEIGHT + 20};
	ptc.spd = Vec2dCreate(Math.random() * 6 - 3, -(Math.random() * 5 + 1));
	ptc._xscale = ptc._yscale = Math.random() * 50 + 350;
	ptc.color = ColorCreate(ptc);
	ColorTableSet(ptc.color,FirePtcExpTable,null);
}

function FirePtcExec(emt,ptc){
	ptc._xscale *= 0.975;
	ptc._yscale *= 0.975;

	ptc.spd.x += RandomSign() * Math.random() * 0.1;
	ptc.spd.y += RandomSign() * Math.random() * 0.1;
	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;
	ColorExecute(ptc.color);
}

function FirePtcDel(emt,ptc){
}


function FirePtcScript(param,id,task){
	PtcFireCreate({x:0,y:0});
	PtcFireCldCreate({x:0,y:0});
}


// J[e[u
FireCldPtcExpTable = [
	{	// 01t[ 
		time:	90,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,0.2,0.1,0,0,0,0,255)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,0.5,0,0,0,0,0,64)
	},{
		time:	-1,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,5,0,0,0,0,0)
	},{time: -1}
];


function PtcFireCldCreate(pos){
	var param = {depth : EffectDepthGet(),pos : pos};
	var order = {
		target	 : _root.back_rayer1,
		depth    : param.depth.depth,	// p[eBN[x
		res      : "snow_ptc_s",		// \[X
		emt_init : FireCldEmtInit,		// G~b^֐
		emt_exec : FireCldEmtExec,		// G~b^ړ֐
		emt_del  : FireCldEmtDel,			// G~b^j֐
		ptc_init : FireCldPtcInit,		// p[eBN֐
		ptc_exec : FireCldPtcExec,		// p[eBNړ֐
		ptc_del  : FireCldPtcDel,			// p[eBNj֐
		gen_num  : 1,					// 
		gen_time : 8,					// Ԋu
		emt_time : 0x7FFFFFFF,			// G~b^I
		kill_time: 15,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(STAGE_TASK,LEVEL_STAGE,order);
	
	var i;
	for(i=0;i<60;i++){
		ParticleTaskExec(id.obj);
	}
}

function FireCldEmtInit(obj,emt){
}

function FireCldEmtExec(obj,emt){
}

function FireCldEmtDel(obj,emt){
	EffectDepthPurge(obj.param.depth);
}
function FireCldPtcInit(emt,ptc){
	ptc.time = 90;
	ptc.blendMode = "add";
	ptc.pos = { x : Math.random() * (GAME_WIDTH - 60) + 30, y : GAME_HEIGHT + 20};
	ptc.spd = Vec2dCreate(Math.random() * 6 - 3, -(Math.random() * 4 + 1));
	ptc._xscale = ptc._yscale = Math.random() * 50 + 50;
	ptc.color = ColorCreate(ptc);
	ColorTableSet(ptc.color,FireCldPtcExpTable,null);
}

function FireCldPtcExec(emt,ptc){
	ptc.spd.x += RandomSign() * Math.random() * 0.05;
	ptc.spd.y -= Math.random() * 0.05;
	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;
	ColorExecute(ptc.color);
}

function FireCldPtcDel(emt,ptc){
}