/* -----------------------------------------------------------------------------
	֐
	t@C  : setuna_hit_ptc.as
			: hakuhin (c) 2006/03/18
	
			: p[eBN֐
 ----------------------------------------------------------------------------- */

SETUNA_HIT_PTC_NUM = 8;


// J[e[u
SetunaHitPtcExpTable = [
	{	// 01t[ 
		time:	30,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,128)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{time: -1}
];

function PtcSetunaHitCreate(pos,target){
	var param = {depth : EffectDepthGet(),pos : pos};
	var order = {
		target	 : target,
		depth    : param.depth.depth,	// p[eBN[x
		res      : "ryousyo",			// \[X
		emt_init : SetunaHitEmtInit,		// G~b^֐
		emt_exec : SetunaHitEmtExec,		// G~b^ړ֐
		emt_del  : SetunaHitEmtDel,		// G~b^j֐
		ptc_init : SetunaHitPtcInit,		// p[eBN֐
		ptc_exec : SetunaHitPtcExec,		// p[eBNړ֐
		ptc_del  : SetunaHitPtcDel,		// p[eBNj֐
		gen_num  : SETUNA_HIT_PTC_NUM,		// 
		gen_time : 99,					// Ԋu
		emt_time : SETUNA_HIT_PTC_NUM,		// G~b^I
		kill_time: 30,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(STAGE_TASK,LEVEL_ANIM,order);
}

function SetunaHitEmtInit(obj,emt){
	if(Math.floor(Math.random() * 2) == 0)	emt.type = "_type0";
	else									emt.type = "_type1";

	obj.pos = Vec2dClone(obj.param.pos);
	emt.rot = 0;
	SetunaHitEmtExec(obj,emt);
}

function SetunaHitEmtExec(obj,emt){
	var pos = obj.pos;
	emt._x = pos.x;
	emt._y = pos.y;
}

function SetunaHitEmtDel(obj,emt){
	EffectDepthPurge(obj.param.depth);
}
function SetunaHitPtcInit(emt,ptc){
	ptc.time = 30;
	ptc.blendMode = "add";
	var m = Mtx33Rotate(emt.rot + Math.random() * 5 * RandomSign());
	var v = Vec2dTransformVector(1,0,m);
	ptc.pos = Vec2dScale(v,5);
	ptc.spd = Vec2dScale(v,10);
	ptc._xscale = ptc._yscale = 200;
	ptc.color = ColorCreate(ptc);
	
	emt.rot += 360 / SETUNA_HIT_PTC_NUM;
	ColorTableSet(ptc.color,SetunaHitPtcExpTable,null);

	// Aj[VXV
	AnmCmdInit(ptc);
	ptc.ANM_GOTO = emt.type;
	AnmCmdPlay(ptc);
}

function SetunaHitPtcExec(emt,ptc){
	ptc.spd = Vec2dScale(ptc.spd,0.80);

	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;

	ColorExecute(ptc.color);
}

function SetunaHitPtcDel(emt,ptc){
	delete obj.color;
}

