/* -----------------------------------------------------------------------------
	֐
	t@C  : smoke_ptc.as
			: hakuhin (c) 2006/03/18
	
			: p[eBN֐
 ----------------------------------------------------------------------------- */

SMOKE_PTC_NUM = 8;


// J[e[u
SmokePtcExpTable = [
	{	// 01t[ 
		time:	15,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,128)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{time: -1}
];

function PtcSmokeCreate(pos){
	var param = {depth : EffectDepthGet(),pos : pos};
	var order = {
		target	 : _root.sprite,
		depth    : param.depth.depth,	// p[eBN[x
		res      : "smoke",			// \[X
		emt_init : SmokeEmtInit,		// G~b^֐
		emt_exec : SmokeEmtExec,		// G~b^ړ֐
		emt_del  : SmokeEmtDel,		// G~b^j֐
		ptc_init : SmokePtcInit,		// p[eBN֐
		ptc_exec : SmokePtcExec,		// p[eBNړ֐
		ptc_del  : SmokePtcDel,		// p[eBNj֐
		gen_num  : SMOKE_PTC_NUM,		// 
		gen_time : 99,					// Ԋu
		emt_time : SMOKE_PTC_NUM,		// G~b^I
		kill_time: 15,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(STAGE_TASK,LEVEL_STAGE,order);
}

function SmokeEmtInit(obj,emt){
	obj.pos = Vec2dClone(obj.param.pos);
	emt.rot = 0;
}

function SmokeEmtExec(obj,emt){
	var pos = obj.pos;
	emt._x = pos.x;
	emt._y = pos.y;
}

function SmokeEmtDel(obj,emt){
	EffectDepthPurge(obj.param.depth);
}
function SmokePtcInit(emt,ptc){
	ptc.time = 15;
	ptc.blendMode = "add";
	var m = Mtx33Rotate(emt.rot + Math.random() * 5 * RandomSign());
	var v = Vec2dTransformVector(1,0,m);
	ptc.pos = Vec2dScale(v,1);
	ptc.spd = Vec2dScale(v,3);
	ptc.color = ColorCreate(ptc);
	
	emt.rot += 360 / SMOKE_PTC_NUM;
	ColorTableSet(ptc.color,SmokePtcExpTable,null);
}

function SmokePtcExec(emt,ptc){
	ptc.spd = Vec2dScale(ptc.spd,0.8);

	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;

	ColorExecute(ptc.color);
}

function SmokePtcDel(emt,ptc){
	delete obj.color;
}

