/* -----------------------------------------------------------------------------
	p[eBNOʊ֐
	t@C  : snow_front_ptc.as
			: hakuhin (c) 2006/03/18
	
			: p[eBN֐
 ----------------------------------------------------------------------------- */

// J[e[u
SnowFrontPtcExpTable = [
	{	// 01t[ 
		time:	60,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,200)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{
		time:	-1,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{time: -1}
];

function PtcSnowFrontCreate(pos){
	var param = {depth : EffectDepthGet(),pos : pos};
	var order = {
		target	 : _root.front_rayer3,
		depth    : param.depth.depth,	// p[eBN[x
		res      : "snow_ptc_l",		// \[X
		emt_init : SnowFrontEmtInit,	// G~b^֐
		emt_exec : SnowFrontEmtExec,	// G~b^ړ֐
		emt_del  : SnowFrontEmtDel,		// G~b^j֐
		ptc_init : SnowFrontPtcInit,	// p[eBN֐
		ptc_exec : SnowFrontPtcExec,	// p[eBNړ֐
		ptc_del  : SnowFrontPtcDel,		// p[eBNj֐
		gen_num  : 1,					// 
		gen_time : 4,					// Ԋu
		emt_time : 0x7FFFFFFF,			// G~b^I
		kill_time: 15,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(STAGE_TASK,LEVEL_STAGE,order);
	
	var i;
	for(i=0;i<60;i++){
		ParticleTaskExec(id.obj);
	}
}

function SnowFrontEmtInit(obj,emt){
}

function SnowFrontEmtExec(obj,emt){
}

function SnowFrontEmtDel(obj,emt){
	EffectDepthPurge(obj.param.depth);
}
function SnowFrontPtcInit(emt,ptc){
	ptc.time = 60;
	ptc.blendMode = "add";
	ptc.pos = { x : Math.random() * SCREEN_WIDTH + 100 , y : - 5};
	ptc.spd = Vec2dCreate(Math.random() - 3, Math.random() * 2 + 2);
	ptc._xscale = ptc._yscale = Math.random() * 20 + 50;
	ptc.color = ColorCreate(ptc);
	ColorTableSet(ptc.color,SnowFrontPtcExpTable,null);
}

function SnowFrontPtcExec(emt,ptc){
	ptc.spd.x += RandomSign() * Math.random() * 0.3;
	ptc.spd.y += Math.random() * 0.1;
	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;
	ColorExecute(ptc.color);
}

function SnowFrontPtcDel(emt,ptc){
}
