/* -----------------------------------------------------------------------------
	p[eBNOʊ֐
	t@C  : snow_front_ptc.as
			: hakuhin (c) 2006/03/18
	
			: p[eBN֐
 ----------------------------------------------------------------------------- */

// J[e[u
SnowTitlePtcExpTable = [
	{	// 01t[ 
		time:	90,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,255)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{
		time:	-1,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{time: -1}
];

function PtcSnowTitleCreate(pos,task){
	var param = {depth : 5,pos : pos};
	var order = {
		target	 : _root,
		depth    : 5,	// p[eBN[x
		res      : "snow_ptc_s",		// \[X
		emt_init : null,				// G~b^֐
		emt_exec : null,				// G~b^ړ֐
		emt_del  : null,				// G~b^j֐
		ptc_init : SnowTitlePtcInit,	// p[eBN֐
		ptc_exec : SnowTitlePtcExec,	// p[eBNړ֐
		ptc_del  : SnowTitlePtcDel,		// p[eBNj֐
		gen_num  : 1,					// 
		gen_time : 2,					// Ԋu
		emt_time : 0x7FFFFFFF,			// G~b^I
		kill_time: 15,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(task,LEVEL_STAGE,order);
	id.level = LEVEL_FADE;
	
	var i;
	for(i=0;i<60;i++){
		ParticleTaskExec(id.obj);
	}
}

function SnowTitlePtcInit(emt,ptc){
	ptc.time = 90;
	ptc.blendMode = "add";
	ptc.pos = { x : Math.random() * SCREEN_WIDTH , y : - 5};
	ptc.spd = Vec2dCreate(RandomSign() * Math.random() * 0.5, Math.random() * 1 + 1);
	ptc._xscale = ptc._yscale = Math.random() * 100 + 50;
	ptc.color = ColorCreate(ptc);
	ColorTableSet(ptc.color,SnowTitlePtcExpTable,null);
}

function SnowTitlePtcExec(emt,ptc){
	ptc.spd.x += RandomSign() * Math.random() * 0.1;
	ptc.spd.y += Math.random() * 0.05;
	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;
	ColorExecute(ptc.color);
}

function SnowTitlePtcDel(emt,ptc){
}
