/* -----------------------------------------------------------------------------
	X^[p[eBN֐
	t@C  : exprosion.as
			: hakuhin (c) 2006/03/18
	
			: X^[p[eBN֐
 ----------------------------------------------------------------------------- */

// J[e[u
StarPtcExpTable = [
	{	// 01t[ 
		time:	15,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,255)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{time: -1}
];

function PtcStarCreate(pos,task){
	var param = {depth : EffectDepthGet(),pos : pos};
	var order = {
		target	 : _root.sprite,
		depth    : param.depth.depth,	// p[eBN[x
		res      : "star_ptc_s",		// \[X
		emt_init : StarEmtInit,			// G~b^֐
		emt_exec : StarEmtExec,			// G~b^ړ֐
		emt_del  : StarEmtDel,			// G~b^j֐
		ptc_init : StarPtcInit,			// p[eBN֐
		ptc_exec : StarPtcExec,			// p[eBNړ֐
		ptc_del  : StarPtcDel,			// p[eBNj֐
		gen_num  : 2,					// 
		gen_time : 1,					// Ԋu
		emt_time : 0x7FFFFFFF,			// G~b^I
		kill_time: 15,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(task,LEVEL_PLAYER,order);
}

function StarEmtInit(obj,emt){
}

function StarEmtExec(obj,emt){
}

function StarEmtDel(obj,emt){
	EffectDepthPurge(obj.param.depth);
}
function StarPtcInit(emt,ptc){
	ptc.time = 15;
	ptc.blendMode = "add";

	switch(PLAYER_TASK.obj.size_type){
	case PLAYER_SIZE_SMALL:
		ptc.pos = Vec2dAdd(PLAYER_TASK.obj.pos,Vec2dRandom(Math.random() * 10));
		ptc.pos.y -= 10;		
		break;
	case PLAYER_SIZE_LARGE:
		ptc.pos = Vec2dAdd(PLAYER_TASK.obj.pos,Vec2dRandom(Math.random() * 20));
		ptc.pos.y -= 20;
		break;
	}
	ptc.spd = Vec2dCreate(0,-0.5);
	ptc.spd.y = Math.abs(ptc.spd.y) * -1;
	ptc.color = ColorCreate(ptc);
	ColorTableSet(ptc.color,StarPtcExpTable,null);
	ptc._rotation = Math.random() * 360;
}

function StarPtcExec(emt,ptc){
	ptc.spd.y *= 1.05;
	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;

	ColorExecute(ptc.color);
}

function StarPtcDel(emt,ptc){
	delete obj.color;
}
