/* -----------------------------------------------------------------------------
	^C֐
	t@C  : tarai.as
			: hakuhin (c) 2006/12/23
	
			: ^Cp֐
 ----------------------------------------------------------------------------- */

TARAI_G = 0.1;

TaraiCollisionRect = {
		x : -20,
		y : -10,
		w :  40,
		h :  20
	};


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function TaraiTaskCreate(task,param){
	return TaskCreate(
		TaraiInitalize,
		TaraiExecute,
		TaraiDelete,
		task,PRIO_STAGE,LEVEL_ANIM,param
	);
}


function TaraiInitalize(obj,task,param){
	obj.task = task;
	obj.depth = EnemyDepthGet();
    obj.mc = _root.sprite.attachMovie("tarai","_" + obj.depth.depth, obj.depth.depth);
	obj.pos = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.id = param.id;

	obj.exec = TaraiFallInit;
	TaraiExecute(obj);
}


function TaraiExecute(obj){
	obj.exec(obj);	// s

	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
}


function TaraiFallInit(obj){
	obj.count = 0;
	obj.step = 0;

	obj.exec = TaraiFallExec;
	TaraiFallExec(obj);
}



function TaraiFallExec(obj){
	obj.spd.y += TARAI_G;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	
	TaraiHitCheck(obj);
}

function TaraiHitWaitInit(obj){
	obj.count = 0;
	
	obj.spd.x = 0;
	obj.spd.y = 0;

	obj.exec = TaraiHitWaitExec;
	TaraiHitWaitExec(obj);
}



function TaraiHitWaitExec(obj){
	if( ++ obj.count > 30) {
		obj.exec = TaraiBlowInit;
	}
}

function TaraiBlowInit(obj){
	obj.count = 0;
	obj.spd.y = -2;
	obj.spd.x = Math.random() * 2 - 1;
	
	obj.exec = TaraiBlowExec;
	TaraiBlowExec(obj);
}



function TaraiBlowExec(obj){
	obj.spd.y += TARAI_G;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
}




function TaraiDelete(obj){
	EnemyDepthPurge(obj.depth);

	obj.mc.removeMovieClip();
}


// ubNpAbp[U
function TaraiHitCheck(obj){
	var pos = obj.pos;
	var rect = TaraiCollisionRect

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_BOSS].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 <= l2){
		}else if(r2 <= l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			SePlay(SE_TARAI,obj.pos);
			data.func(data.param,HITTEST_TYPE_TARAI,obj.pos);
			TaraiHitWaitInit(obj);
			return;
		}

//		data = data.post;
		data = list;
	}
}