/* -----------------------------------------------------------------------------
	MatrixNXvZp֐
	t@C	:	matrix.as
	as.Ver		:	Flash 5 ȍ~
			:	Hakuhin	(C)	2006/04/24
 ----------------------------------------------------------------------------- */

/* -----------------------------------------------------------------------------

	--------------------------------------
	}gbNX̌^
	--------------------------------------
	matrix = {
		a  : 0 , b  : 0,
		c  : 0 , d  : 0,
		tx : 0 , ty : 0,
	];
	--------------------------------------
	
	MatrixNXƓ`ōsvZĂ܂B


	// sp֐ -------------------------------------------------------
	function Mtx33Create();					// Pʍs쐬
	function Mtx33Clone (m);				// s񕡐
	function Mtx33GetPos(m);				// W擾

	// sړs -----------------------------------------------------
	function Mtx33Translate(x,y);			// ss쐬
	function Mtx33TranslatePref(x,y,m);		// ss * ws
	function Mtx33TranslatePost(x,y,m);		// ws * ss

	// ]s -----------------------------------------------------
	function Mtx33Rotate(rot);				// ]s쐬
	function Mtx33RotatePref(rot,m);		// ]s * ws
	function Mtx33RotatePost(rot,m);		// ws * ]s

	// gks -----------------------------------------------------
	function Mtx33Scale(x,y);				// gks쐬
	function Mtx33ScalePref(x,y,m);			// gks * ws
	function Mtx33ScalePost(x,y,m);			// ws * gks

	// ˉeϊ ---------------------------------------------------------
	function Vec2dTransformPoint (x,y,m); 	// _̎ˉe
	function Vec2dTransformVector (x,y,m);	// xNg̎ˉe
	function Mtx33Transform  (m,m);			// s̎ˉe(s * s)

	// ts ---------------------------------------------------------
	function Mtx33InvertOrthoNormal (m); 	// t}gbNXvZ(Ksp)
	function Mtx33Invert (m);				// t}gbNXvZ

	.Mtx33Transform() ͌vZʂ̂
	*Pref *Post ֐ŌvZłƂ͂D悵Ďgp邱
 ----------------------------------------------------------------------------- */


/* ------------------------------------------------------------------- 
	}gbNX쐬
		Ȃ
	Ԃl	Pʍs

	(gp)
	var Mtx33 = _root.Mtx33Create();
 ------------------------------------------------------------------- */
function Mtx33Create(){
	return {
		a : 1,		b : 0,
		c : 0,		d : 1,
		tx: 0,		ty: 0
	};
}


/* ------------------------------------------------------------------- 
	}gbNX
		s
	Ԃl	̍s

	(gp)
	var matrix1 = _root.Mtx33Create();
	var matrix2 = _root.Mtx33Clone(matrix1);
 ------------------------------------------------------------------- */
function Mtx33Clone(m){

	return {
		a : m.a,		b : m.b,
		c : m.c,		d : m.d,
		tx: m.tx,		ty: m.ty
	};

}


/* ------------------------------------------------------------------- 
	W擾
		擾s
	Ԃl	WxNgiIuWFNgj

	(gp)
	matrix = _root.Mtx33Create();
	var vec = _root.Mtx33GetPos(matrix);
 ------------------------------------------------------------------- */
function Mtx33GetPos(m){
	return {
		x :	m.tx,
		y :	m.ty
	};
}


/* ------------------------------------------------------------------- 
	ss쐬
	01	x W
	02	y W
	Ԃl		ss

	(gp)
	var matrix = _root.Mtx33Translate(20,30);
 ------------------------------------------------------------------- */
function Mtx33Translate(x,y){
	return {
		a : 1,		b : 0,
		c : 0,		d : 1,
		tx: x,		ty: y
	};
}


/* ------------------------------------------------------------------- 
	sړsvZ(ss * ws)
	01	x W
	02	y W
	03	z W
	04	ws
	Ԃl		vZ̍s

	(gp)
	var matrix1 = _root.Mtx33Create();
	var matrix2 = _root.Mtx33TranslatePref(20,30,matrix1);
 ------------------------------------------------------------------- */
function Mtx33TranslatePref(x,y,m2){

	return {
		a : m2.a,
		b : m2.b,
		c : m2.c,
		d : m2.d,
		tx: x * m2.a + y * m2.c + m2.tx,
		ty: x * m2.b + y * m2.d + m2.ty
	};

}


/* ------------------------------------------------------------------- 
	sړsvZ(ws * ss)
	01	x W
	02	y W
	03	z W
	04	ws
	Ԃl		vZ̍s

	(gp)
	var matrix1 = _root.Mtx33Create();
	var matrix2 = _root.Mtx33TranslatePost(20,30,matrix1);
 ------------------------------------------------------------------- */
function Mtx33TranslatePost(x,y,m1){

	return {
		a : m1.a,
		b : m1.b,
		c : m1.c,
		d : m1.d,
		tx: m1.tx + x,
		ty: m1.ty + y
	};

}


/* ------------------------------------------------------------------- 
	]s쐬
		px
	Ԃl	]s

	(gp)
	var matrix = _root.Mtx33Rotate(30);
 ------------------------------------------------------------------- */
function Mtx33Rotate(rot){
	
	var rad = rot * Math.PI / 180;
	var cos = Math.cos(rad);
	var sin = Math.sin(rad);

	return {
		a : cos,	b : sin,
		c : -sin,	d : cos,
		tx: 0,		ty: 0
	};

}


/* ------------------------------------------------------------------- 
	]svZ(]s * ws)
	01	px
	02	ws
	Ԃl		vZ̍s

	(gp)
	var matrix1 = _root.Mtx33Translate(10,20,30);
	var matrix2 = _root.Mtx33RotatePref(30,matrix1);
 ------------------------------------------------------------------- */
function Mtx33RotatePref(rot,m2){
	
	var rad = rot * Math.PI / 180;
	var cos = Math.cos(rad);
	var sin = Math.sin(rad);
	
	return {
		a : cos * m2.a + sin * m2.c,
		b : cos * m2.b + sin * m2.d,
		c : -sin * m2.a + cos * m2.c,
		d : -sin * m2.b + cos * m2.d,
		tx: m2.tx,
		ty: m2.ty
	};

}


/* ------------------------------------------------------------------- 
	]svZ(ws * ]s)
	01	px
	02	ws
	Ԃl		vZ̍s

	(gp)
	var matrix1 = _root.Mtx33Translate(10,20,30);
	var matrix2 = _root.Mtx33RotatePost(30,matrix1);
 ------------------------------------------------------------------- */
function Mtx33RotatePost(rot,m1){
	
	var rad = rot * Math.PI / 180;
	var cos = Math.cos(rad);
	var sin = Math.sin(rad);

	return {
		a : m1.a * cos + m1.b * -sin,
		b : m1.a * sin + m1.b *  cos,
		c : m1.c * cos + m1.d * -sin,
		d : m1.c * sin + m1.d *  cos,
		tx: m1.tx * cos + m1.ty * -sin,
		ty: m1.tx * sin + m1.ty *  cos
	};
}


/* ------------------------------------------------------------------- 
	gks쐬
	01	x 
	02	y 
	Ԃl		gks

	(gp)
	var matrix1 = _root.Mtx33Scale(1,2);
 ------------------------------------------------------------------- */
function Mtx33Scale(x,y){

	return {
		a : x,	b : 0,
		c : 0,	d : y,
		tx: 0,	ty: 0
	};
}


/* ------------------------------------------------------------------- 
	gksvZ(gks * ws)
	01	x 
	02	y 
	03	z 
	04	ws
	Ԃl		vZ̍s

	(gp)
	var matrix1 = _root.Mtx33Translate(10,20);
	var matrix2 = _root.Mtx33ScalePref(1,2,matrix1);
 ------------------------------------------------------------------- */
function Mtx33ScalePref(x,y,m2){

	return {
		a : x * m2.a,
		b : x * m2.b,
		c : y * m2.c,
		d : y * m2.d,
		tx: m2.tx,
		ty: m2.ty
	};

}


/* ------------------------------------------------------------------- 
	gksvZ(ws * gks)
	01	x 
	02	y 
	03	z 
	04	ws
	Ԃl		vZ̍s

	(gp)
	var matrix1 = _root.Mtx33Translate(10,20);
	var matrix2 = _root.Mtx33ScalePost(1,2,matrix1);
 ------------------------------------------------------------------- */
function Mtx33ScalePost(x,y,m1){

	return {
		a : m1.a * x,
		b : m1.b * y,
		c : m1.c * x,
		d : m1.d * y,
		tx: m1.tx * x,
		ty: m1.ty * y
	};

}


/* ------------------------------------------------------------------- 
	_̎ˉeϊ
	01	xW
	02	yW
	03	zW
	04	ws
	Ԃl		ϊ̍WxNgiIuWFNgj
 ------------------------------------------------------------------- */
function Vec2dTransformPoint(x,y,m){

	return {
		x :	x * m.a + y * m.c + m.tx,
		y :	x * m.b + y * m.d + m.ty
	};

}


/* ------------------------------------------------------------------- 
	xNg̎ˉeϊ
	01	x 
	02	y 
	03	z 
	04	ws
	Ԃl		ϊ̃xNgiIuWFNgj
 ------------------------------------------------------------------- */
function Vec2dTransformVector (x,y,m2){

	return {
		x : x * m2.a + y * m2.c,
		y : x * m2.b + y * m2.d
	};
};


/* ------------------------------------------------------------------- 
	}gbNXm̌vZ
	01	Pڂ̍s
	02	Qڂ̍s
	Ԃl		vZ̍s
 ------------------------------------------------------------------- */
function Mtx33Transform  (m1,m2){

	return {
		a : m1.a * m2.a + m1.b * m2.c,
		b : m1.a * m2.b + m1.b * m2.d,
		c : m1.c * m2.a + m1.d * m2.c,
		d : m1.c * m2.b + m1.d * m2.d,
		tx: m1.tx * m2.a + m1.ty * m2.c + m2.tx,
		ty: m1.tx * m2.b + m1.ty * m2.d + m2.ty
	};

};


/* ------------------------------------------------------------------- 
	t}gbNXvZ(Ksp)
	01	sizj
	Ԃl		vZ̍sizj
 ------------------------------------------------------------------- */
function Mtx33InvertOrthoNormal (m){

	return {
		a : m.a,
		b : m.c,
		c : m.b,
		d : m.d,
		tx: -m.tx * m.a + -m.ty * m.b,
		ty: -m.tx * m.c + -m.ty * m.d
	};

}


/* ------------------------------------------------------------------- 
	t}gbNXvZ
	01	sizj
	Ԃl		vZ̍sizj
 ------------------------------------------------------------------- */
function Mtx33Invert (m2){
	var i,j,k,l;
	var m1 = {
		a : 0, b : 0,
		c : 0, d : 0,
		tx: 0, ty: 0
	};

	for(l=0;l<2;l++){
		var a = [
			[ m2.a ,m2.b ,0.0 ,0.0 ],
			[ m2.c ,m2.d ,0.0 ,0.0 ],
			[ m2.tx,m2.ty,1.0 ,0.0 ]
		];
		a[l][3] = 1.0;
		
		for(i=0;i<3;i++){
			if(a[i][i] != 0.0){
				for(j=3;j>=i;j--){
					a[i][j] /= a[i][i];
				}
			}			
			for(j=i+1;j<3;j++){
				for(k=i+1;k<4;k++){
					a[j][k] -= a[j][i] * a[i][k];
				}
			}
		}

		for(i=2;i>0;i--){
			for(j=i-1;j>=0;j--){
				a[j][i] *= a[i][3];
				a[j][3] -= a[j][i];
			}
		}
		
		if(l == 0){
			m1.a  = a[0][3];
			m1.c  = a[1][3];
			m1.tx = a[2][3];
		}else if(l == 1){
			m1.b  = a[0][3];
			m1.d  = a[1][3];
			m1.ty = a[2][3];
		}
	}
	
	return m1;
}