/* -----------------------------------------------------------------------------
	ubNtF[h֐
	t@C  : black_fade.as
			: hakuhin (c) 2006/12/21
	
			: ubNtF[h\
 ----------------------------------------------------------------------------- */


BLACK_FADE_TIME = 30;

/* --------------------------------
	^XN
 -------------------------------- */
function BlackFadeInCreate(task,param){
	return TaskCreate(
		BlackFadeInInitalize,
		BlackFadeInExecute,
		BlackFadeInDelete,
		task,PRIO_SCROLL,LEVEL_FADE,param
	);
}


// ʏ
function BlackFadeInInitalize(obj,task,param){
	obj.level = TaskWork.level;
	TaskWork.level = LEVEL_FADE;
	// `pMC
	obj.mc = _root.attachMovie("back6" ,"_" + DEPTH_FADE , DEPTH_FADE);

	obj.mc._alpha = 100;

	obj.task = task;
	obj.count = 0;
	
	obj.func = param.func;
	obj.param = param.param;
}


// ʏ
function BlackFadeInExecute(obj){
	var d = 1 - obj.count / BLACK_FADE_TIME;

	obj.mc._alpha = d * 100;

	if(++ obj.count > BLACK_FADE_TIME){
		TaskDelete(obj.task);
		return;
	}
}

function BlackFadeInDelete(obj){
	TaskWork.level = obj.level;
	obj.mc.removeMovieClip();
	obj.func(obj.param);
}





/* --------------------------------
	^XN
 -------------------------------- */
function BlackFadeOutCreate(task,param){
	return TaskCreate(
		BlackFadeOutInitalize,
		BlackFadeOutExecute,
		BlackFadeOutDelete,
		task,PRIO_SCROLL,LEVEL_FADE,param
	);
}


// ʏ
function BlackFadeOutInitalize(obj,task,param){
	obj.level = TaskWork.level;
	TaskWork.level = LEVEL_FADE;
	// `pMC
	obj.mc = _root.attachMovie("back6" ,"_" + DEPTH_FADE , DEPTH_FADE);
	obj.mc._alpha = 0;

	obj.task = task;
	obj.count = 0;
	
	obj.func = param.func;
	obj.param = param.param;
}


// ʏ
function BlackFadeOutExecute(obj){

	var d = obj.count / BLACK_FADE_TIME;
	
	obj.mc._alpha = d * 100;


	if(++ obj.count > BLACK_FADE_TIME){
		TaskDelete(obj.task);
		return;
	}
}

function BlackFadeOutDelete(obj){
	TaskWork.level = obj.level;
	obj.mc.removeMovieClip();
	obj.func(obj.param);
}
