/* -----------------------------------------------------------------------------
	u[tF[h֐
	t@C  : blur_fade.as
			: hakuhin (c) 2006/12/21
	
			: u[tF[h
 ----------------------------------------------------------------------------- */


BLUR_FADE_TIME = 15;

/* --------------------------------
	^XN
 -------------------------------- */
function BlurFadeInCreate(task,param){
	return TaskCreate(
		BlurFadeInInitalize,
		BlurFadeInExecute,
		BlurFadeInDelete,
		task,PRIO_SCROLL,LEVEL_FADE,param
	);
}


// ʏ
function BlurFadeInInitalize(obj,task,param){
	obj.level = TaskWork.level;
	TaskWork.level = LEVEL_FADE;
	// `pMC
	obj.mc = _root.createEmptyMovieClip("fade" ,DEPTH_FADE);

	obj.task = task;
	obj.count = 0;
	
	obj.func = param.func;
	obj.param = param.param;
}


// ʏ
function BlurFadeInExecute(obj){

	if(obj.mc)		obj.mc.removeMovieClip();
	obj.mc = _root.createEmptyMovieClip("fade" ,DEPTH_FADE);

	var d = 1 - obj.count / BLUR_FADE_TIME;
//	d = d * d;

	var size = Math.floor(d * 64 + 0.5) + 8;

	// rbg}bvRs[
    var bmpData = new flash.display.BitmapData(SCREEN_WIDTH, SCREEN_HEIGHT, true);
    var m = new flash.geom.Matrix(1,0,0,1,0,0);
    var color = new flash.geom.ColorTransform(1, 1, 1, 1, 0, 0, 0, 0);
    var rect = new flash.geom.Rectangle(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	bmpData.draw(_root, m, color, "normal", rect, true);
	obj.mc.attachBitmap(bmpData, 0, "auto", true);



	var param = new flash.filters.BlurFilter();

	param.blurX = d * 100;	// ̂ڂ
	param.blurY = d * 10;	// ̂ڂ
	param.quality = 2;	// ڂ̎s
	obj.mc.filters = new Array(param);


	if(++ obj.count > BLUR_FADE_TIME){
		TaskDelete(obj.task);
		return;
	}
}

function BlurFadeInDelete(obj){
	TaskWork.level = obj.level;
	obj.mc.removeMovieClip();
	obj.func(obj.param);
}





/* --------------------------------
	^XN
 -------------------------------- */
function BlurFadeOutCreate(task,param){
	return TaskCreate(
		BlurFadeOutInitalize,
		BlurFadeOutExecute,
		BlurFadeOutDelete,
		task,PRIO_SCROLL,LEVEL_FADE,param
	);
}


// ʏ
function BlurFadeOutInitalize(obj,task,param){
	obj.level = TaskWork.level;
	TaskWork.level = LEVEL_FADE;
	// `pMC
	obj.mc = _root.createEmptyMovieClip("fade" ,DEPTH_FADE);

	obj.task = task;
	obj.count = 0;
	
	obj.func = param.func;
	obj.param = param.param;
}


// ʏ
function BlurFadeOutExecute(obj){

	if(obj.mc)		obj.mc.removeMovieClip();
	obj.mc = _root.createEmptyMovieClip("fade" ,DEPTH_FADE);

	var d = obj.count / BLUR_FADE_TIME;
//	d = d * d;

	var size = Math.floor(d * 64 + 0.5) + 8;

	// rbg}bvRs[
    var bmpData = new flash.display.BitmapData(SCREEN_WIDTH, SCREEN_HEIGHT, true);
    var m = new flash.geom.Matrix(1,0,0,1,0,0);
    var color = new flash.geom.ColorTransform(1, 1, 1, 1, 0, 0, 0, 0);
    var rect = new flash.geom.Rectangle(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	bmpData.draw(_root, m, color, "normal", rect, true);
	obj.mc.attachBitmap(bmpData, 0, "auto", true);



	var param = new flash.filters.BlurFilter();

	param.blurX = d * 100;	// ̂ڂ
	param.blurY = d * 10;	// ̂ڂ
	param.quality = 2;	// ڂ̎s
	obj.mc.filters = new Array(param);


	if(++ obj.count > BLUR_FADE_TIME){
		TaskDelete(obj.task);
		return;
	}
}

function BlurFadeOutDelete(obj){
	TaskWork.level = obj.level;
	obj.mc.removeMovieClip();
	obj.func(obj.param);
}
