/* -----------------------------------------------------------------------------
	UCNtF[h֐
	t@C  : mosaic_fade.as
			: hakuhin (c) 2006/12/04
	
			: UCNGtFNg
 ----------------------------------------------------------------------------- */


MOSAIC_FADE_TIME = 25;

/* --------------------------------
	^XN
 -------------------------------- */
function MosaicFadeInCreate(task,param){
	return TaskCreate(
		MosaicFadeInInitalize,
		MosaicFadeInExecute,
		MosaicFadeInDelete,
		task,PRIO_SCROLL,LEVEL_FADE,param
	);
}


// ʏ
function MosaicFadeInInitalize(obj,task,param){
	obj.level = TaskWork.level;
	TaskWork.level = LEVEL_FADE;
	// `pMC
	obj.mc = _root.createEmptyMovieClip("fade" ,DEPTH_FADE);

	obj.task = task;
	obj.count = 0;
	
	obj.func = param.func;
	obj.param = param.param;
}


// ʏ
function MosaicFadeInExecute(obj){

	// N[Abv
	obj.mc.clear();
//	obj.mc.lineStyle (0, 0, 0);

	var d = 1 - obj.count / MOSAIC_FADE_TIME;
	var size = Math.floor(d * 64 + 0.5) + 8;

	// rbg}bvRs[
    var bmpData = new flash.display.BitmapData(SCREEN_WIDTH, SCREEN_HEIGHT, true);
    var m = new flash.geom.Matrix(1,0,0,1,0,0);
    var color = new flash.geom.ColorTransform((1-d), (1-d), (1-d), 1, 0, 0, 0, 0);
    var rect = new flash.geom.Rectangle(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	bmpData.draw(_root, m, color, "normal", rect, true);



	
	var w_half = SCREEN_WIDTH_HALF;
	var h_half = SCREEN_HEIGHT_HALF;
	var s_half = size / 2;
	
	if(s_half > h_half)	var num_y = 1;
	else				var num_y = Math.ceil((h_half - s_half) / size) * 2 + 1;
	if(s_half > w_half)	var num_x = 1;
	else				var num_x = Math.ceil((w_half - s_half) / size) * 2 + 1;
	
	var pos_x = -(num_x * size - SCREEN_WIDTH) / 2;
	var pos_y = -(num_y * size - SCREEN_HEIGHT) / 2;
	



	var i,j;
	var y = pos_y;
	for(j=0;j<num_y;j++){
		var x = pos_x;
		for(i=0;i<num_x;i++){
			// YsNZ擾
			obj.mc.beginFill (bmpData.getPixel32((x < 0 ? 0 : x),(y < 0 ? 0 : y)), 100);
			obj.mc.moveTo ( x        , y        );
			obj.mc.lineTo ( x + size , y        );
			obj.mc.lineTo ( x + size , y + size );
			obj.mc.lineTo ( x        , y + size );
			obj.mc.endFill();
			
			x += size;
		}
		y += size;
	}


	if(++ obj.count > MOSAIC_FADE_TIME){
		TaskDelete(obj.task);
		return;
	}
}

function MosaicFadeInDelete(obj){
	TaskWork.level = obj.level;
	obj.mc.removeMovieClip();
	obj.func(obj.param);
}





/* --------------------------------
	^XN
 -------------------------------- */
function MosaicFadeOutCreate(task,param){
	return TaskCreate(
		MosaicFadeOutInitalize,
		MosaicFadeOutExecute,
		MosaicFadeOutDelete,
		task,PRIO_SCROLL,LEVEL_FADE,param
	);
}


// ʏ
function MosaicFadeOutInitalize(obj,task,param){
	obj.level = TaskWork.level;
	TaskWork.level = LEVEL_FADE;
	// `pMC
	obj.mc = _root.createEmptyMovieClip("fade" ,DEPTH_FADE);

	obj.task = task;
	obj.count = 0;
	
	obj.func = param.func;
	obj.param = param.param;
}


// ʏ
function MosaicFadeOutExecute(obj){

	// N[Abv
	obj.mc.clear();
//	obj.mc.lineStyle (0, 0, 0);

	var d = obj.count / MOSAIC_FADE_TIME;
	var size = Math.floor(d * 64 + 0.5) + 8;

	// rbg}bvRs[
    var bmpData = new flash.display.BitmapData(SCREEN_WIDTH, SCREEN_HEIGHT, true);
    var m = new flash.geom.Matrix(1,0,0,1,0,0);
    var color = new flash.geom.ColorTransform((1-d), (1-d), (1-d), 1, 0, 0, 0, 0);
	var rect = new flash.geom.Rectangle(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	bmpData.draw(_root, m, color, "normal", rect, true);



	
	var w_half = SCREEN_WIDTH_HALF;
	var h_half = SCREEN_HEIGHT_HALF;
	var s_half = size / 2;
	
	if(s_half > h_half)	var num_y = 1;
	else				var num_y = Math.ceil((h_half - s_half) / size) * 2 + 1;
	if(s_half > w_half)	var num_x = 1;
	else				var num_x = Math.ceil((w_half - s_half) / size) * 2 + 1;
	
	var pos_x = -(num_x * size - SCREEN_WIDTH) / 2;
	var pos_y = -(num_y * size - SCREEN_HEIGHT) / 2;
	



	var i,j;
	var y = pos_y;
	for(j=0;j<num_y;j++){
		var x = pos_x;
		for(i=0;i<num_x;i++){
			// YsNZ擾
			obj.mc.beginFill (bmpData.getPixel32((x < 0 ? 0 : x),(y < 0 ? 0 : y)), 100);
			obj.mc.moveTo ( x        , y        );
			obj.mc.lineTo ( x + size , y        );
			obj.mc.lineTo ( x + size , y + size );
			obj.mc.lineTo ( x        , y + size );
			obj.mc.endFill();
			
			x += size;
		}
		y += size;
	}


	if(++ obj.count > MOSAIC_FADE_TIME){
		TaskDelete(obj.task);
		return;
	}
}

function MosaicFadeOutDelete(obj){
	TaskWork.level = obj.level;
	obj.mc.removeMovieClip();
	obj.func(obj.param);
}
