/* -----------------------------------------------------------------------------
	l[Gg[\֐
	t@C  : name_entry.as
			: hakuhin (c) 2006/12/10
	
			: l[Gg[\
 ----------------------------------------------------------------------------- */

// J[e[u
NameEntryTable = [
	{	// 01t[ 
		time:	5,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,196)
	},{
		time:	 2,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,32)
	},{time: -2}
];








/* --------------------------------
	^XN
 -------------------------------- */
function NameEntryCreate(task,param){
	return TaskCreate(
		NameEntryInitalize,
		NameEntryExecute,
		NameEntryDelete,
		task,PRIO_SCROLL,LEVEL_PAUSE,param
	);
}


// ʏ
function NameEntryInitalize(obj,task,param){
	KeyClear();

	obj.task = task;

	obj.back = new Array();
	obj.back[0] = _root.attachMovie("back3",  "b1",  0);
	obj.back[1] = _root.attachMovie("jam_illust",  "b2",  1);
	obj.back[1]._x = 40;
	obj.back[1]._y = 20;
	obj.back[2] = _root.attachMovie("name_entry",  "b3",  2);

	obj.mc = new Array();
	obj.mc[0] = ScoreClipCreate(PlayerStatus.score,10);
	obj.mc[1] = TimeClipCreate(PlayerStatus.play_time,20);
	obj.mc[0]._x = 220;
	obj.mc[0]._y = 119;
	obj.mc[1]._x = 220;
	obj.mc[1]._y = 159;
	obj.mc[2] = _root.attachMovie("font_name",  "_" + 30 , 30);
	obj.mc[2]._x = 220;
	obj.mc[2]._y = 199;

	obj.color = ColorCreate(obj.mc[2]);
	ColorTableSet(obj.color,NameEntryTable,null);

	obj.rot = 0;
	
	AnmCmdInit(obj.mc[2]);
	obj.mc[2].ANM_GOTO = "_0";
	AnmCmdPlay(obj.mc[2]);

	obj.name_num = 0;
	obj.name_type = 0;
	
	obj.name = new Array();
	
	BlurFadeInCreate(null,null);
	
	obj.exec = NameEntryNyokuInit;
}


// ʏ
function NameEntryExecute(obj){
	obj.exec(obj);
}


function NameEntryNyokuInit(obj){
	obj.exec = NameEntryNyokuExec;
	NameEntryNyokuExec(obj);
}

function NameEntryNyokuExec(obj){
	if(KeyData[0].Menu & KEY_LEFT){
		obj.name_type --;
		SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
	}
	if(KeyData[0].Menu & KEY_RIGHT){
		obj.name_type ++;
		SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
	}
	if(KeyData[0].Menu & KEY_DOWN){
		obj.name_type = 50;
		SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
	}
	
	if(obj.name_type <   0)	obj.name_type += 51;
	if(obj.name_type >= 51)	obj.name_type -= 51;
	
	
	if(obj.name_num >= 8)	obj.name_type = 50;
	
	if(KeyData[0].Trg & KEY_A){
		obj.name[obj.name_num] = obj.name_type;

		if(obj.name_type == 50){
			obj.exec = NameEntryEndInit;
			return;
		}

		obj.mc[3 + obj.name_num] = _root.attachMovie("font_name",  "_" + (100 + obj.name_num) , 100 + obj.name_num);
		obj.mc[3 + obj.name_num]._x = 220 + 20 * obj.name_num;
		obj.mc[3 + obj.name_num]._y = 199;
		AnmCmdInit(obj.mc[3 + obj.name_num]);
		obj.mc[3 + obj.name_num].ANM_GOTO = "_" + obj.name_type;
		AnmCmdPlay(obj.mc[3 + obj.name_num]);
		obj.name_num ++;
		SoundPlay(SE_JAM_GET,100,0,SOUND_PRIO_SE,false);
	}

	if(KeyData[0].Trg & KEY_B){
		if(obj.name_num > 0){
			obj.mc[3 + obj.name_num - 1].removeMovieClip();
			obj.name_num --;
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		}
	}
	
	
	ColorExecute(obj.color);
	
	obj.mc[2].ANM_GOTO = "_" + obj.name_type;
	AnmCmdPlay(obj.mc[2]);
	obj.mc[2]._x = 220 + 20 * obj.name_num;
}

function NameEntryEndInit(obj){
	obj.exec = NameEntryEndExec;

	SoundPlay(SE_POWERUP,100,0,SOUND_PRIO_SE,false);

	// 
	obj.mc[2].removeMovieClip();
	
	// ŃGg[n̏
	RankSetIn(PlayerStatus.score,PlayerStatus.play_time,obj.name);

	obj.count = 0;
	NameEntryEndExec(obj);
}

function NameEntryEndExec(obj){
	if(++ obj.count > 180){
		BlackFadeOutCreate(null , {func : NameEntryNextTitleFunc , param : obj});
		return;
	}
}

function NameEntryNextTitleFunc(obj){
	TaskDelete(obj.task);
	TitleCreate(null,0);
}


function NameEntryDelete(obj){

	var i;
	var num = obj.mc.length;
	for(i=0;i<num;i++){
		obj.mc[i].removeMovieClip();
	}
	
	num = obj.back.length;
	for(i=0;i<num;i++){
		obj.back[i].removeMovieClip();
	}
	
	LocalSave();	// ۑ
}


function ScoreClipCreate(score,depth){
	var j;
	var p_mc = _root.createEmptyMovieClip("score" + depth, depth);

	var str = new Array();
	str[0] = "_" + (Math.floor(score / 10000000) % 10 + 26);
	str[1] = "_" + (Math.floor(score /  1000000) % 10 + 26);
	str[2] = "_" + (Math.floor(score /   100000) % 10 + 26);
	str[3] = "_" + (Math.floor(score /    10000) % 10 + 26);
	str[4] = "_" + (Math.floor(score /     1000) % 10 + 26);
	str[5] = "_" + (Math.floor(score /      100) % 10 + 26);
	str[6] = "_" + (Math.floor(score /       10) % 10 + 26);
	str[7] = "_" + (Math.floor(score /        1) % 10 + 26);
	
	for(j=0;j<8;j++){
		var mc = p_mc.attachMovie("font_name",  "_" + j , j);
		mc._x =20 * j;
		AnmCmdInit(mc);
		mc.ANM_GOTO = str[j];
		AnmCmdPlay(mc);
	}

	return p_mc;
}


function TimeClipCreate(time,depth){
	var j;

	var p_mc = _root.createEmptyMovieClip("time" + depth, depth);

	
	var sec = time / 1000;
	var min = sec / 60;
	var hou = min / 60;
	sec = sec % 60;
	min = min % 60;
	hou = hou % 100;

	var str = new Array();
	str[0] = "_" + (Math.floor(hou / 10) + 26);
	str[1] = "_" + (Math.floor(hou % 10) + 26);
	str[2] = "_39";
	str[3] = "_" + (Math.floor(min / 10) + 26);
	str[4] = "_" + (Math.floor(min % 10) + 26);
	str[5] = "_39";
	str[6] = "_" + (Math.floor(sec / 10) + 26);
	str[7] = "_" + (Math.floor(sec % 10) + 26);
	
	for(j=0;j<8;j++){
		var mc = p_mc.attachMovie("font_name",  "_" + j, j);
		mc._x = 20 * j;
		AnmCmdInit(mc);
		mc.ANM_GOTO = str[j];
		AnmCmdPlay(mc);
	}

	return p_mc;
}