/* -----------------------------------------------------------------------------
	TEhj[֐
	t@C  : sound_menu.as
			: hakuhin (c) 2006/10/31
	
			: TEhj[\
 ----------------------------------------------------------------------------- */
SoundInfo = {

	bgm_vol : 7,
	se_vol : 7

};



SoundMenuTiyakiPos = [
[
	{x: 60.0 - 15	,y:88.0},
	{x:395.0 + 15	,y:88.0}
],[
	{x: 60.0 - 15	,y:138.0},
	{x:395.0 + 15	,y:138.0}
],[
	{x:193.0 - 35	,y:286.0},
	{x:258.0 + 35	,y:286.0}
]
];


/* --------------------------------
	^XN
 -------------------------------- */
function SoundMenuCreate(task,param){
	return TaskCreate(
		SoundMenuInitalize,
		SoundMenuExecute,
		SoundMenuDelete,
		task,PRIO_SCROLL,LEVEL_PAUSE,param
	);
}


// ʏ
function SoundMenuInitalize(obj,task,param){
	KeyClear();

	obj.y = param;
	obj.task = task;

	obj.back = new Array();
	obj.back[0] = _root.attachMovie("back3",  "b1",  0);
	obj.back[1] = _root.attachMovie("jam_illust",  "b2",  1);
	obj.back[1]._x = 40;
	obj.back[1]._y = 20;
	obj.back[2] = _root.attachMovie("menu_sound", "b3",  2);
	obj.mc = new Array();
	obj.mc[0] = _root.attachMovie("nayuki",  "m1",  10);
	obj.mc[1] = _root.attachMovie("akiko", 	 "m2",  11);
	obj.mc[0]._x = -20;
	obj.mc[1]._x = SCREEN_WIDTH + 20;
	obj.mc[0]._y = SoundMenuTiyakiPos[obj.y][0].y;
	obj.mc[1]._y = SoundMenuTiyakiPos[obj.y][1].y;
	AnmCmdInit(obj.mc[0]);
	AnmCmdInit(obj.mc[1]);

	obj.mc[1]._xscale = -100;
	PtcSnowTitleCreate({x:0,y:0},task);

	obj.rot = 0;
	
	obj.bgm_mc = new Array();
	var i;
	for(i=0;i<SoundInfo.bgm_vol;i++){
		obj.bgm_mc[i] = _root.attachMovie("volume_gauge",  "bgm" + i,  20 + i);
		obj.bgm_mc[i]._x = 284 + (10 * i);
		obj.bgm_mc[i]._y = 85;
		obj.bgm_mc[i]._yscale = (i + 1) / 10 * 50 + 50;
	}
	obj.se_mc = new Array();
	for(i=0;i<SoundInfo.se_vol;i++){
		obj.se_mc[i] = _root.attachMovie("volume_gauge",  "se" + i,  40 + i);
		obj.se_mc[i]._x = 284 + (10 * i);
		obj.se_mc[i]._y = 135;
		obj.se_mc[i]._yscale = (i + 1) / 10 * 50 + 50;
	}

	BlurFadeInCreate(null,null);
}


// ʏ
function SoundMenuExecute(obj){
	AnmCmdPlay(obj.mc[0]);
	AnmCmdPlay(obj.mc[1]);


	if(KeyData[0].Menu & KEY_UP){
		SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		obj.y --;
	}
	if(KeyData[0].Menu & KEY_DOWN){
		obj.y ++;
		SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
	}
	if(obj.y > 2)			obj.y -= 3;
	else if(obj.y < 0)		obj.y += 3;

	switch(obj.y){
	case 0:
		if(KeyData[0].Menu & KEY_LEFT){
			if(-- SoundInfo.bgm_vol < 0){
				SoundInfo.bgm_vol = 0;
			}else{
				SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
				obj.bgm_mc[SoundInfo.bgm_vol].removeMovieClip();
			}
			SoundWork.obj[0].so.setVolume(100 * (SoundInfo.bgm_vol / 10));
		}
		if(KeyData[0].Menu & KEY_RIGHT){
			if(++ SoundInfo.bgm_vol > 10){
				SoundInfo.bgm_vol = 10;
			}else{
				SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
				var vol = SoundInfo.bgm_vol - 1;
				obj.bgm_mc[vol] = _root.attachMovie("volume_gauge",  "bgm" + vol,  20 + vol);
				obj.bgm_mc[vol]._x = 284 + (10 * vol);
				obj.bgm_mc[vol]._y = 85;
				obj.bgm_mc[vol]._yscale = (vol + 1) / 10 * 50 + 50;
			}
			SoundWork.obj[0].so.setVolume(100 * (SoundInfo.bgm_vol / 10));
		}


		break;
	case 1:
		if(KeyData[0].Menu & KEY_LEFT){
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
			if(-- SoundInfo.se_vol < 0){
				SoundInfo.se_vol = 0;
			}else{
				obj.se_mc[SoundInfo.se_vol].removeMovieClip();
			}
		}
		if(KeyData[0].Menu & KEY_RIGHT){
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
			if(++ SoundInfo.se_vol > 10){
				SoundInfo.se_vol = 10;
			}else{
				var vol = SoundInfo.se_vol - 1;
				obj.se_mc[vol] = _root.attachMovie("volume_gauge",  "se" + vol,  40 + vol);
				obj.se_mc[vol]._x = 284 + (10 * vol);
				obj.se_mc[vol]._y = 135;
				obj.se_mc[vol]._yscale = (vol + 1) / 10 * 50 + 50;
			}
		}
		break;

	case 2:
		if(KeyData[0].Trg & KEY_A){
			KeyData[0].Trg &= ~KEY_A;
			BlurFadeOutCreate(null , {func : SoundBackOptionFunc , param : obj});
			SoundPlay(SE_MENU_OK,100,0,SOUND_PRIO_SE,false);

			return;
		}
		break;
	}


	obj.rot += 10;
	obj.mc[0]._x += (SoundMenuTiyakiPos[obj.y][0].x + Math.sin(obj.rot * Math.PI / 180) * 3 - obj.mc[0]._x) * 0.5;
	obj.mc[1]._x += (SoundMenuTiyakiPos[obj.y][1].x - Math.sin(obj.rot * Math.PI / 180) * 3 - obj.mc[1]._x) * 0.5;
	obj.mc[0]._y += (SoundMenuTiyakiPos[obj.y][0].y - obj.mc[0]._y) * 0.5;
	obj.mc[1]._y += (SoundMenuTiyakiPos[obj.y][1].y - obj.mc[1]._y) * 0.5;
}


function SoundMenuDelete(obj){
	var i;
	var num = obj.mc.length;
	for(i=0;i<num;i++){
		obj.mc[i].removeMovieClip();
	}
	
	num = obj.back.length;
	for(i=0;i<num;i++){
		obj.back[i].removeMovieClip();
	}
	
	num = obj.bgm_mc.length;
	for(i=0;i<num;i++){
		obj.bgm_mc[i].removeMovieClip();
	}
	
	num = obj.se_mc.length;
	for(i=0;i<num;i++){
		obj.se_mc[i].removeMovieClip();
	}
	
	LocalSave();	// ݒۑ
}

function SoundBackOptionFunc(obj){
	TaskDelete(obj.task);
	OptionCreate(obj.task,5);
}