/* -----------------------------------------------------------------------------
	Xe[WZNg֐
	t@C  : stage_select.as
			: hakuhin (c) 2006/12/28
	
			: Xe[WZNg\
 ----------------------------------------------------------------------------- */


StageSelectTable = [
	{world : 1 , stage : 1 , script : "Stage1_1_0Script"},
	{world : 1 , stage : 2 , script : "Stage1_2_0Script"},
	{world : 1 , stage : 3 , script : "Stage1_3_0Script"},
	{world : 2 , stage : 1 , script : "Stage2_1_0Script"},
	{world : 2 , stage : 2 , script : "Stage2_2_0Script"},
	{world : 2 , stage : 3 , script : "Stage2_3_0Script"},
	{world : 3 , stage : 1 , script : "Stage3_1_0Script"},
	{world : 3 , stage : 2 , script : "Stage3_2_0Script"},
	{world : 3 , stage : 3 , script : "Stage3_3_0Script"},
	{world : 4 , stage : 1 , script : "Stage4_1_0Script"},
	{world : 4 , stage : 2 , script : "Stage4_2_0Script"}
//	{world : 4 , stage : 2 , script : "Stage4_2_0Script"},
//	{world : 4 , stage : 3 , script : "Stage4_3_0Script"},

];

/* --------------------------------
	^XN
 -------------------------------- */
function StageSelectCreate(task,param){
	return TaskCreate(
		StageSelectInitalize,
		StageSelectExecute,
		StageSelectDelete,
		task,PRIO_SCROLL,LEVEL_PAUSE,param
	);
}


// ʏ
function StageSelectInitalize(obj,task,param){
	KeyClear();

	obj.y = param;
	obj.task = task;

	obj.back = new Array();
	obj.back[0] = _root.attachMovie("back6", 		"b1",  0);
	obj.back[1] = _root.attachMovie("title_nayuki",	"b2",  1);
	obj.back[2] = _root.attachMovie("title_akiko", 	"b3",  2);
	obj.back[3] = _root.attachMovie("stage_select", "b4",  6);
	obj.back[1]._alpha = 30;
	obj.back[2]._alpha = 30;
	obj.back[2]._x = -50;
	obj.back[1]._x = 200;

	obj.mc = new Array();
	obj.mc[0] = _root.attachMovie("font_name",  "m1",  10);
	obj.mc[1] = _root.attachMovie("font_name", 	 "m2", 11);
	AnmCmdInit(obj.mc[0]);
	AnmCmdInit(obj.mc[1]);
	obj.mc[0].ANM_GOTO = "_27";
	obj.mc[1].ANM_GOTO = "_27";
	AnmCmdPlay(obj.mc[0]);
	AnmCmdPlay(obj.mc[1]);

	obj.mc[0]._x = 176;
	obj.mc[0]._y = 164;
	obj.mc[1]._x = 256;
	obj.mc[1]._y = 164;
	
	obj.head = 0;
	
	BlurFadeInCreate(null,null);
}


// ʏ
function StageSelectExecute(obj){


	if(KeyData[0].Menu & KEY_LEFT){
		SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		obj.head -= 1;
	}
	if(KeyData[0].Menu & KEY_RIGHT){
		SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		obj.head += 1;
	}
	
	var len = StageSelectTable.length;
	if(obj.head < 0)	obj.head += len;
	if(obj.head >= len)	obj.head -= len;

	if(KeyData[0].Trg & KEY_A){
		SoundPlay(SE_MENU_OK,100,0,SOUND_PRIO_SE,false);
		BlackFadeOutCreate(null , {func : StageSelectNextMainGameFunc , param : obj});
		return;
	}
	
	obj.mc[0].ANM_GOTO = "_" + (26 + StageSelectTable[obj.head].world);
	obj.mc[1].ANM_GOTO = "_" + (26 + StageSelectTable[obj.head].stage);
	AnmCmdPlay(obj.mc[0]);
	AnmCmdPlay(obj.mc[1]);

}

function StageSelectDelete(obj){
	var i;
	var num = obj.mc.length;
	for(i=0;i<num;i++){
		obj.mc[i].removeMovieClip();
	}
	
	num = obj.back.length;
	for(i=0;i<num;i++){
		obj.back[i].removeMovieClip();
	}
}



function NextKeyConfigFunc(obj){
	TaskDelete(obj.task);
	KeyConfigCreate(null,0);
}


function StageSelectNextMainGameFunc(obj){
	TaskDelete(obj.task);
	// vC[Xe[^X
	PlayerStatus.score = 0;
	PlayerStatus.level = 0;
	PlayerStatus.num = 2;
	PlayerStatus.warp = null;
	PlayerStatus.next_script = null;
	PlayerStatus.panel = [0,0,0];
	PlayerStatus.panel_num = 0;
	PlayerStatus.world = StageSelectTable[obj.head].world;
	PlayerStatus.stage = StageSelectTable[obj.head].stage;
	PlayerStatus.star_time = 0;
	PlayerStatus.star_hit = 0;
	PlayerStatus.jam = 0;
	PlayerStatus.stage_time = 0;
	PlayerStatus.bgm_id = null;
	PlayerStatus.play_time = MAX_TIME;
	StageSetWorldScript();
	WorldStartCreate(null,null);
}