/* -----------------------------------------------------------------------------
	vC[Aj[V֐
	t@C  : pl_anime.as
			: hakuhin (c) 2006/11/13
	
			: vC[Aj[V
 ----------------------------------------------------------------------------- */


function PlayerPowerUpAnimeCreate(task,param){
	return TaskCreate(
		PlayerPowerUpAnimeInitalize,
		PlayerPowerUpAnimeExecute,
		PlayerPowerUpAnimeDelete,
		task,PRIO_PLAYER_ITEM,LEVEL_ANIM,param
	);
}

function PlayerPowerUpAnimeInitalize(obj,task,param){
	obj.task = task;
	obj.pos = Vec2dClone(param.pos);
	obj.pref = param.pref;
	obj.post = param.post;
	obj.frame = param.frame;
	obj.dir = param.dir;
	obj.time = 0;
	
	TaskWork.level = LEVEL_ANIM;
}

function PlayerPowerUpAnimeExecute(obj){
		
	if(obj.time % 10 == 0){
		switch(obj.post){
		case 0:		var mc = _root.sprite.attachMovie("nayuki","player",DEPTH_PLAYER);			break;
		case 1:		var mc = _root.sprite.attachMovie("akiko","player",DEPTH_PLAYER);			break;
		case 2:		var mc = _root.sprite.attachMovie("fire_akiko","player",DEPTH_PLAYER);		break;
		}
		mc._x = obj.pos.x;
		mc._y = obj.pos.y;
		mc._xscale *= obj.dir;
		mc.gotoAndStop(obj.frame);
		
	}	
	if(obj.time % 10 == 5){
		switch(obj.pref){
		case 0:		var mc = _root.sprite.attachMovie("nayuki","player",DEPTH_PLAYER);			break;
		case 1:		var mc = _root.sprite.attachMovie("akiko","player",DEPTH_PLAYER);			break;
		case 2:		var mc = _root.sprite.attachMovie("fire_akiko","player",DEPTH_PLAYER);		break;
		}
		mc._x = obj.pos.x;
		mc._y = obj.pos.y;
		mc._xscale *= obj.dir;
		mc.gotoAndStop(obj.frame);
	}
	if( ++obj.time > 40 ){
		TaskDelete(obj.task);
		return;
	}
}

function PlayerPowerUpAnimeDelete(obj){
	TaskWork.level = LEVEL_PLAYER;
	// XV
	PlayerUpdate(PLAYER_TASK.obj);
}





// J[e[u
PlayerDamageTable = [
	{	// 01t[ 
		time:	5,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,196)
	},{
		time:	 2,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,32)
	},{time: -2}
];



function PlayerDamageAnimeCreate(task,param){
	return TaskCreate(
		PlayerDamageAnimeInitalize,
		PlayerDamageAnimeExecute,
		PlayerDamageAnimeDelete,
		task,PRIO_PLAYER_ITEM,LEVEL_PLAYER,param
	);
}

function PlayerDamageAnimeInitalize(obj,task,param){
	obj.task = task;
	obj.time = 0;
	obj.hittest = param;

	obj.color = ColorCreate(PLAYER_TASK.obj.mc);
	ColorTableSet(obj.color,PlayerDamageTable,120);

}

function PlayerDamageAnimeExecute(obj){
	ColorExecute(obj.color);

	if( ++obj.time > 120 ){
		TaskDelete(obj.task);
		return;
	}
}

function PlayerDamageAnimeDelete(obj){
	HittestAttach(obj.hittest,HITTEST_TYPE_PLAYER);
}





// J[e[u
PlayerStarTable = [
	{	// 01t[ 
		time:	3,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,200,0,0,0,255)
	},{	// 01t[ 
		time:	3,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,200,0,255)
	},{	// 01t[ 
		time:	3,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,200,200,0,255)
	},{	// 01t[ 
		time:	-3,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,255)
	}
];



function PlayerStarAnimeCreate(task,param){
	
	if(PLAYER_TASK.obj.star)	return NULL;


	return TaskCreate(
		PlayerStarAnimeInitalize,
		PlayerStarAnimeExecute,
		PlayerStarAnimeDelete,
		task,PRIO_PLAYER_ITEM,LEVEL_PLAYER,param
	);
}

function PlayerStarAnimeInitalize(obj,task,param){
	obj.task = PLAYER_TASK.obj.star = task;
	obj.time = 0;
	
	PtcStarCreate(PLAYER_TASK.obj.pos,task);

	obj.color = ColorCreate(PLAYER_TASK.obj.mc);
	ColorTableSet(obj.color,PlayerStarTable,null);

	var order = {
		depth : DEPTH_PLAYER_CHASE,			// [x(֋OՐgp
		num   : DEPTH_PLAYER_CHASE_NUM,		// OՐ
		rist  : 0,							// 
		mc    : param.mc,					// ǔf
		start : new flash.geom.ColorTransform(1,0.5,0.0,0,255,255,0,128),	// JnJ[
		end   : new flash.geom.ColorTransform(1,1,0.0,0,255,255,255,0),		// IJ[
		blend : "add"
	};
	obj.chase = ChaseTaskCreate(task,order);
	
	BgmPlay({
		ch : 0,
		id : BGM_STAR,
		roop : true,
		vol : 100,
		pan : 0
	});
}

function PlayerStarAnimeExecute(obj){
	ColorExecute(obj.color);
}

function PlayerStarAnimeDelete(obj){
	ColorBaseSet(obj.color ,new flash.geom.ColorTransform(1,1,1,1,0,0,0,0));
	BgmPlay({
		ch : 0,
		id : PlayerStatus.bgm_id,
		roop : true,
		vol : 100,
		pan : 0
	});
}


function PlayerStarClear(obj){
	// X^[~
	if(obj.star){
		TaskDelete(obj.star);
		obj.star = null;
		PlayerStatus.star_time = 0;
	}
}

