/* -----------------------------------------------------------------------------
	neiubN֐
	t@C  : hatena_block.as
			: hakuhin (c) 2006/11/07
	
			: neiubNp֐
 ----------------------------------------------------------------------------- */


// neiubN^Cv
BLOCK_ITEM_BREAK	= 0;	// 
BLOCK_ITEM_EMPTY	= 1;	// Ȃ
BLOCK_ITEM_MASHROOM	= 2;	// p[Abv
BLOCK_ITEM_JAM 		= 3;	// W
BLOCK_ITEM_JAMS 	= 4;	// W
BLOCK_ITEM_STAR		= 5;	// X^[
BLOCK_ITEM_1UP		= 6;	// 1UP

BLOCK_TYPE_BLOCK	= 0;
BLOCK_TYPE_HATENA	= 1;
BLOCK_TYPE_EMPTY	= 2;
BLOCK_TYPE_BATU		= 3;




HATENA_BLOCK_WIDTH = 20;
HATENA_BLOCK_HEIGHT = HATENA_BLOCK_WIDTH;
HATENA_BLOCK_RADIUS = HATENA_BLOCK_WIDTH / 2;

HATENA_JAMS_TIME	= 180;


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function BlockTaskCreate(task,param){
	return TaskCreate(
		BlockInitalize,
		BlockExecute,
		BlockDelete,
		task,PRIO_STAGE,LEVEL_STAGE,param
	);

}

function BlockInitalize(obj,task,param){

	obj.task = task;
	obj.depth = BlockDepthGet();

	obj.id = param.id;
	obj.mc_type = param.mc_type;
	obj.item_type = param.item_type;
	obj.color_type = param.color_type;

	obj.pos = Vec2dClone(param.pos);
	obj.base = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.mov = Vec2dCreate(0,0);
	obj.jams_count = 0;
	obj.end = false;
	obj.exec = BlockStayInit;

	if(STAGE_SCRIPT_WORK[obj.id] == 2){
		var rect = {
			x : 0,
			y : 0,
			w : HATENA_BLOCK_WIDTH,
			h : HATENA_BLOCK_HEIGHT
		};

		// RWo^
		obj.collision = {pos : obj.pos,rect: rect,type : COLLISION_TYPE_RECT,func : null,param : obj};
		CollisionAttach(obj.collision);
		
		obj.mc = _root.sprite.attachMovie("batu_block","_" + obj.depth.depth, obj.depth.depth);

		obj.mc._x = obj.pos.x;
		obj.mc._y = obj.pos.y;
		return;
		
	}else{
		switch(obj.mc_type){
		case BLOCK_TYPE_BLOCK:		obj.mc = _root.sprite.attachMovie(obj.color_type,"_" + obj.depth.depth, obj.depth.depth);		break;
		case BLOCK_TYPE_HATENA:		obj.mc = _root.sprite.attachMovie("hatena_block","_" + obj.depth.depth, obj.depth.depth);		break;
		};
	}

	if(obj.mc_type == BLOCK_TYPE_EMPTY){
		var rect = {
			x : 0,
			y : HATENA_BLOCK_HEIGHT - 2,
			w : HATENA_BLOCK_WIDTH,
			h : 2
		};

		// _[Wo^
		obj.hittest = {pos : obj.pos,rect: rect,func:BlockBreakFunc,param:obj,type : COLLISION_TYPE_RECT};
		HittestAttach(obj.hittest,HITTEST_TYPE_EMPTY);
	}else{
		var rect = {
			x : 0,
			y : 0,
			w : HATENA_BLOCK_WIDTH,
			h : HATENA_BLOCK_HEIGHT
		};

		// RWo^
		obj.collision = {pos : obj.pos,rect: rect,type : COLLISION_TYPE_RECT,func : null,param : obj};
		CollisionAttach(obj.collision);

		// _[Wo^
		obj.hittest = {pos : obj.pos,rect: rect,func:BlockBreakFunc,param:obj,type : COLLISION_TYPE_RECT};
		HittestAttach(obj.hittest,HITTEST_TYPE_STAGE);
	}

	obj.mc._x = obj.pos.x;
	obj.mc._y = obj.pos.y;

}


function BlockExecute(obj){
	obj.exec(obj);	// s
	
	if(obj.jams_count < HATENA_JAMS_TIME && obj.jams_count > 0){
		obj.jams_count ++;
	}
}


function BlockStayInit(obj){
	obj.exec = BlockStayExec;
	
	BlockStayExec(obj);
}


function BlockStayExec(obj){
}


function HatenaItemCreateInit(obj){
	obj.exec = HatenaItemCreateExec;
	obj.pos = Vec2dCreate(obj.base.x,obj.base.y);
	obj.mov.y = -4;
	obj.count = 0;

	switch(obj.item_type){
	case BLOCK_ITEM_EMPTY:
		obj.end = true;
		obj.mc = _root.sprite.attachMovie("batu_block","_" + obj.depth.depth, obj.depth.depth);
//		obj.mc.cacheAsBitmap = true;
		STAGE_SCRIPT_WORK[obj.id] = 2;

		if(obj.hittest){
			HittestRemove(obj.hittest);
			obj.hittest = null;
		}
		break;

	case BLOCK_ITEM_BREAK:
		break;

	case BLOCK_ITEM_MASHROOM:
		if(PlayerStatus.level == 0){
			MushroomTaskCreate(STAGE_TASK,{
				pos : Vec2dAdd(obj.pos,Vec2dCreate(HATENA_BLOCK_RADIUS,0))
			});
		}else{
			FlowerTaskCreate(STAGE_TASK,{
				pos : Vec2dAdd(obj.pos,Vec2dCreate(HATENA_BLOCK_RADIUS,0))
			});
		}
	
		SePlay(SE_ITEM_APPER,obj.pos);
		
		
		obj.end = true;
		obj.mc = _root.sprite.attachMovie("batu_block","_" + obj.depth.depth, obj.depth.depth);
		STAGE_SCRIPT_WORK[obj.id] = 2;
		
		if(obj.hittest){
			HittestRemove(obj.hittest);
			obj.hittest = null;
		}
		break;

	case BLOCK_ITEM_STAR:
		StarTaskCreate(STAGE_TASK,{
			pos : Vec2dAdd(obj.pos,Vec2dCreate(HATENA_BLOCK_RADIUS,0))
		});
		SePlay(SE_ITEM_APPER,obj.pos);

		obj.end = true;
		obj.mc = _root.sprite.attachMovie("batu_block","_" + obj.depth.depth, obj.depth.depth);
		STAGE_SCRIPT_WORK[obj.id] = 2;

		if(obj.hittest){
			HittestRemove(obj.hittest);
			obj.hittest = null;
		}
		break;

	case BLOCK_ITEM_JAM:
		JamGetTaskCreate(STAGE_TASK,{
			pos : Vec2dAdd(obj.pos,Vec2dCreate(HATENA_BLOCK_RADIUS,0))
		});
		obj.end = true;
		obj.mc = _root.sprite.attachMovie("batu_block","_" + obj.depth.depth, obj.depth.depth);
		STAGE_SCRIPT_WORK[obj.id] = 2;

		if(obj.hittest){
			HittestRemove(obj.hittest);
			obj.hittest = null;
		}
		break;

	case BLOCK_ITEM_JAMS:
		// BȂʏ탂[h
		if(obj.mc_type == BLOCK_TYPE_EMPTY){
			var rect = {
				x : 0,
				y : 0,
				w : HATENA_BLOCK_WIDTH,
				h : HATENA_BLOCK_HEIGHT
			};

			if(obj.hittest){
				HittestRemove(obj.hittest);
				obj.hittest = null;
			}

			// _[Wo^
			obj.hittest = {pos : obj.pos,rect: rect,func:BlockBreakFunc,param:obj,type : COLLISION_TYPE_RECT};
			HittestAttach(obj.hittest,HITTEST_TYPE_STAGE);


			obj.mc = _root.sprite.attachMovie(obj.color_type,"_" + obj.depth.depth, obj.depth.depth);
			obj.mc_type = BLOCK_TYPE_BLOCK;
		}

		JamGetTaskCreate(STAGE_TASK,{
			pos : Vec2dAdd(obj.pos,Vec2dCreate(HATENA_BLOCK_RADIUS,0))
		});
		
		obj.jams_count ++;
		if(obj.jams_count >= HATENA_JAMS_TIME){
			obj.end = true;
			obj.mc = _root.sprite.attachMovie("batu_block","_" + obj.depth.depth, obj.depth.depth);
			STAGE_SCRIPT_WORK[obj.id] = 2;

			if(obj.hittest){
				HittestRemove(obj.hittest);
				obj.hittest = null;
			}
		}
		break;
/*
	case BLOCK_TYPE_STAR:
		obj.end = true;
		obj.mc = _root.sprite.attachMovie("batu_block","batu_block" + obj.depth.depth, obj.depth.depth);
		STAGE_SCRIPT_WORK[obj.id] = 2;

		if(obj.hittest){
			HittestRemove(obj.hittest);
			obj.hittest = null;
		}
		break;
*/
	}

	HatenaItemCreateExec(obj);
}


function HatenaItemCreateExec(obj){
	obj.mov.y += 1;
	obj.pos = Vec2dAdd(obj.pos,obj.mov);
	obj.mc._x = obj.pos.x;
	obj.mc._y = obj.pos.y;
	if( ++obj.count > 6){
		// ҋ@Ԃ
		if(obj.end){
			obj.exec = BlockStayInit;
		// 肪邩`FbN
		}else{
			obj.exec = BlockRecoverInit;
		}
	}
}



function BlockDelete(obj){
	BlockDepthPurge(obj.depth);

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}

 	if(obj.collision){
		CollisionRemove(obj.collision);
		obj.collision = null;
	}
	obj.mc.removeMovieClip();
}

function BlockBreakFunc(obj,type){
	// ubNU
	BlockGetItemCheck(obj);

	switch(type){
	case HITTEST_TYPE_PLAYER:
		if(obj.mc_type == BLOCK_TYPE_EMPTY){
			var rect = {
				x : 0,
				y : 0,
				w : HATENA_BLOCK_WIDTH,
				h : HATENA_BLOCK_HEIGHT
			};
	
			// RWo^
			obj.collision = {pos : obj.pos,rect: rect,type : COLLISION_TYPE_RECT,func : null,param : obj};
			CollisionAttach(obj.collision);
		}

		if(obj.item_type == BLOCK_ITEM_BREAK){
			if(PlayerStatus.level != 0){
				if(obj.hittest){
					HittestRemove(obj.hittest);
					obj.hittest = null;
				}
			 	if(obj.collision){
					CollisionRemove(obj.collision);
					obj.collision = null;
				}
				var pos = Vec2dCreate(
					obj.pos.x + HATENA_BLOCK_RADIUS,
					obj.pos.y + HATENA_BLOCK_RADIUS
				);

				ScoreAdd(200);
				PtcHahenCreate(pos);
				SePlay(SE_BREAK,pos);

				TaskDelete(obj.task);
				STAGE_SCRIPT_WORK[obj.id] = 0;
				return;
			}
		}
		break;
	case HITTEST_TYPE_TURTLE_ATT:
		if(obj.item_type == BLOCK_ITEM_BREAK){
			if(obj.hittest){
				HittestRemove(obj.hittest);
				obj.hittest = null;
			}
		 	if(obj.collision){
				CollisionRemove(obj.collision);
				obj.collision = null;
			}
			var pos = Vec2dCreate(
				obj.pos.x + HATENA_BLOCK_RADIUS,
				obj.pos.y + HATENA_BLOCK_RADIUS
			);

			ScoreAdd(200);
			PtcHahenCreate(pos);
			SePlay(SE_BREAK,pos);
			TaskDelete(obj.task);
			STAGE_SCRIPT_WORK[obj.id] = 0;
			return;
		}	
		break;
	}
	

	obj.exec = HatenaItemCreateInit;
}


function BlockAttachScript(param,id,task){
	BlockTaskCreate(task,{
		pos       : param.pos,
		item_type : param.item_type,
		mc_type   : param.mc_type,
		color_type: param.color_type,
		id        : id
	});
}


// ubNU
function BlockGetItemCheck(obj){
	var pos = obj.pos;
	var rect = {
		x :   0,
		y : -10,
		w :  20,
		h :  10
	};
	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;
	var vec = Vec2dCreate(pos.x + HATENA_BLOCK_RADIUS,pos.y + HATENA_BLOCK_RADIUS);

	var data = HITTEST_WORK[HITTEST_TYPE_ITEM].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_STAGE,vec);
		}

		data = list;
	}

	var data = HITTEST_WORK[HITTEST_TYPE_ENEMY].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			ScoreSCreate(null,{pos : obj.pos,score : 200});
			data.func(data.param,HITTEST_TYPE_STAGE,vec);
		}

		data = list;
	}
	
	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			ScoreSCreate(null,{pos : obj.pos,score : 200});
			data.func(data.param,HITTEST_TYPE_STAGE,vec);
		}

		data = list;
	}
	
	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE_ATT].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			ScoreSCreate(null,{pos : obj.pos,score : 200});
			data.func(data.param,HITTEST_TYPE_STAGE,vec);
		}

		data = list;
	}
}