/* -----------------------------------------------------------------------------
	ړ֐
	t@C  : block_foot.as
			: hakuhin (c) 2006/11/26
	
			: ړ
 ----------------------------------------------------------------------------- */



/* --------------------------------
	^XN
 -------------------------------- */
function BlockFootCreate(task,param){
	return TaskCreate(
		BlockFootInitalize,
		BlockFootExecute,
		BlockFootDelete,
		task,PRIO_STAGE,LEVEL_PLAYER,param
	);
}


// ʏ
function BlockFootInitalize(obj,task,param){
	obj.task = task;
	
	obj.num = param.num;
	obj.pos = Vec2dClone(param.pos);
	obj.base = Vec2dClone(param.pos);
	obj.spd = Vec2dClone(param.spd);
	obj.length = param.length;

	obj.depth = BlockDepthGet();

	// [N쐬
	obj.mc = _root.sprite.createEmptyMovieClip("block_foot" + obj.depth.depth, obj.depth.depth);
	
	var i;
	var w = obj.num * 10;
	var rect = {
		x :  -5,
		y :  -5,
		w :  10,
		h :  10
	};
	
	obj.collision = new Array();
	for(i=0;i<obj.num;i++){
		var mc = obj.mc.attachMovie("block_foot","_" + i, i);
		mc._x = -(w / 2) + 10 * i + 5;
		
		var pos = {x : -(w / 2) + 10 * i + 5 + obj.pos.x, y : obj.pos.y}

		// RWo^
		obj.collision[i] = {pos : pos,rect: rect,type : COLLISION_TYPE_FOOT,func : null,param : obj};
		CollisionAttach(obj.collision[i]);
	}
	
	BlockFootExecute(obj);
}


// ʏ
function BlockFootExecute(obj){

	var i;
	var w = obj.num * 10;
	for(i=0;i<obj.num;i++){
		// RWo^XV
		CollisionRemove(obj.collision[i]);
		obj.collision[i].pos = {x : -(w / 2) + 10 * i + 5 + obj.pos.x, y : obj.pos.y};
		CollisionAttach(obj.collision[i]);
	}
	

	obj.pos = Vec2dAdd(obj.pos , obj.spd);
	
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
	
	var vec = Vec2dSub(obj.base,obj.pos);
	if(Vec2dLength(vec) > obj.length){
		TaskDelete(obj.task);
	}
}


function BlockFootDelete(obj){
	var i;
	for(i=0;i<obj.num;i++){
		CollisionRemove(obj.collision[i]);
	}
	BlockDepthPurge(obj.depth);
	obj.mc.removeMovieClip();
}


















/* --------------------------------
	^XN
 -------------------------------- */
function BlockFootMngCreate(task,param){
	return TaskCreate(
		BlockFootMngInitalize,
		BlockFootMngExecute,
		BlockFootMngDelete,
		task,PRIO_STAGE,LEVEL_PLAYER,param
	);
}


// ʏ
function BlockFootMngInitalize(obj,task,param){
	obj.task = task;
	obj.count = param.count;
	obj.pos = param.pos;
	obj.spd = param.spd;
	obj.num = param.num;
	obj.length = param.length;
	obj.frame = 0;
}


// ʏ
function BlockFootMngExecute(obj){
	if( ++ obj.frame > obj.count){
		BlockFootCreate(obj.task,{
			pos : obj.pos,
			spd : obj.spd,
			num : obj.num,
			length : obj.length
		});
		obj.frame = 0;
	}
}


function BlockFootMngDelete(obj){
}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function BlockFootMngScript(param,id,task){
	BlockFootMngCreate(task,{
		count : param.count,
		pos : param.pos,
		spd : param.spd,
		num : param.num,
		length : param.length
	});
}
