/* -----------------------------------------------------------------------------
	ubW֐
	t@C  : bridge.as
			: hakuhin (c) 2006/10/31
	
			: c莞Ԃ\
 ----------------------------------------------------------------------------- */



/* --------------------------------
	^XN
 -------------------------------- */
function BridgeCreate(task,param){
	return TaskCreate(
		BridgeInitalize,
		BridgeExecute,
		BridgeDelete,
		task,PRIO_STAGE,LEVEL_STAGE,param
	);
}


// ʏ
function BridgeInitalize(obj,task,param){
	obj.task = task;

	obj.pos = Vec2dClone(param.pos);
	obj.fpos = Vec2dClone(param.pos);
	obj.base = Vec2dClone(param.pos);
	obj.length = param.length;
	obj.rot = param.rot;
	obj.add = param.add;

	obj.depth = BlockDepthGet();

	// [N쐬
	obj.mc = _root.sprite.attachMovie("batu_block","_" + obj.depth.depth, obj.depth.depth);

	var rect = {
		x : 0,
		y : 0,
		w : HATENA_BLOCK_WIDTH,
		h : HATENA_BLOCK_HEIGHT
	};

	// RWo^
	obj.collision = {pos : obj.base,rect: rect,type : COLLISION_TYPE_RECT,func : null,param : obj};
	CollisionAttach(obj.collision);
}


// ʏ
function BridgeExecute(obj){
	obj.rot += obj.add;
	if(obj.rot < 0)		obj.rot += 360;
	if(obj.rot > 360)	obj.rot -= 360;

	obj.pos.y = obj.base.y + Math.sin(obj.rot * Math.PI / 180) * obj.length;

	// RWo^XV
	CollisionRemove(obj.collision);
	obj.collision.pos = Vec2dClone(obj.fpos);
	CollisionAttach(obj.collision);

	obj.spd = Vec2dSub(obj.pos,obj.fpos);
	obj.fpos = Vec2dClone(obj.pos);
	
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
}


function BridgeDelete(obj){
	CollisionRemove(obj.collision);
	BlockDepthPurge(obj.depth);
	obj.mc.removeMovieClip();
}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function BridgeScript(param,id,task){
	
	var i;
	for(i=0;i<param.num;i++){
		var d = (i / (param.num - 1) * 2 - 1);
		d = 1-Math.abs(d);
		BridgeCreate(task,{
			pos : { x : param.pos.x + i * HATENA_BLOCK_WIDTH , y : param.pos.y},
			length : param.length * d,
			rot : param.rot * i,
			add : param.add
		});
	}
}




/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function BridgeHalfScript(param,id,task){
	var i;
	for(i=0;i<param.num;i++){

		var d = i / (param.num - 1);
		BridgeCreate(task,{
			pos : { x : param.pos.x + i * HATENA_BLOCK_WIDTH * param.dir, y : param.pos.y},
			length : param.length * d,
			rot : param.rot * i,
			add : param.add
		});
	}
}
