/* -----------------------------------------------------------------------------
	֐
	t@C  : fall_foot.as
			: hakuhin (c) 2006/12/11
	
			: 
 ----------------------------------------------------------------------------- */



FALL_FOOT_FLG_COLLISION = 0x0001;	// ڐGς
FALL_FOOT_G				= 0.3;		// d
FALL_FOOT_SPD_Y			= 4;		// ō


/* --------------------------------
	^XN
 -------------------------------- */
function FallFootCreate(task,param){
	return TaskCreate(
		FallFootInitalize,
		FallFootExecute,
		FallFootDelete,
		task,PRIO_STAGE,LEVEL_STAGE,param
	);
}


// ʏ
function FallFootInitalize(obj,task,param){
	obj.task = task;
	
	obj.flg = 0;
	obj.pos = Vec2dClone(param.pos);
	obj.fpos = Vec2dClone(param.pos);
	obj.base = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.count = param.count;
	obj.end = false;

	obj.depth = BlockDepthGet();

	// [N쐬
	obj.mc = _root.sprite.attachMovie("fall_foot" , "_" + obj.depth.depth, obj.depth.depth);

	var rect = {
		x :  0,
		y :  0,
		w :  20,
		h :  15
	};
	// RWo^
	obj.collision = {pos : obj.pos,rect: rect,type : COLLISION_TYPE_RECT,func : FallFootHitCheck,param : obj};
	CollisionAttach(obj.collision);

	obj.exec = FallFootStayInit;
	obj.exec(obj);
}


// ---------------------------------------
//	ҋ@
// ---------------------------------------
function FallFootStayInit(obj){
	obj.exec = FallFootStayExec;
	FallFootStayExec(obj);
}

function FallFootStayExec(obj){
}


// ---------------------------------------
//	ڐG̃R[obN֐
// ---------------------------------------
function FallFootHitCheck(obj){
	if(!(obj.flg & FALL_FOOT_FLG_COLLISION)){
		obj.flg |= FALL_FOOT_FLG_COLLISION;
		obj.exec = FallFootStep1Init;
	}
}

// ---------------------------------------
//	U
// ---------------------------------------
function FallFootStep1Init(obj){
	obj.frame = 0;
	obj.exec = FallFootStep1Exec;
	FallFootStep1Exec(obj);

}

function FallFootStep1Exec(obj){
	if(++ obj.frame > 30){
		obj.exec = FallFootStep2Init;
	}

}
// ---------------------------------------
//	
// ---------------------------------------
function FallFootStep2Init(obj){
	obj.frame = 0;
	obj.exec = FallFootStep2Exec;
	FallFootStep2Exec(obj);

}

function FallFootStep2Exec(obj){
	obj.spd.y += FALL_FOOT_G;
	if(obj.spd.y > FALL_FOOT_SPD_Y)	obj.spd.y = FALL_FOOT_SPD_Y;

	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	
	var vec = ScreenPosition(obj.pos);
	if(vec.y > SCREEN_HEIGHT + 40){
		obj.end = true;
	}
}


// ʏ
function FallFootExecute(obj){

	obj.exec(obj);
	obj.spd = Vec2dSub(obj.pos,obj.fpos);
	
	obj.collision.pos = Vec2dClone(obj.fpos);

	// RWo^XV
	CollisionRemove(obj.collision);
	obj.collision.pos = obj.fpos;
	CollisionAttach(obj.collision);
	obj.fpos = Vec2dClone(obj.pos);

	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
	
	if(obj.end){
		TaskDelete(obj.task);
		return;
	}
}


function FallFootDelete(obj){
	var i;
	CollisionRemove(obj.collision);
	BlockDepthPurge(obj.depth);
	obj.mc.removeMovieClip();
}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function FallFootScript(param,id,task){

	FallFootCreate(task,{
		pos : param.pos
	});
}
