/* -----------------------------------------------------------------------------
	S[֐
	t@C  : goal_panel.as
			: hakuhin (c) 2006/12/02
	
			: S[pl
 ----------------------------------------------------------------------------- */



/* --------------------------------
	^XN
 -------------------------------- */
function GoalPanelCreate(task,param){
	return TaskCreate(
		GoalPanelInitalize,
		GoalPanelExecute,
		GoalPanelDelete,
		task,PRIO_SCROLL,LEVEL_PLAYER,param
	);
}


// ʏ
function GoalPanelInitalize(obj,task,param){
	obj.task = task;
	obj.pos = param.pos;
	obj.world = param.world;
	obj.stage = param.stage;

	obj.mc = _root.sprite.attachMovie("goal_panel_f" , "_" + DEPTH_GOAL, DEPTH_GOAL);
	obj.mc._x = param.pos.x;
	obj.mc._y = param.pos.y;
	AnmCmdInit(obj.mc);
	
	obj.exec = GoalPanelStayInit;
}


// ʏ
function GoalPanelExecute(obj){
	
	obj.exec(obj);

}




function GoalPanelDelete(obj){
	obj.mc.removeMovieClip();

}

GoalPanelLavel = [
	"_mushroom",
	"_flower",
	"_star"
];

function GoalPanelStayInit(obj){
	obj.exec = GoalPanelStayExec;
	obj.count = 0;
	obj.head = 0;
	
	GoalPanelStayExec(obj);
}


function GoalPanelStayExec(obj){
	
	if(++ obj.count > 6){
		obj.count = 0;
		if( ++ obj.head > 2){
			obj.head = 0;
		}
/*
		if(obj.head == 2){
			if(obj.mosaic == null){
				obj.mosaic = MosaicEffectCreate(obj.task,{
					rect : {x : -12,y : -12,w : 24,h : 24},
					size : {x:6,y:6},
					type : 0
				});
			}
		}else{
			if(obj.mosaic){
				TaskDelete(obj.mosaic);
				obj.mosaic = null;
			}
		}
*/
		obj.mc.ANM_GOTO = GoalPanelLavel[obj.head];
		AnmCmdPlay(obj.mc);
	}
	
	
//	if(obj.mosaic)
//		obj.mosaic.obj.pos = ScreenPosition(obj.pos);

	GoalPanelCheck(obj);

}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function GoalPanelScript(param,id,task){
	GoalPanelCreate(task,{
		pos : param.pos,
		world : param.world,
		stage : param.stage,
		id : id
	});
}





// S[ڐG
function GoalPanelCheck(obj){
	var pos = obj.pos;
	var rect = {
		x : -15,
		y : -15,
		w :  30,
		h :  30
	};

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_PLAYER].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			obj.mc.ANM_GOTO = "_waku";
			AnmCmdPlay(obj.mc);
			obj.exec = null;
			
			TimeStop();
			
			// o^
			PlayerStatus.panel[PlayerStatus.panel_num] = obj.head + 1;
			PlayerStatus.panel_num += 1;
			
			StageEnemyKill();
			PlayerStarClear(PLAYER_TASK.obj);

			PLAYER_TASK.obj.flg |= PLAYER_FLG_GOAL;
			
			// Rv[go
			var check = 0;
			
			if(PlayerStatus.panel_num == 3){
				if(PlayerStatus.panel[0] == obj.head + 1){
					if(PlayerStatus.panel[1] == obj.head + 1){
						check = 1;
					}
				}
			
				// SOSRv`FbN
				if(check == 0){
					if(PlayerStatus.panel[0] != obj.head + 1){
						if(PlayerStatus.panel[1] != obj.head + 1){
							if(PlayerStatus.panel[1] != PlayerStatus.panel[0]){
								check = 2;
							}
						}
					}
				}
			}
			
			switch(check){
			case 2:
//				TaskWork.level = LEVEL_STAGE;
				SosCompCreate(STAGE_TASK,obj.head);
				PLAYER_TASK.level = 0;

				BgmPlay({
					ch : 0,
					id : BGM_COMP,
					roop : false,
					vol : 100,
					pan : 0
				});
				break;
				
			case 1:
//				TaskWork.level = LEVEL_STAGE;
				PanelCompCreate(STAGE_TASK,obj.head);
				PLAYER_TASK.level = 0;

				BgmPlay({
					ch : 0,
					id : BGM_COMP,
					roop : false,
					vol : 100,
					pan : 0
				});
				
				break;
				
			case 0:
//				PLAYER_TASK.level = LEVEL_STAGE;
//				TaskWork.level = LEVEL_STAGE;

				GoalPanelGetMenuCreate(obj.task,{ pos:obj.pos,type:obj.head});

				BgmPlay({
					ch : 0,
					id : BGM_GOAL,
					roop : false,
					vol : 100,
					pan : 0
				});
/*
				if(obj.mosaic){
					TaskDelete(obj.mosaic);
					obj.mosaic = null;
				}
*/
				break;
			}

			// Xe[WXV
			PlayerStatus.world = obj.world;
			PlayerStatus.stage = obj.stage;

			PopupMsgSet("goal");

			return;
		}

		data = list;
	}
}












// Abp[U
function StageEnemyKill(){
	var vec = WorldPosition({x:-50,y:-50});

	// XN[ɓ
	var pos = Vec2dCreate(vec.x + GAME_WIDTH_HALF, vec.y + GAME_HEIGHT_HALF);
	var l1 = vec.x;
	var t1 = vec.y;
	var r1 = l1 + GAME_WIDTH + 100;
	var m1 = t1 + GAME_HEIGHT + 100;

	var data = HITTEST_WORK[HITTEST_TYPE_ENEMY].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 <= l2){
		}else if(r2 <= l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			if(data.func(data.param,HITTEST_TYPE_STAGE_KILL,pos)){
				JamGetTaskCreate(STAGE_TASK,{
					pos : b_pos
				});
				PtcSmokeCreate(b_pos);
			}
		}

		data = list;
	}
	
	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 <= l2){
		}else if(r2 <= l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			if(data.func(data.param,HITTEST_TYPE_STAGE_KILL,pos)){
				JamGetTaskCreate(STAGE_TASK,{
					pos : b_pos
				});
				PtcSmokeCreate(b_pos);
			}
		}

		data = list;
	}
	
	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE_ATT].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 <= l2){
		}else if(r2 <= l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			if(data.func(data.param,HITTEST_TYPE_STAGE_KILL,pos)){
				JamGetTaskCreate(STAGE_TASK,{
					pos : b_pos
				});
				PtcSmokeCreate(b_pos);
			}
		}

		data = list;
	}
}
