/* -----------------------------------------------------------------------------
	B֐
	t@C  : pocket_front.as
			: hakuhin (c) 2006/12/02
	
			: B
 ----------------------------------------------------------------------------- */



/* --------------------------------
	^XN
 -------------------------------- */
function PocketFrontCreate(task,param){
	return TaskCreate(
		PocketFrontInitalize,
		PocketFrontExecute,
		PocketFrontDelete,
		task,PRIO_SCROLL,LEVEL_STAGE,param
	);
}


// ʏ
function PocketFrontInitalize(obj,task,param){
	obj.task = task;
	obj.id = param.id;
	obj.pos = param.pos;
	obj.rect = param.rect;
	obj.depth = IllustDepthGet();

	obj.mc = _root.front_rayer1.createEmptyMovieClip("pocket_f" + obj.depth.depth, obj.depth.depth);
	obj.mc._x = param.pos.x;
	obj.mc._y = param.pos.y;

	obj.bmpData = flash.display.BitmapData.loadBitmap (param.asset);
    obj.mc.attachBitmap(obj.bmpData, 0);

    obj.point = new flash.geom.Point( 0, 0);
    obj.bmp_rect = new flash.geom.Rectangle(0, 0, obj.mc._width, obj.mc._height);

	// _~[\[X
  	obj.source = new flash.display.BitmapData(obj.bmp_rect.width, obj.bmp_rect.height, true, 0);
	obj.clear_num = Math.floor((obj.bmp_rect.width * obj.bmp_rect.height) / 60);

	// ̎
	obj.rand = Math.floor(Math.random() * 0xFFFF);
	obj.flg = false;
	obj.count = 0;

}


// ʏ
function PocketFrontExecute(obj){
	// vC[RW
	if(obj.flg){
		obj.rand = obj.bmpData.pixelDissolve(obj.source, obj.bmp_rect, obj.bmp_point, obj.rand, obj.clear_num, 0);
		if( ++ obj.count > 60){
			STAGE_SCRIPT_WORK[obj.id] = false;
			TaskDelete(obj.task);
			return;
		}
	}else{
		PocketFrontCheck(obj);
	}

}


function PocketFrontDelete(obj){
	obj.bmpData.dispose();
	obj.mc.removeMovieClip();
	IllustDepthPurge(obj.depth);

}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function PocketFrontScript(param,id,task){
	PocketFrontCreate(task,{
		pos : param.pos,
		rect : param.rect,
		asset : param.asset,
		id : id
	});
}





// ubNpAbp[U
function PocketFrontCheck(obj){
	var pos = obj.pos;
	var rect = obj.rect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_PLAYER].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			obj.flg = true;
			SoundPlay(SE_POCKET,100,0,SOUND_PRIO_VOICE,false);
			return;
		}

		data = list;
	}
}
