/* -----------------------------------------------------------------------------
	蔻({p)
	t@C  : collision
			: hakuhin (c)2006/02/15
	
			: 蔻`p
 ----------------------------------------------------------------------------- */



/* -----------------------------------------------------------
	RW`FbN
 ----------------------------------------------------------- */
function CollisionRenderTaskCreate(task,param){
	return TaskCreate(
		CollisionRenderInitalize,
		CollisionRenderExecute,
		CollisionRenderDelete,
		task,PRIO_DEBUG,LEVEL_SYSTEM,param
	);
}

function CollisionRenderInitalize(obj,task,param){
	var i;
	obj.task = task;
	obj.mc = _root.sprite.createEmptyMovieClip("collison_render", 100021);
}

function CollisionRenderExecute(obj){
	var i,j;

	var length = 0;

	obj.mc.clear();
	obj.mc.lineStyle (0, 0x000000, 0);

	var y_max = COLLISION_WORK.length;
	var x_max = COLLISION_WORK[0].length;


	var pos = PLAYER_TASK.obj.pos;
	var i = 0;
	var j=0;

	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 1;
	var j_min = Math.floor((pos.y - 20) / COLLISION_SECTOR_HEIGHT) - 1;
	var i_max = i_min + 3;
	var j_max = j_min + 3;
/*
	var i_min = 0;
	var j_min = 0;
	var i_max = COLLISION_WORK[0].length;
	var j_max = COLLISION_WORK.length;
*/
	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l = b_rect.x + b_pos.x;
				var t = b_rect.y + b_pos.y;
				var r = l + b_rect.w;
				var m = t + b_rect.h;
				
				obj.mc.beginFill (0x88FF88, 75);
				obj.mc.moveTo (l, t);
				obj.mc.lineTo (r, t);
				obj.mc.lineTo (r, m);
				obj.mc.lineTo (l, m);
				obj.mc.endFill ();


				data = data.post;
			}
		}
	}
}


function CollisionRenderDelete(obj){
	obj.mc.removeMovieClip();
}