/* -----------------------------------------------------------------------------
	fobOpj[
	t@C  : debug.as
			: hakuhin (c) 2006/06/30
	
			: eXgpj[
 ----------------------------------------------------------------------------- */

StageDebugTable = [
{name : "1-1-0", data : Stage1_1_0Script , world : 1 , stage : 1},
{name : "1-2-0", data : Stage1_2_0Script , world : 1 , stage : 2},
{name : "1-2-1", data : Stage1_2_1Script , world : 1 , stage : 2},
{name : "1-2-2", data : Stage1_2_2Script , world : 1 , stage : 2},
{name : "1-3-0", data : Stage1_3_0Script , world : 1 , stage : 3},
{name : "2-1-0", data : Stage2_1_0Script , world : 2 , stage : 1},
{name : "2-2-0", data : Stage2_2_0Script , world : 2 , stage : 2},
{name : "2-2-1", data : Stage2_2_1Script , world : 2 , stage : 2},
{name : "2-3-0", data : Stage2_3_0Script , world : 2 , stage : 3},
{name : "2-3-1", data : Stage2_3_1Script , world : 2 , stage : 3},
{name : "2-3-2", data : Stage2_3_2Script , world : 2 , stage : 3},
{name : "3-1-0", data : Stage3_1_0Script , world : 3 , stage : 1},
{name : "3-2-0", data : Stage3_2_0Script , world : 3 , stage : 2},
{name : "3-2-1", data : Stage3_2_1Script , world : 3 , stage : 2},
{name : "3-3-0", data : Stage3_3_0Script , world : 3 , stage : 3},
{name : "3-3-1", data : Stage3_3_1Script , world : 3 , stage : 3},
{name : "4-1-0", data : Stage4_1_0Script , world : 4 , stage : 1},
{name : "4-2-0", data : Stage4_2_0Script , world : 4 , stage : 2},
{name : "4-2-1", data : Stage4_2_1Script , world : 4 , stage : 2},
{name : "4-2-2", data : Stage4_2_2Script , world : 4 , stage : 2},
{name : "4-2-3", data : Stage4_2_3Script , world : 4 , stage : 2},
{name : "4-2-4", data : Stage4_2_4Script , world : 4 , stage : 2},
{}
];



function DebugMenuTaskCreate(task,param){
	TaskWork.level = LEVEL_MIN;
	TaskCreate(DebugMenuInit,DebugMenuExec,DebugMenuDel,task,PRIO_BENCH_START,LEVEL_SYSTEM,param);
}


function DebugMenuInit(obj,task,param){
	var i;
	obj.task = task;
	SoundAllStop();
	obj.mc = _root.createEmptyMovieClip("debug_room", this.getNextHighestDepth());
	var title = obj.mc.attachMovie("title","title", this.getNextHighestDepth());
	title._x = 80;
	title._y = 70;

	obj.x = 0;
	obj.y = 0;
	obj.step = 0;
	
	obj.stage = 0;
	
	if(InputTask[0])	TaskDelete(InputTask[0]);
	KeyInputTaskCreate(null,0);
	if(InputTask[1])	TaskDelete(InputTask[1]);
	KeyInputTaskCreate(null,1);

	var type = [
	"PLACTICE_TEST",
	"SOUND_TEST",
	"MAIN_GAME"
	];
	
	obj.y_max = type.length;
	
	obj.mc.createTextField("debug_menu",obj.mc.getNextHighestDepth(), 10, 20, 100, 20);
	obj.mc.debug_menu.text = "DEBUG_MENU";
	obj.mc.debug_menu.selectable = false;

	for(i=0;i<type.length;i++){
		obj.mc.createTextField("menu" + i,obj.mc.getNextHighestDepth(), 30, 40 + i * 20, 200, 20);
		eval("obj.mc.menu"+i).text = type[i];
		eval("obj.mc.menu"+i).selectable = false;
	}

	obj.mc.createTextField("stage_menu",obj.mc.getNextHighestDepth(), 130, 40, 100, 20);
	obj.mc.stage_menu.text = "1-1";
	obj.mc.stage_menu.selectable = false;

	obj.mc.createTextField("cur",obj.mc.getNextHighestDepth(), 10, 30, 30, 20);
	obj.mc.cur.text = ">>";
	obj.mc.cur.selectable = false;

	DebugMenuExec(obj);
}

function DebugMenuExec(obj){

	switch(obj.step){
	case 0:
		obj.step = 1;
		break;
	case 1:

		if(KeyData[0].Menu & KEY_UP)	obj.y --;
		if(KeyData[0].Menu & KEY_DOWN)	obj.y ++;

		if(obj.y < 0)				obj.y = obj.y_max - 1;
		if(obj.y > obj.y_max - 1)	obj.y = 0;
		
		if(obj.y == 5){
			TaskDelete(obj.task);
		}

		switch(obj.y){
		case 0:
			if(KeyData[0].Menu & KEY_LEFT)	obj.stage --;
			if(KeyData[0].Menu & KEY_RIGHT)	obj.stage ++;
			if(obj.stage < 0)						obj.stage = 0;
			if(obj.stage >= StageDebugTable.length)	obj.stage = StageDebugTable.length - 1;

			obj.mc.stage_menu.text = StageDebugTable[obj.stage].name;


			if(KeyData[0].Trg & KEY_A){
				TaskDelete(obj.task);
				// Xe[W쐬
				StageTaskCreate(null,null);
				// XNvgǂݍ
				PlayerStatus.world = StageDebugTable[obj.stage].world;
				PlayerStatus.stage = StageDebugTable[obj.stage].stage;
				StageScriptWorkCreate(StageDebugTable[obj.stage].data);
				StageScriptRead(StageDebugTable[obj.stage].data,STAGE_TASK);
				PlayerCreate(STAGE_TASK,NULL);
				return;
			}
			break;
		}
		if(KeyData[0].Trg & KEY_A){
			switch(obj.y){
			case 1:
				TaskDelete(obj.task);
				SoundTestCreate(null,null);					// TEheXg
				return;
				break;
			case 2:
//				ManagerDemoCreate();
				TaskDelete(obj.task);
//				TitleCreate(null,0);
				FirstContinueCreate(obj.task,null);
				return;
				break;
			}
		}
		break;
	}

	obj.mc.cur._x = 10;
	obj.mc.cur._y = obj.y * 20 + 40;

}

function DebugMenuDel(obj){
	obj.mc.removeMovieClip();
}