/* -----------------------------------------------------------------------------
	UCN֐
	t@C  : mosaic.as
			: hakuhin (c) 2006/11/13
	
			: UCNo\
 ----------------------------------------------------------------------------- */

// \[Xp^[Qbg
SOURCE_MOVIECLIP = _root;



/* --------------------------------
	vC[^XN
 -------------------------------- */
function MosaicEffectCreate(task,param){
	return TaskCreate(
		MosaicEffectInitalize,
		MosaicEffectExecute,
		MosaicEffectDelete,
		task,PRIO_EFFECT,LEVEL_PLAYER,param
	);
}


// ʏ
function MosaicEffectInitalize(obj,task,param){
	obj.task = task;

	obj.rect = param.rect;
	obj.size = param.size;
	obj.type = param.type;
	obj.depth = ((obj.type == 1) ? IllustDepthGet() : IllustBackDepthGet());
	obj.pos = Vec2dCreate(0,0);
	obj.mc = _root.status.createEmptyMovieClip("mosaic" + obj.depth.depth, obj.depth.depth);
	obj.bmpData = new flash.display.BitmapData(obj.rect.w, obj.rect.h,true);
	MosaicEffectExecute(obj);
}


// ʏ
function MosaicEffectExecute(obj){
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);

	// N[Abv
    obj.bmpData.fillRect(new flash.geom.Rectangle(0,0,obj.rect.w,obj.rect.h),0x00000000);
	
	// rbg}bvLv`
	obj.bmpData.draw(SOURCE_MOVIECLIP, new flash.geom.Matrix(1,0,0,1,-obj.rect.x + SOURCE_MOVIECLIP._x -obj.mc._x,-obj.rect.y + SOURCE_MOVIECLIP._y -obj.mc._y));

	var i,j;
	var m_rect = new flash.geom.Rectangle(0,0,obj.size.x,obj.size.y);
	for(i=0;i < obj.rect.h;i+=obj.size.y){
		for(j=0;j < obj.rect.w;j+=obj.size.x){
			// sNZ̐FL΂ĕ`
			m_rect.x = j;
			m_rect.y = i;
			obj.bmpData.fillRect(m_rect, obj.bmpData.getPixel32 (j + Math.floor(Math.random() * obj.size.x),i + Math.floor(Math.random() * obj.size.y)));
		}
	}

	// `
	obj.mc.clear();
	obj.mc.beginBitmapFill(obj.bmpData, new flash.geom.Matrix(1,0,0,1,obj.rect.x,obj.rect.y),true,true);
	obj.mc.moveTo(obj.rect.x, obj.rect.y);
	obj.mc.lineTo(obj.rect.x, obj.rect.y + obj.rect.h);
	obj.mc.lineTo(obj.rect.x + obj.rect.w, obj.rect.y + obj.rect.h);
	obj.mc.lineTo(obj.rect.x + obj.rect.w, obj.rect.y);
	obj.mc.endFill();
}


function MosaicEffectDelete(obj){
	obj.bmpData.dispose();
	((obj.type == 1) ? IllustDepthPurge(obj.depth) : IllustBackDepthPurge(obj.depth));
	obj.mc.removeMovieClip();
}
