/* -----------------------------------------------------------------------------
	֐
	t@C  : exprosion.as
			: hakuhin (c) 2006/03/18
	
			: p[eBN֐
 ----------------------------------------------------------------------------- */

// J[e[u
PanelGetPtcExpTable = [
	{	// 01t[ 
		time:	25,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,255)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{time: -1}
];

function PtcPanelGetCreate(pos){
	var param = {pos : pos};
	var order = {
		target	 : _root.status,
		depth    : 4100,				// p[eBN[x
		res      : "star_ptc_l",		// \[X
		emt_init : PanelGetEmtInit,			// G~b^֐
		emt_exec : PanelGetEmtExec,			// G~b^ړ֐
		emt_del  : PanelGetEmtDel,			// G~b^j֐
		ptc_init : PanelGetPtcInit,			// p[eBN֐
		ptc_exec : PanelGetPtcExec,			// p[eBNړ֐
		ptc_del  : PanelGetPtcDel,			// p[eBNj֐
		gen_num  : 20,					// 
		gen_time : 1,					// Ԋu
		emt_time : 3,					// G~b^I
		kill_time: 25,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(STAGE_TASK,LEVEL_STAGE,order);
}

function PanelGetEmtInit(obj,emt){
	emt._x = obj.param.pos.x;
	emt._y = obj.param.pos.y;
	emt.rot = 0;
	PanelGetEmtExec(obj,emt);
}

function PanelGetEmtExec(obj,emt){
}

function PanelGetEmtDel(obj,emt){
}

function PanelGetPtcInit(emt,ptc){
	ptc.time = 25;
	ptc.blendMode = "add";

	var m = Mtx33Rotate(emt.rot + Math.random() * 5 * RandomSign());
	var v = Vec2dTransformVector(1,0,m);
	ptc.pos = Vec2dCreate(0,0);
	ptc.spd = Vec2dScale(v,Math.random() * 10 + 5);
	ptc.color = ColorCreate(ptc);
	
	emt.rot += 360 / 20;
	ColorTableSet(ptc.color,PanelGetPtcExpTable,null);
	ptc.rot_spd = Math.random() * 20 - 10;

}

function PanelGetPtcExec(emt,ptc){
	ptc.spd = Vec2dScale(ptc.spd,0.85);
	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;
	ptc._rotation += ptc.rot;
	ptc._xscale *= 1.05;
	ptc._yscale *= 1.05;
	
	ptc.rot_spd *= 0.95;
	ptc._rotation += ptc.rot_spd;

	ColorExecute(ptc.color);
}

function PanelGetPtcDel(emt,ptc){
	delete obj.color;
}
