/* -----------------------------------------------------------------------------
	p[eBN֐
	t@C  : snow_ptc.as
			: hakuhin (c) 2006/03/18
	
			: p[eBN֐
 ----------------------------------------------------------------------------- */

// J[e[u
SnowPtcExpTable = [
	{	// 01t[ 
		time:	120,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,255)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{
		time:	-1,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{time: -1}
];

function PtcSnowCreate(pos){
	var param = {depth : EffectDepthGet(),pos : pos};
	var order = {
		target	 : _root.back_rayer1,
		depth    : param.depth.depth,	// p[eBN[x
		res      : "snow_ptc_s",		// \[X
		emt_init : SnowEmtInit,		// G~b^֐
		emt_exec : SnowEmtExec,		// G~b^ړ֐
		emt_del  : SnowEmtDel,			// G~b^j֐
		ptc_init : SnowPtcInit,		// p[eBN֐
		ptc_exec : SnowPtcExec,		// p[eBNړ֐
		ptc_del  : SnowPtcDel,			// p[eBNj֐
		gen_num  : 1,					// 
		gen_time : 2,					// Ԋu
		emt_time : 0x7FFFFFFF,			// G~b^I
		kill_time: 15,					// 
		param    : param				// ̑
	};
	var id = ParticleTaskCreate(STAGE_TASK,LEVEL_STAGE,order);
	
	var i;
	for(i=0;i<60;i++){
		ParticleTaskExec(id.obj);
	}
}

function SnowEmtInit(obj,emt){
}

function SnowEmtExec(obj,emt){
}

function SnowEmtDel(obj,emt){
	EffectDepthPurge(obj.param.depth);
}
function SnowPtcInit(emt,ptc){
	ptc.time = 120;
	ptc.blendMode = "add";
	ptc.pos = { x : Math.random() * GAME_WIDTH + 50, y : - 5};
	ptc.spd = Vec2dCreate(Math.random() * -0.5 - 0.25, Math.random() * 0.05 + 0.02);
	ptc._xscale = ptc._yscale = Math.random() * 20 + 50;
	ptc.color = ColorCreate(ptc);
	ColorTableSet(ptc.color,SnowPtcExpTable,null);
}

function SnowPtcExec(emt,ptc){
	ptc.spd.x += RandomSign() * Math.random() * 0.05;
	ptc.spd.y += Math.random() * 0.05;
	ptc.pos = Vec2dAdd(ptc.pos,ptc.spd);
	ptc._x = ptc.pos.x;
	ptc._y = ptc.pos.y;
	ColorExecute(ptc.color);
}

function SnowPtcDel(emt,ptc){
}


function SnowPtcScript(param,id,task){
	PtcSnowCreate({x:0,y:0});
	PtcSnowFrontCreate({x:0,y:0});
}
