/* -----------------------------------------------------------------------------
	L֐
	t@C  : cat.as
			: hakuhin (c) 2006/12/08
	
			: Lp֐
 ----------------------------------------------------------------------------- */

CAT_WIDTH  = 14;
CAT_HEIGHT = 27;
CAT_BASE_HEIGHT = 32;
CAT_RADIUS = CAT_WIDTH / 2;

CAT_MOVE_INT      = 30;


CAT_TYPE_ROT_000 = 0;
CAT_TYPE_ROT_090 = 1;
CAT_TYPE_ROT_180 = 2;
CAT_TYPE_ROT_270 = 3;




RotAmeCollisionRectRot000 = {
	x : -CAT_RADIUS,
	y : -CAT_HEIGHT,
	w :  CAT_WIDTH,
	h :  CAT_HEIGHT
};


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function RotAmeTaskCreate(task,param){
	return TaskCreate(
		RotAmeInitalize,
		RotAmeExecute,
		RotAmeDelete,
		task,PRIO_ENEMY,LEVEL_ENEMY,param
	);
}


/* --------------------------------------------------------------
	
 -------------------------------------------------------------- */
function RotAmeInitalize(obj,task,param){
	obj.task = task;
	obj.id = param.id;
	obj.depth = EffectDepthGet();
	
	obj.mc = new Array();
	obj.pos = new Array();
	obj.rot = param.rot;
	obj.rot_spd = param.rot_spd;
  	obj.pos[0] = Vec2dClone(param.pos);
 	obj.mc[0] = _root.sprite.createEmptyMovieClip("ame" + obj.depth.depth, obj.depth.depth);
	obj.mc[0]._x = obj.pos.x;
	obj.mc[0]._y = obj.pos.y;
	
	obj.num = param.num;
	var i;
	var m = Mtx33Rotate(obj.rot);
	for(i=1;i<obj.num + 1;i++){
 		obj.mc[i] = obj.mc[0].attachMovie("ame","_" + i, i);
		obj.pos[i] = Vec2dTransformVector (i * 20,0,m);
	}
	
	obj.mc[0]._x = obj.pos[0].x;
	obj.mc[0]._y = obj.pos[0].y;

	RotAmeExecute(obj);
}


/* --------------------------------------------------------------
	s
 -------------------------------------------------------------- */
function RotAmeExecute(obj){
	var i;
	
	obj.rot += obj.rot_spd;
	
	var m = Mtx33Rotate(obj.rot);
	for(i=0;i<obj.num;i++){
 		obj.pos[i+1] = Vec2dTransformVector (i * 12,0,m);
		RotAmeAttackCheck(obj,Vec2dAdd(obj.pos[i+1],obj.pos[0]));
		obj.mc[i+1]._x = Math.floor(obj.pos[i+1].x + 0.5);
		obj.mc[i+1]._y = Math.floor(obj.pos[i+1].y + 0.5);
	}


	AnmCmdPlay(obj.mc);
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
}


/* --------------------------------------------------------------
	j
 -------------------------------------------------------------- */
function RotAmeDelete(obj){

	EffectDepthPurge(obj.depth);
	if(obj.hittest)	HittestRemove(obj.hittest);
	
	obj.mc.removeMovieClip();
	obj.mc = null;

}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function RotAmeAttachScript(param,id,task){
	RotAmeTaskCreate(task,{
		pos : param.pos,
		num : param.num,
		rot : param.rot,
		rot_spd : param.rot_spd,
		id  : id
	});
}



/* --------------------------------------------------------------
	U`FbN
 -------------------------------------------------------------- */
function RotAmeAttackCheck(obj,pos){
	var rect = {
	x : -5,
	y : -5,
	w : 10,
	h : 10
	};

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var data = HITTEST_WORK[HITTEST_TYPE_PLAYER].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_ENEMY,obj.pos,obj.spd);
		}

		data = list;
	}
}
