/* -----------------------------------------------------------------------------
	W֐
	t@C  : jam.as
			: hakuhin (c) 2006/11/01
	
			: Wp֐
 ----------------------------------------------------------------------------- */

JAM_WIDTH = 16;
JAM_HEIGHT = JAM_WIDTH;
JAM_RADIUS = JAM_WIDTH / 2;


// J[e[u
JamGetTable = [
	{	// 01t[ 
		time:	30,	interpolate: true,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,196)
	},{
		time:	0,	interpolate: false,
		transform : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0)
	},{time: -1}
];


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function JamTaskCreate(task,param){
	return TaskCreate(
		JamInitalize,
		JamExecute,
		JamDelete,
		task,PRIO_STAGE,LEVEL_PLAYER,param
	);
}


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function JamGetTaskCreate(task,param){
	return TaskCreate(
		JamGetInitalize,
		JamExecute,
		JamDelete,
		task,PRIO_STAGE,LEVEL_PLAYER,param
	);
}

function JamInitalize(obj,task,param){
	obj.task = task;
	obj.depth = EnemyDepthGet();
    obj.mc = _root.sprite.attachMovie("jam","_" + obj.depth.depth, obj.depth.depth);
	obj.pos = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.id = param.id;

	var rect = {
		x : -JAM_RADIUS,
		y : -JAM_RADIUS,
		w : JAM_WIDTH,
		h : JAM_HEIGHT
	}
	obj.hittest = {pos : obj.pos,rect: rect,func:JamGetFunc,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_ITEM);

	obj.exec = JamStayInit;
}

function JamGetInitalize(obj,task,param){
	obj.task = task;
	obj.depth = EnemyDepthGet();
    obj.mc = _root.sprite.attachMovie("jam","_" + obj.depth.depth, obj.depth.depth);
	obj.pos = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.id = param.id;

	SePlay(SE_JAM_GET,obj.pos);
	if(Math.floor(Math.random() * 5) == 0){
		PopupMsgSet("jam_get");
	}

	obj.exec = JamGetInit;
}


function JamExecute(obj){
	obj.exec(obj);	// s

	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
}


function JamStayInit(obj){
	obj.exec = JamStayExec;
	obj.rot = 0;


	JamStayExec(obj);
}


function JamStayExec(obj){
	obj.rot += 5;
	if(obj.rot > 360)	obj.rot -= 360;
	obj.pos.y += Math.sin(obj.rot * Math.PI / 180) * 0.1;
}


function JamGetInit(obj){
	obj.exec = JamGetExec;
	obj.spd.y = -12;
	obj.count = 0;
	obj.color = ColorCreate(obj.mc);
	ColorTableSet(obj.color,JamGetTable,null);

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	JamGetExec(obj);
}


function JamGetExec(obj){
	obj.spd.y += 1;
	obj.pos = Vec2dAdd(obj.pos,obj.spd);
//	ColorExecute(obj.color);
	if(++obj.count > 20){
		ScoreSCreate(null,{pos : obj.pos,score : 100});
		TaskDelete(obj.task);
		JamGetEffectCreate(STAGE_TASK,ScreenPosition(obj.pos));
		return;
	}
}



function JamDelete(obj){
	
	EnemyDepthPurge(obj.depth);

	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}

	obj.mc.removeMovieClip();
}


function JamAttachScript(param,id,task){
	JamTaskCreate(task,{
		pos : param.pos,
		id  : id
	});
}


function JamGetFunc(obj,type){
	switch(type){
	case HITTEST_TYPE_PLAYER:
		JamGetEffectCreate(STAGE_TASK,ScreenPosition(obj.pos));
		STAGE_SCRIPT_WORK[obj.id] = 0;
		ScoreAdd(50);

		SePlay(SE_JAM_GET,obj.pos);
		if(Math.floor(Math.random() * 5) == 0){
			PopupMsgSet("jam_get");
		}

		PtcJamCreate(obj.pos);
		TaskDelete(obj.task);
		break;
	case HITTEST_TYPE_STAGE:
		STAGE_SCRIPT_WORK[obj.id] = 0;
		obj.exec = JamGetInit;
		break;
	}
}
