/* -----------------------------------------------------------------------------
	g}z[N֐
	t@C  : tomahawk.as
			: hakuhin (c) 2006/12/23
	
			: g}z[Np֐
 ----------------------------------------------------------------------------- */


TomahawkCollisionRect = {
		x : -10,
		y : -30,
		w :  20,
		h :  30
	};


/* --------------------------------------------------------------
	^XN
 -------------------------------------------------------------- */
function TomahawkTaskCreate(task,param){
	return TaskCreate(
		TomahawkInitalize,
		TomahawkExecute,
		TomahawkDelete,
		task,PRIO_STAGE,LEVEL_ANIM,param
	);
}


function TomahawkInitalize(obj,task,param){
	obj.task = task;
	obj.depth = EnemyDepthGet();
    obj.mc = _root.sprite.attachMovie("tomahawk","_" + obj.depth.depth, obj.depth.depth);
	obj.pos = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.id = param.id;
	
	// o^
	obj.hittest = {pos : obj.pos,rect: TomahawkCollisionRect,func:TomahawkHitPlayerCheck,param:obj};
	HittestAttach(obj.hittest,HITTEST_TYPE_ITEM);

	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
	
	obj.exec = null;
}


function TomahawkExecute(obj){
	obj.exec(obj);	// s


}


function TomahawkGoalInit(obj){
	obj.count = 0;
	obj.step = 0;
	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}

	obj.exec = TomahawkGoalExec;
	TomahawkGoalExec(obj);
}

function TomahawkGoalExec(obj){
	switch(obj.step){
	case 0:
		if(++ obj.count > 60){
			obj.count = 0
			obj.step = 1;
		}
		break;

	case 1:
		if(-- PlayerStatus.stage_time <= 0){
			obj.step = 2;
			obj.count = 0;
		}

		SoundPlay(SE_ADD,100,0,SOUND_PRIO_SE,false);
		ScoreAdd(100);
		TimeUpdate(TIME_TASK.obj);
		break;
		
	case 2:
		if(++ obj.count > 60){
			obj.exec = TomahawkTaraiFallInit;
		}

		break;
	}
}


function TomahawkTaraiFallInit(obj){
	ScrollData.flg |= SCROLL_FLG_CAMERA_FREE;

	obj.count = 0;
	obj.step = 0;

	obj.exec = TomahawkTaraiFallExec;
	TomahawkTaraiFallExec(obj);
}

function TomahawkTaraiFallExec(obj){
	ScrollData.pos.x -= (ScrollData.pos.x - AYU_TASK.obj.pos.x + GAME_WIDTH_HALF) * 0.05;

	switch(obj.step){
	case 0:
		if(++ obj.count > 60){
			obj.count = 0
			obj.step = 1;
			// ^C
			SePlay(SE_FALL,obj.pos);
			TaraiTaskCreate(STAGE_TASK,{pos: {x : AYU_TASK.obj.pos.x , y : -20} });
		}
		break;

	case 1:

		break;
	}
}


function TomahawkDelete(obj){
	EnemyDepthPurge(obj.depth);
	if(obj.hittest){
		HittestRemove(obj.hittest);
		obj.hittest = null;
	}
	obj.mc.removeMovieClip();
}


function TomahawkAttachScript(param,id,task){
	TomahawkTaskCreate(task,{
		pos : param.pos,
		id  : id
	});
}


// `FbN
function TomahawkHitPlayerCheck(obj){
	ScoreSCreate(null,{pos : obj.pos,score : 10000});

	// vC[d
	PLAYER_TASK.level = 0;
	PLAYER_TASK.obj.flg &= ~PLAYER_FLG_COLLISION;

	// Jړ
	AyuTaraiFunc();
	TimeStop();
//	TaskWork.level = LEVEL_ANIM;
	TomahawkGoalInit(obj);
	
	BgmPlay({
		ch : 0,
		id : BGM_COMP,
		roop : false,
		vol : 100,
		pan : 0
	});

}