/* -----------------------------------------------------------------------------
	⊮֐
	t@C  : interpolate.as
			: hakuhin (c) 2006/02/05
	
			: ⊮p֐
 ----------------------------------------------------------------------------- */
 
/* --------------------------------------
	d֐g1Ȑ(-l(x)^(1/(d-1)) +l(x)^(d+1))
	pr) A悤ȕ
	01 0.0`1.0
	02 -3.0 `3.0 炢
 -------------------------------------- */
function InterpolateDimension(x,d){
	var num = d + (d >= 0 ? 1 : -1);
	if(num < 0.0)	num = -1.0 / num;
	return Math.pow(x,num);
}


/* --------------------------------------
	hermite
	pr)Č悤ȕ
	01 0.0 ` 1.0
 -------------------------------------- */
function InterpolateHermite(d){
	return -2.0 * (d * d * d) + 3.0 * (d * d);
}

/* --------------------------------------
	colorTransform⊮
	01 1ڂ̃J[gXtH[
	02 2ڂ̃J[gXtH[
	03 0.0 ` 1.0
 -------------------------------------- */
function InterpolateColorTransform(color1,color2,d){
 	return new flash.geom.ColorTransform(
		(color2.redMultiplier	 - color1.redMultiplier		) * d + color1.redMultiplier	,
		(color2.greenMultiplier	 - color1.greenMultiplier	) * d + color1.greenMultiplier	,
		(color2.blueMultiplier	 - color1.blueMultiplier	) * d + color1.blueMultiplier	,
		(color2.alphaMultiplier	 - color1.alphaMultiplier	) * d + color1.alphaMultiplier	,
		(color2.redOffset		 - color1.redOffset			) * d + color1.redOffset		,
		(color2.greenOffset		 - color1.greenOffset		) * d + color1.greenOffset		,
		(color2.blueOffset		 - color1.blueOffset		) * d + color1.blueOffset		,
		(color2.alphaOffset		 - color1.alphaOffset		) * d + color1.alphaOffset
	);
}