/* -----------------------------------------------------------------------------
	QcxNg֐
	t@C	:	vec2d.as
	as.Ver		:	Flash 5 ȍ~
			:	Hakuhin	(C)	2006/01/31
 ----------------------------------------------------------------------------- */

/* -----------------------------------------------------------------------------

	--------------------------------------
	xNǧ^

	vec = {
		x : 0,	y : 0
	};
	--------------------------------------

	QcxNgIuWFNg`ŕ\Ă܂B
	x  x ̐A y  y̐łB

	--------------------------------------
	֐ꗗ

	function Vec2dCreate(x, y);					// QcxNg쐬	
	function Vec2dClone(vec);					// QcxNg
	function Vec2dAdd(vec1, vec2);				// QcxNgZ
	function Vec2dSub(vec1, vec2);				// QcxNgZ
	function Vec2dScale(vec, scale);			// QcxNgZ
	function Vec2dDotProduct(vec1, vec2);		// QcxNgm̓
	function Vec2dPerp(vec1, vec2);				// QcxNgɐȂQcxNg
	function Vec2dLength(vec);					// QcxNg̒
	function Vec2dNormalize (vec);				// QcxNg̐K
	function Vec2dRandom(s);					// _ȂQcxNg쐬
	function Vec2dGetReflectVector(spd,normal);	// ˂QcxNg
	function Vec2dGetSlideVector(spd,normal);	// ׂQcxNg
	--------------------------------------

 ----------------------------------------------------------------------------- */


/* ------------------------------------------------------------------- 
	xNg쐬
	01	x 
	02	y 
	Ԃl		xNgiIuWFNgj

	(gp)
	var 	vec = _root.Vec2dCreate(10,5);
 ------------------------------------------------------------------- */
function Vec2dCreate(x,y){
	return {
		x : x,
		y : y
	};
}


/* ------------------------------------------------------------------- 
	xNg
	01	xNg
	Ԃl		xNgiIuWFNgj

	(gp)
	var 	vec1 = _root.Vec2dCreate(10,5);
	var 	vec2 = _root.Vec2dClone(vec1);
 ------------------------------------------------------------------- */
function Vec2dClone(vec){
	return {
		x : vec.x,
		y : vec.y
	};
}


/* ------------------------------------------------------------------- 
	xNgZ
	01	Pڂ̃xNg
	02	Qڂ̃xNg
	Ԃl		xNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec2dCreate(10,5);
	var vec2 = _root.Vec2dCreate(20,-7);	
	var vec3 = _root.Vec2dAdd(vec1,vec2);
 ------------------------------------------------------------------- */
function Vec2dAdd( vec1, vec2 ){
	return {
		x : vec1.x + vec2.x,
		y : vec1.y + vec2.y
	};
}


/* ------------------------------------------------------------------- 
	xNgZ
	01	Pڂ̃xNg
	02	Qڂ̃xNg
	Ԃl		xNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec2dCreate(10,5);
	var vec2 = _root.Vec2dCreate(20,-7);	
	var vec3 = _root.Vec2dSub(vec1,vec2);
 ------------------------------------------------------------------- */
function Vec2dSub( vec1, vec2 ){
	return {
		x : vec1.x - vec2.x,
		y : vec1.y - vec2.y
	};
}


/* ------------------------------------------------------------------- 
	XJlŏZ
	01	xNg
	02	{
	Ԃl		xNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec2dCreate(10,5);	
	var vec2 = _root.Vec2dScale(vec1,2);
 ------------------------------------------------------------------- */
function Vec2dScale( vec, scale ){
	return {
		x : vec.x * scale,
		y : vec.y * scale
	};
}


/* ------------------------------------------------------------------- 
	
	01	Pڂ̃xNg
	02	Qڂ̃xNg
	Ԃl		

	(gp)
	var vec1 = _root.Vec2dCreate(10,5);
	var vec2 = _root.Vec2dCreate(20,-7);
	var dot = _root.Vec2dDotProduct(vec1,vec2);
 ------------------------------------------------------------------- */
function Vec2dDotProduct( vec1, vec2 ){
	return (vec1.x * vec2.x) + (vec1.y * vec2.y);
}


/* ------------------------------------------------------------------- 
	ȃxNg
	01	xNg
	Ԃl		xNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec2dCreate(10,5);
	var vec2 = _root.Vec2dPerp(vec1);
 ------------------------------------------------------------------- */
function Vec2dPerp( vec ){
	return {
		x : -vec.y,
		y : vec.x
	};
}


/* ------------------------------------------------------------------- 
	xNg̒
	01	𒲂ׂxNg
	Ԃl		

	(gp)
	var vec1 = _root.Vec2dCreate(10,5);	
	var length = _root.Vec2dLength(vec1);
 ------------------------------------------------------------------- */
function Vec2dLength( vec ){
	return Math.sqrt((vec.x * vec.x) + (vec.y * vec.y));
}


/* ------------------------------------------------------------------- 
	xNg̐K
	01	KxNg
	Ԃl		KꂽxNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec2dCreate(10,5);
	var vec2 = _root.Vec2dNormalize(vec1);
 ------------------------------------------------------------------- */
function Vec2dNormalize ( vec ){
   var length = Math.sqrt((vec.x * vec.x) + (vec.y * vec.y));
	if(length > 0)	length = 1 / length;
	return {
		x : vec.x * length,
		y : vec.y * length
	};
}


/* ------------------------------------------------------------------- 
	_ȃxNg쐬
	01	XJl
	Ԃl		xNgiIuWFNgj

	(gp)
	var vec = _root.Vec2dRandom(1);
 ------------------------------------------------------------------- */
function Vec2dRandom(s){
	var x,y;
	for(;;){
		x = Math.random() - 0.5;
		y = Math.random() - 0.5;
		if(x * x + y * y != 0)	break;
	}
	var length = Math.sqrt((x * x) + (y * y));
	if(length > 0)	length = 1 / length;
	return {
		x : x * length * s,
		y : y * length * s
	};
}


// ----------------------------
// ˃xNg߂
//
// 01	xNg
// 02	nʂ̖@
// Ԃl	˃xNg
// ----------------------------
function Vec2dGetReflectVector(spd,normal){
	var t = -(normal.x * spd.x + normal.y * spd.y)/(normal.x * normal.x + normal.y * normal.y);
	return {
		x : spd.x + t * normal.x * 2.0,
		y : spd.y + t * normal.y * 2.0
	};
}

// ----------------------------
// xNg
//
// 01	xNg
// 02	nʂ̖@
// Ԃl	xNg
// ----------------------------
function Vec2dGetSlideVector(spd,normal){
	var t = -(normal.x * spd.x + normal.y * spd.y)/(normal.x * normal.x + normal.y * normal.y);
	return {
		x : spd.x + t * normal.x,
		y : spd.y + t * normal.y
	};
}