/* -----------------------------------------------------------------------------
	IvV֐
	t@C  : option.as
			: hakuhin (c) 2006/10/31
	
			: IvV\
 ----------------------------------------------------------------------------- */


GameInfo = {
	dialog : 0,
	fps : 1,
	vsync : 0,
	frame_skip : 1
}


OptionTiyakiPos = [
[
	{x: 40.0 - 15	,y:62.0},
	{x:410.0 + 15	,y:62.0}
],[
	{x: 40.0 - 15	,y:88.0},
	{x:410.0 + 15	,y:88.0}
],[
	{x: 40.0 - 15	,y:114.0},
	{x:410.0 + 15	,y:114.0}
],[
	{x: 40.0 - 15	,y:140.0},
	{x:410.0 + 15	,y:140.0}
],[
	{x:142.0 - 35	,y:176.0},
	{x:308.0 + 35	,y:176.0}
],[
	{x:175.0 - 35	,y:206.0},
	{x:272.0 + 35	,y:206.0}
],[
	{x:163.0 - 35	,y:236.0},
	{x:287.0 + 35	,y:236.0}
],[
	{x:193.0 - 35	,y:286.0},
	{x:258.0 + 35	,y:286.0}
]
];


OptionSwitchPos = [
[
	{x:276.0 - 18	,y:52.0},
	{x:347.0 - 18	,y:52.0}
],[
	{x:276.0 - 18	,y:78.0},
	{x:347.0 - 18	,y:78.0}
],[
	{x:276.0 - 18	,y:104.0},
	{x:347.0 - 18	,y:104.0}
],[
	{x:276.0 - 18	,y:130.0},
	{x:347.0 - 18	,y:130.0}
]
];

/* --------------------------------
	^XN
 -------------------------------- */
function OptionCreate(task,param){
	return TaskCreate(
		OptionInitalize,
		OptionExecute,
		OptionDelete,
		task,PRIO_SCROLL,LEVEL_PAUSE,param
	);
}


// ʏ
function OptionInitalize(obj,task,param){
	KeyClear();

	obj.y = param;
	obj.task = task;

	obj.back = new Array();
	obj.back[0] = _root.attachMovie("back3",  "b1",  0);
	obj.back[1] = _root.attachMovie("jam_illust",  "b2",  1);
	obj.back[1]._x = 40;
	obj.back[1]._y = 20;
	obj.back[2] = _root.attachMovie("option", "b3",  2);
	obj.mc = new Array();
	obj.mc[0] = _root.attachMovie("nayuki",  "m1",  10);
	obj.mc[1] = _root.attachMovie("akiko", 	 "m2",  11);
	obj.mc[0]._x = -20;
	obj.mc[1]._x = SCREEN_WIDTH + 20;
	obj.mc[0]._y = OptionTiyakiPos[obj.y][0].y;
	obj.mc[1]._y = OptionTiyakiPos[obj.y][1].y;
	AnmCmdInit(obj.mc[0]);
	AnmCmdInit(obj.mc[1]);


	obj.mc[1]._xscale = -100;
	PtcSnowTitleCreate({x:0,y:0},task);

	obj.rot = 0;

	var i;
	for(i=0;i<4;i++){
		obj.mc[2 + i] = _root.attachMovie("zanki",  "z" + (20 + i),  20 + i);
	}

	obj.mc[2]._x = OptionSwitchPos[0][GameInfo.dialog].x;
	obj.mc[2]._y = OptionSwitchPos[0][GameInfo.dialog].y;
	obj.mc[3]._x = OptionSwitchPos[1][GameInfo.fps].x;
	obj.mc[3]._y = OptionSwitchPos[1][GameInfo.fps].y;
	obj.mc[4]._x = OptionSwitchPos[2][GameInfo.frame_skip].x;
	obj.mc[4]._y = OptionSwitchPos[2][GameInfo.frame_skip].y;
	obj.mc[5]._x = OptionSwitchPos[3][GameInfo.vsync].x;
	obj.mc[5]._y = OptionSwitchPos[3][GameInfo.vsync].y;
	
	if(obj.y == 0){
		BlackFadeInCreate(null,null);
	}else{
		BlurFadeInCreate(null,null);
	}
}


// ʏ
function OptionExecute(obj){
	AnmCmdPlay(obj.mc[0]);
	AnmCmdPlay(obj.mc[1]);

	if(KeyData[0].Menu & KEY_UP){
		SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		obj.y --;
	}
	if(KeyData[0].Menu & KEY_DOWN){
		obj.y ++;
		SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
	}
	if(obj.y > 7)			obj.y -= 8;
	else if(obj.y < 0)		obj.y += 8;

	switch(obj.y){
	case 0:
		if(KeyData[0].Trg & KEY_LEFT){
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
			GameInfo.dialog --;
		}
		if(KeyData[0].Trg & KEY_RIGHT){
			GameInfo.dialog ++;
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		}
		if(GameInfo.dialog >= 2)		GameInfo.dialog -= 2;
		if(GameInfo.dialog <  0)		GameInfo.dialog += 2;
		break;
	case 1:
		if(KeyData[0].Trg & KEY_LEFT){
			GameInfo.fps --;
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		}
		if(KeyData[0].Trg & KEY_RIGHT){
			GameInfo.fps ++;
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		}
		if(GameInfo.fps >= 2)			GameInfo.fps -= 2;
		if(GameInfo.fps <  0)			GameInfo.fps += 2;
		
		if(KeyData[0].Trg & (KEY_LEFT | KEY_RIGHT)){
			switch(GameInfo.fps){
			case 0:	BenchMarkOn();	break;
			case 1:	BenchMarkOff();	break;
			}
		}
		break;
	case 2:
		if(KeyData[0].Trg & KEY_LEFT){
			GameInfo.frame_skip --;
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		}
		if(KeyData[0].Trg & KEY_RIGHT){
			GameInfo.frame_skip ++;
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		}
		if(GameInfo.frame_skip >= 2)	GameInfo.frame_skip -= 2;
		if(GameInfo.frame_skip <  0)	GameInfo.frame_skip += 2;
		if(KeyData[0].Trg & (KEY_LEFT | KEY_RIGHT)){
			switch(GameInfo.frame_skip){
			case 0:	FrameSkipOn();	break;
			case 1:	FrameSkipOff();	break;
			}
		}
		break;
	case 3:
		if(KeyData[0].Trg & KEY_LEFT){
			GameInfo.vsync --;
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		}
		if(KeyData[0].Trg & KEY_RIGHT){
			GameInfo.vsync ++;
			SoundPlay(SE_MENU_SEL,100,0,SOUND_PRIO_SE,false);
		}
		if(GameInfo.vsync >= 2)			GameInfo.vsync -= 2;
		if(GameInfo.vsync <  0)			GameInfo.vsync += 2;
		
		if(KeyData[0].Trg & (KEY_LEFT | KEY_RIGHT)){
			switch(GameInfo.vsync){
			case 0:	VSyncOn();	break;
			case 1:	VSyncOff();	break;
			}
		}
		break;
	case 4:
		if(KeyData[0].Trg & KEY_A){
			KeyData[0].Trg &= ~KEY_A;
			BlurFadeOutCreate(null , {func : NextKeyConfigFunc , param : obj});
			SoundPlay(SE_MENU_OK,100,0,SOUND_PRIO_SE,false);
			return;
		}
		break;
	case 5:
		if(KeyData[0].Trg & KEY_A){
			KeyData[0].Trg &= ~KEY_A;
			BlurFadeOutCreate(null , {func : NextSoundFunc , param : obj});
			SoundPlay(SE_MENU_OK,100,0,SOUND_PRIO_SE,false);
			return;
		}
		break;
	case 6:
		if(KeyData[0].Trg & KEY_A){
			KeyData[0].Trg &= ~KEY_A;
			BlurFadeOutCreate(null , {func : NextRankFunc , param : obj});
			SoundPlay(SE_MENU_OK,100,0,SOUND_PRIO_SE,false);
			return;
		}
		break;
	case 7:
		if(KeyData[0].Trg & KEY_A){
			KeyData[0].Trg &= ~KEY_A;
			BlackFadeOutCreate(null , {func : BackTitleFunc , param : obj});
			SoundPlay(SE_MENU_OK,100,0,SOUND_PRIO_SE,false);
			return;
		}
		break;
	}


	obj.rot += 10;
	obj.mc[0]._x += (OptionTiyakiPos[obj.y][0].x + Math.sin(obj.rot * Math.PI / 180) * 3 - obj.mc[0]._x) * 0.5;
	obj.mc[1]._x += (OptionTiyakiPos[obj.y][1].x - Math.sin(obj.rot * Math.PI / 180) * 3 - obj.mc[1]._x) * 0.5;
	obj.mc[0]._y += (OptionTiyakiPos[obj.y][0].y - obj.mc[0]._y) * 0.5;
	obj.mc[1]._y += (OptionTiyakiPos[obj.y][1].y - obj.mc[1]._y) * 0.5;
	
	
	var i;
	for(i=0;i<4;i++){
		obj.mc[2 + i]._rotation += 3;
	}
	
	obj.mc[2]._x -= (obj.mc[2]._x - OptionSwitchPos[0][GameInfo.dialog].x) * 0.5;
	obj.mc[3]._x -= (obj.mc[3]._x - OptionSwitchPos[1][GameInfo.fps].x) * 0.5;
	obj.mc[4]._x -= (obj.mc[4]._x - OptionSwitchPos[2][GameInfo.frame_skip].x) * 0.5;
	obj.mc[5]._x -= (obj.mc[5]._x - OptionSwitchPos[3][GameInfo.vsync].x) * 0.5;

}

function OptionDelete(obj){
	var i;
	var num = obj.mc.length;
	for(i=0;i<num;i++){
		obj.mc[i].removeMovieClip();
	}
	
	num = obj.back.length;
	for(i=0;i<num;i++){
		obj.back[i].removeMovieClip();
	}
	
	LocalSave();	// ݒۑ
}



function NextKeyConfigFunc(obj){
	TaskDelete(obj.task);
	KeyConfigCreate(null,0);
}

function NextSoundFunc(obj){
	TaskDelete(obj.task);
	SoundMenuCreate(null,0);
}

function NextRankFunc(obj){
	TaskDelete(obj.task);
	RankMenuCreate(null,0);
}

function BackTitleFunc(obj){
	TaskDelete(obj.task);
	TitleCreate(null,1);
}