/* -----------------------------------------------------------------------------
	֐
	t@C  : ryousyo.as
			: hakuhin (c) 2006/10/30
	
			: vC[p̋ʓ܂Ƃ߂֐
 ----------------------------------------------------------------------------- */

RYOUSYO_WIDTH		=  14;					// TCY
RYOUSYO_RADIUS		=  RYOUSYO_WIDTH / 2;	// a
RYOUSYO_JUMP_POWER	=  4;					// Wv
RYOUSYO_MOVE_SPD	=  6;					// ړx
RYOUSYO_G			=  0.5;					// d
RYOUSYO_JUMP_MAX	=  10;					// Wvő

RYOUSYO_TASK = null;

RyousyoRect = {
	x : -RYOUSYO_RADIUS,
	y : -RYOUSYO_RADIUS,
	w :  RYOUSYO_WIDTH,
	h :  RYOUSYO_WIDTH
};
	
/* --------------------------------
	Ǘ}l[W
 -------------------------------- */
function RyousyoMngCreate(task,param){
	return RYOUSYO_TASK = TaskCreate(
		RyousyoMngInitalize,
		RyousyoMngExecute,
		RyousyoMngDelete,
		task,PRIO_PLAYER_ITEM,LEVEL_PLAYER,param
	);
}

function RyousyoMngInitalize(obj,task,param){
	obj.task = task;
	obj.id = [false,false];
}

function RyousyoMngExecute(obj){

}

function RyousyoMngDelete(obj){
	RYOUSYO_TASK = null;
}



/* --------------------------------
	{
 -------------------------------- */
function RyousyoCreate(task){
	var mng = RYOUSYO_TASK.obj;
	if(mng == null)	return;

	var i;
	var id = mng.id;
	for(i=0;i<id.length;i++){
		if(id[i] == false)	break;
	}
	
	if(i == id.length)	return;
	id[i] = true;

	return TaskCreate(
		RyousyoInitalize,
		RyousyoExecute,
		RyousyoDelete,
		task,PRIO_PLAYER_ITEM,LEVEL_PLAYER,i
	);
}

function RyousyoInitalize(obj,task,param){
	obj.task = task;
	obj.id = param;
	var depth = DEPTH_RYOUSYO + param * 50;

	obj.mc = _root.sprite.attachMovie("ryousyo","ryousyo" + param ,depth);
	// Aj[VXV
	AnmCmdInit(obj.mc);
	obj.mc.ANM_GOTO = "_type" + param;

	// vC[^XN
	var player = task.parent.obj;
	
	// ʒu
	obj.pos = Vec2dClone(player.pos);
	obj.pos.x += player.dir * 5;
	obj.pos.y += -25;
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);
	
	// 
	obj.spd = Vec2dCreate(player.dir * RYOUSYO_MOVE_SPD,RYOUSYO_JUMP_POWER);

	var order = {
		depth : depth - 10,		// [x(֋OՐgp
		num   : 3,		// OՐ
		rist  : 1,		// 
		mc    : obj.mc,	// ǔf
		start : new flash.geom.ColorTransform(1,1,1,0,0,0,0,64),	// JnJ[
		end   : new flash.geom.ColorTransform(1,1,1,0,0,0,0,0),		// IJ[
		blend : 0
	};
	ChaseTaskCreate(task,order);

}

function RyousyoExecute(obj){

	obj.spd.y += RYOUSYO_G;
	if(obj.spd.y > RYOUSYO_JUMP_MAX)	obj.spd.y = RYOUSYO_JUMP_MAX;

	// n``FbN
	if(RyousyoCollisionCheck(obj)){
		TaskDelete(obj.task);
		return;
	}


	obj.pos = Vec2dAdd(obj.pos,obj.spd);
	
	if(RyousyoAttackCheck(obj)){
		TaskDelete(obj.task);
		return;
	}
	
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);


	var vec = ScreenPosition(obj.pos);

	// Aj[VXV
	AnmCmdPlay(obj.mc);
	
	// ʊO
	var check = false;
	if(vec.x <-RYOUSYO_WIDTH)					check = true;
	if(vec.x > RYOUSYO_WIDTH + GAME_WIDTH)		check = true;
	if(vec.y <-RYOUSYO_WIDTH)					check = true;
	if(vec.y > RYOUSYO_WIDTH + GAME_HEIGHT)		check = true;
	if(check){
		TaskDelete(obj.task);
		return;
	}
}

function RyousyoDelete(obj){
	RYOUSYO_TASK.obj.id[obj.id] = false;
	obj.mc.removeMovieClip();
}



// RW`FbN
/*
function RyousyoCollisionCheck(obj){
	var MAX_LENGTH = RYOUSYO_JUMP_MAX;
	
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = RyousyoRect;

	// YZN^
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 1;
	var j_min = Math.floor(pos.y / COLLISION_SECTOR_HEIGHT) - 1;
	var i_max = i_min + 3;
	var j_max = j_min + 3;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;

	

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				if(r1 < l2){
				}else if(r2 < l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{

					// Ɉړ
					if(spd.y > 0){
						// ubN̏[
						if(m1 - t2 <= MAX_LENGTH){
							pos.y = t2 - rect.y - rect.h;  // ɕ␳
							obj.spd.y = -RYOUSYO_JUMP_POWER;
							return true;
						}
					}
					
					PtcRyousyoCreate(obj.pos);
					return false;
				}

				data = data.post;
			}
		}
	}
	
	
	return true;
}
*/
// n``FbN
function RyousyoCollisionCheck(obj){
	
	var pos = obj.pos;
	var spd = obj.spd;
	var rect = RyousyoRect;

	// YZN^
	var vec = Vec2dClone(pos);
	var check = false;	// nʂɍڂ
	var check2 = false;	// ㉺n`X[邩
	var check3 = false;	// Vɓ
	var check4 = false;	// ǂɓ
	var i_min = Math.floor(pos.x / COLLISION_SECTOR_WIDTH)  - 2;
	var j_min = Math.floor((pos.y - 20) / COLLISION_SECTOR_HEIGHT) - 2;
	var i_max = i_min + 4;
	var j_max = j_min + 4;
	var i,j;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var t3 = 0x7FFFFFFF;
	var m3 =-0x7FFFFFFF;
	var l3 = 0x7FFFFFFF;
	var r3 =-0x7FFFFFFF;
	
	var speed = Vec2dCreate(0,0);

	var PL_Y_LENGTH = 2;
	
	
	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH + 2;
				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;
				
				if(r1 < l2){
				}else if(r2 < l1){
				}else if(m1 < t2){
				}else if(m2 < t1){
				}else{

					if(t2 < t3)	t3 = t2;
					if(m2 > m3)	m3 = m2;
					
					
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							if(m1 - t2 < MAX_Y_LENGTH){
								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}

					// Ɉړ
					}
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
						}
					}

				}

				data = data.post;
			}
		}
	}

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){

			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;
				
				var MAX_Y_LENGTH = Math.abs(spd.y) + Math.abs(data.param.spd.y) + PL_Y_LENGTH;
				
				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{
					if(data.type == COLLISION_TYPE_FOOT){
						if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
							// ubN̏[
							
							if(m1 - t2 < MAX_Y_LENGTH){

								speed.y +=  data.param.spd.y;

								var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
								if(vec.y > y){
									vec.y = y;
									if(!data.param.spd.y){
										speed.y = 0;
									}
								}

								check = true;

								if(l2 < l3)	l3 = l2;
								if(r3 < r2)	r3 = r2;

								// `Abvf[g
								l1 = rect.x + vec.x;
								t1 = rect.y + vec.y;
								r1 = l1 + rect.w;
								m1 = t1 + rect.h;
								
							}
						}
						data = data.post;
						continue;
					}

					// Ɉړ
					if(spd.y + Math.abs(data.param.spd.y) >= -0.001){
						// ubN̏[
						if(m1 - t2 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = t2 - rect.y - rect.h - 0.001;  // ɕ␳
							if(vec.y > y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							check = true;
							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;
							
						}
					}

					// Ɉړ
					if(spd.y - Math.abs(data.param.spd.y) <= 0.001){
						// ubN̉[
						if(m2 - t1 < MAX_Y_LENGTH){

							speed.y +=  data.param.spd.y;

							var y = m2 - rect.y + 0.001; 			// ɕ␳
							if(vec.y < y){
								vec.y = y;
								if(!data.param.spd.y){
									speed.y = 0;
								}
							}

							if(l2 < l3)	l3 = l2;
							if(r3 < r2)	r3 = r2;

							check3 = true;


						}
					}

					PL_Y_LENGTH += Math.abs(data.param.spd.y);
					//vec = Vec2dAdd(vec,data.param.spd);
					//speed = Vec2dAdd( speed , data.param.spd);

					// `Abvf[g
					l1 = rect.x + vec.x;
					t1 = rect.y + vec.y;
					r1 = l1 + rect.w;
					m1 = t1 + rect.h;

				}

				data = data.post;
			}
		}
	}

	// `Abvf[g
	l1 = rect.x + vec.x;
	t1 = rect.y + vec.y;
	r1 = l1 + rect.w;
	m1 = t1 + rect.h;

	for(j=j_min;j<j_max;j++){
		for(i = i_min;i < i_max;i++){
			
			if(COLLISION_WORK[j][i] == null)	continue;
			var data = COLLISION_WORK[j][i].start.post;
			while(true){
				if(data.post == null)	break;

				if(data.type == COLLISION_TYPE_FOOT){
					data = data.post;
					continue;
				}

				var b_rect = data.rect;
				var b_pos  = data.pos;

				var l2 = b_rect.x + b_pos.x;
				var t2 = b_rect.y + b_pos.y;
				var r2 = l2 + b_rect.w;
				var m2 = t2 + b_rect.h;

				var MAX_X_LENGTH = Math.abs(spd.x) + Math.abs(data.param.spd.x) + 1;

				if(r1 <= l2){
				}else if(r2 <= l1){
				}else if(m1 <= t2){
				}else if(m2 <= t1){
				}else{

					// EɈړ
					if(spd.x - Math.abs(data.param.spd.x) >= -0.001){
						// ubN̍[
						
						if(r1 - l2 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = l2 - rect.x - rect.w - 0.001;  // ɕ␳
							if(vec.x > x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(l2 == l3){
								check2 = true;
							}
							check4 = 1;
							spd.x = 0;
							
						}
					}

					// Ɉړ
					if(spd.x - Math.abs(data.param.spd.x) <= 0.001){
						// ubN̉E[
						if(r2 - l1 <= MAX_X_LENGTH){

							// xf
							speed.x += data.param.spd.x;

							var x = r2 - rect.x + 0.001;  // Eɕ␳
							if(vec.x < x){
								vec.x = x;
								if(!data.param.spd.y){
									speed.x = 0;
								}
							}

							if(r2 == r3){
								check2 = true;
							}
							check4 = 2;
							spd.x = 0;

						}
					}
				}

				data = data.post;
			}
		}
	}

	vec = Vec2dAdd(speed,vec);
	pos.x = vec.x;


	// ǐڐG
	if(check4){
		PtcRyousyoCreate(pos);
		return true;
	}

	// ǖ
	if(check2){
		return false;
	}
	
	
	pos.y = vec.y;

	// V
	if(check3){
		PtcRyousyoCreate(pos);
		return true;
	}

	// n
	if(check){
		// Ɉړ
		if(spd.y > 0){
			// ubN̏[
//			if(m1 - t2 <= MAX_LENGTH){
//				pos.y = t2 - rect.y - rect.h;  // ɕ␳
				obj.spd.y = -RYOUSYO_JUMP_POWER;
//			}
		}
	}

	return false;
}



/* --------------------------------------------------------------
	U`FbN
 -------------------------------------------------------------- */
function RyousyoAttackCheck(obj){
	var pos = obj.pos;
	// TCY
	var rect = RyousyoRect;

	var l1 = rect.x + pos.x;
	var t1 = rect.y + pos.y;
	var r1 = l1 + rect.w;
	var m1 = t1 + rect.h;

	var vec = Vec2dCreate(pos.x + RYOUSYO_RADIUS,pos.y + RYOUSYO_RADIUS);


	var data = HITTEST_WORK[HITTEST_TYPE_ENEMY].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_PLAYER_ITEM,vec,obj.spd);
			PtcRyousyoCreate(obj.pos);

			return true;
		}

		data = list;
	}
	
	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_PLAYER_ITEM,vec,obj.spd);
			PtcRyousyoCreate(obj.pos);

			return true;
		}

		data = list;
	}
	
	var data = HITTEST_WORK[HITTEST_TYPE_TURTLE_ATT].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_PLAYER_ITEM,vec,obj.spd);
			PtcRyousyoCreate(obj.pos);

			return true;
		}

		data = list;
	}

	var data = HITTEST_WORK[HITTEST_TYPE_BOSS].start.post;
	while(true){
		var list = data.post;
		if(data.post == null)	break;

		var b_rect = data.rect;
		var b_pos  = data.pos;

		var l2 = b_rect.x + b_pos.x;
		var t2 = b_rect.y + b_pos.y;
		var r2 = l2 + b_rect.w;
		var m2 = t2 + b_rect.h;

		if(r1 < l2){
		}else if(r2 < l1){
		}else if(m1 < t2){
		}else if(m2 < t1){
		}else{
			data.func(data.param,HITTEST_TYPE_PLAYER_ITEM,vec,obj.spd);
			PtcRyousyoCreate(obj.pos);

			return true;
		}

		data = list;
	}
	
	return false;
}




