/* -----------------------------------------------------------------------------
	]֐
	t@C  : block_rot_foot.as
			: hakuhin (c) 2006/11/26
	
			: ړ
 ----------------------------------------------------------------------------- */



/* --------------------------------
	^XN
 -------------------------------- */
function BlockRotFootCreate(task,param){
	return TaskCreate(
		BlockRotFootInitalize,
		BlockRotFootExecute,
		BlockRotFootDelete,
		task,PRIO_STAGE,LEVEL_STAGE,param
	);
}


// ʏ
function BlockRotFootInitalize(obj,task,param){
	obj.task = task;
	
	obj.num = param.num;
	obj.pos = Vec2dClone(param.pos);
	obj.fpos = Vec2dClone(param.pos);
	obj.base = Vec2dClone(param.pos);
	obj.x_len = param.x_len;
	obj.y_len = param.y_len;
	obj.x_rot = param.x_rot;
	obj.y_rot = param.y_rot;
	obj.x_add = param.x_add;
	obj.y_add = param.y_add;
		
		
	
	obj.depth = BlockDepthGet();

	// [N쐬
	obj.mc = _root.sprite.createEmptyMovieClip("_" + obj.depth.depth, obj.depth.depth);
	
	var i;
	var w = obj.num * 20;
	var rect = {
		x :  -10,
		y :  -10,
		w :  20,
		h :  20
	};
	
	obj.collision = new Array();
	for(i=0;i<obj.num;i++){
		var mc = obj.mc.attachMovie(param.asset,"_" + i, i);
		mc._x = -(w / 2) + 10 * i + 5;
		
		var pos = {x : -(w / 2) + 10 * i + 5 + obj.pos.x, y : obj.pos.y}

		// RWo^
		obj.collision[i] = {pos : pos,rect: rect,type : COLLISION_TYPE_FOOT,func : null,param : obj};
		CollisionAttach(obj.collision[i]);
	}
	
	BlockRotFootExecute(obj);
}


// ʏ
function BlockRotFootExecute(obj){


	
	obj.x_rot += obj.x_add;
	if(obj.x_rot > 360)	obj.x_rot -= 360;
	if(obj.x_rot < 0)	obj.x_rot += 360;
	obj.y_rot += obj.y_add;
	if(obj.y_rot > 360)	obj.y_rot -= 360;
	if(obj.y_rot < 0)	obj.y_rot += 360;
	
	obj.pos.x = Math.sin(obj.x_rot * Math.PI / 180)	* obj.x_len;
	obj.pos.y = Math.sin(obj.y_rot * Math.PI / 180)	* obj.y_len;

	var i;
	var w = obj.num * 10;
	for(i=0;i<obj.num;i++){
		// RWo^XV
		CollisionRemove(obj.collision[i]);
		obj.collision[i].pos = {x : -(w / 2) + 10 * i + 5 + obj.fpos.x, y : obj.fpos.y};
		CollisionAttach(obj.collision[i]);
	}

	obj.spd = Vec2dSub(obj.pos,obj.fpos);
	obj.fpos = Vec2dClone(obj.pos);

	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);

}


function BlockRotFootDelete(obj){
	var i;
	for(i=0;i<obj.num;i++){
		CollisionRemove(obj.collision[i]);
	}
	BlockDepthPurge(obj.depth);
	obj.mc.removeMovieClip();
}


function BlockRotFootAttachScript(param,id,task){
	BlockRotFootCreate(task,{
		pos : param.pos,
		num : param.num,
		x_len : param.x_len,
		y_len : param.y_len,
		x_rot : param.x_rot,
		y_rot : param.y_rot,
		x_add : param.x_add,
		y_add : param.y_add,
		asset : param.asset
	});
}