/* -----------------------------------------------------------------------------
	wiʊ֐
	t@C  : stage.as
			: hakuhin (c) 2006/11/05
	
			: wi̋ʓ܂Ƃ߂֐
 ----------------------------------------------------------------------------- */

STAGE_RAYER_NUM = 7;		// Xe[WC[
STAGE_WORK = null;
STAGE_TASK = null;
STAGE_FREE_HEIGHT	= 40;	// XN[Ƃ荂
STAGE_END_WIDTH		= 130;	// XN[[̕

// C[
StageRayerName = [
//	"status",
	"front_rayer3",
	"front_rayer2",
	"front_rayer1",
	"sprite",
	"back_rayer3",
	"back_rayer2",
	"back_rayer1"
];

// C[[x
StageRayerDepth = [
//	DEPTH_STATUS,
	DEPTH_FRONT_RAYER3,
	DEPTH_FRONT_RAYER2,
	DEPTH_FRONT_RAYER1,
	DEPTH_SPRITE,
	DEPTH_BACK_RAYER3,
	DEPTH_BACK_RAYER2,
	DEPTH_BACK_RAYER1
];

STAGE_WARP_EMPTY = 0;
STAGE_WARP_NEXT = 1;
STAGE_WARP_WORLD = 2;


function StageTaskCreate(task,param){
	return TaskCreate(
		StageInitalize,
		StageExecute,
		StageDelete,
		task,PRIO_SOUND,LEVEL_STAGE,param
	);
	
	
}

function StageInitalize(obj,task,param){
	STAGE_TASK = task;
	obj.task = task;
	ScrollData.flg = 0;
	ScrollData.cen = Vec2dCreate(GAME_WIDTH_HALF,GAME_HEIGHT_HALF);

	STAGE_WORK = new Object();
	for(i=0;i<STAGE_RAYER_NUM;i++){
		STAGE_WORK[i] = {
			mc : _root.createEmptyMovieClip(StageRayerName[i] ,StageRayerDepth[i]),
			sx : 1,
			sy : 1
		};
		
		STAGE_WORK[i].mc._xscale = 100;
		STAGE_WORK[i].mc._yscale = 100;
	}
	
	obj.shake_pow = 0;
	obj.shake_time = 0;

	IllustCreate(obj.task,null);
	PauseMenuCreate(obj.task,null);

//	StageExecute(obj);
}

function StageExecute(obj){

	if(ScrollData.flg & SCROLL_FLG_CAMERA_FREE){
	}else{
		var vec = ScreenPosition(PLAYER_TASK.obj.pos);

		var x = 0;
		var y = 0;
	
		ScrollData.cen.x -= PLAYER_TASK.obj.spd.x * 0.5;
		if(ScrollData.cen.x < STAGE_END_WIDTH)					ScrollData.cen.x = STAGE_END_WIDTH;
		if(ScrollData.cen.x > GAME_WIDTH - STAGE_END_WIDTH)		ScrollData.cen.x = GAME_WIDTH - STAGE_END_WIDTH;

		x = vec.x - ScrollData.cen.x;
		if(vec.y < ScrollData.cen.y - STAGE_FREE_HEIGHT)	y = vec.y - ScrollData.cen.y + STAGE_FREE_HEIGHT;
		if(vec.y > ScrollData.cen.y + STAGE_FREE_HEIGHT)	y = vec.y - ScrollData.cen.y - STAGE_FREE_HEIGHT;
	
	//	ScrollData.pos.x += x * 0.5;
	//	ScrollData.pos.y += y * 0.5;
		ScrollData.pos.x += x;
		ScrollData.pos.y += y;	
	}



	if(ScrollData.min_x > ScrollData.pos.x) 				ScrollData.pos.x = ScrollData.min_x;
	if(ScrollData.min_y > ScrollData.pos.y) 				ScrollData.pos.y = ScrollData.min_y;
	if(ScrollData.max_x < ScrollData.pos.x + GAME_WIDTH )	ScrollData.pos.x = ScrollData.max_x - GAME_WIDTH ;
	if(ScrollData.max_y < ScrollData.pos.y + GAME_HEIGHT)	ScrollData.pos.y = ScrollData.max_y - GAME_HEIGHT;

	if(ScrollData.flg & SCROLL_FLG_NO_RETURN_X){
		if(ScrollData.min_x < ScrollData.pos.x)
			ScrollData.min_x = ScrollData.pos.x;
	}


	var i;
	for(i=1;i<STAGE_RAYER_NUM;i++){
		var work = STAGE_WORK[i];
		work.mc._x = Math.floor(-ScrollData.pos.x * work.sx + 0.5) * 1;
		work.mc._y = Math.floor(-ScrollData.pos.y * work.sy + 0.5) * 1;
	}

	
	var d = 1;
	if(obj.shake_time < 10)	d = obj.shake_time / 10;
	var shk = Vec2dCreate(d * Math.random() * obj.shake_pow * MathSign(),d * Math.random() * obj.shake_pow * MathSign());

	if(--obj.shake_time < 0){
		obj.shake_time = 0;
	}else{
		for(i=1;i<STAGE_RAYER_NUM - 1;i++){
			var work = STAGE_WORK[i];
			work.mc._x  += shk.x;
			work.mc._y  += shk.y;
		}	
	
	}

}


function StageDelete(obj){
	var i;
	for(i=0;i<STAGE_RAYER_NUM;i++){
		var work = STAGE_WORK[i];
		work.mc.removeMovieClip();
	}
	

	if(COLLISION_WORK)	CollisionWorkDelete();


	delete STAGE_WORK;
	STAGE_WORK = null;
	STAGE_TASK = null;
}



function StageSetRectScript(param,id,task){
	// E
	ScrollData.min_x = param.min_x;
	ScrollData.max_x = param.max_x;
	ScrollData.min_y = param.min_y;
	ScrollData.max_y = param.max_y;
	
	// Xe[W萶
	CollisionWorkCreate(ScrollData.max_x,ScrollData.max_y);
	HittestWorkCreate();

}

function StageSetShake(time,power){
	// E
	obj = STAGE_TASK.obj;
	obj.shake_pow = power;
	obj.shake_time = time;
}

function StageSetScaleScript(param,id,task){
	// E
	var work = STAGE_WORK[param.rayer];
	work.sx = param.sx;
	work.sy = param.sy;
}

function StageMcAttachScript(param,id,task){
	// Xe[Wu
	var mc = STAGE_WORK[param.rayer].mc.attachMovie(param.asset,"_" + param.depth, param.depth);
	mc._x = param.pos.x;
	mc._y = param.pos.y;
}


function StageEndPos(obj){
	// XN[E
	if(ScrollData.flg & SCROLL_FLG_END_ROOP){
		if(obj.pos.x < ScrollData.min_x - 10) obj.pos.x += ScrollData.max_x - ScrollData.min_x + 20;
		if(obj.pos.x > ScrollData.max_x + 10) obj.pos.x -= ScrollData.max_x - ScrollData.min_x + 20;
	}else{
		if(obj.pos.x < ScrollData.min_x){
			obj.pos.x = ScrollData.min_x;
			return true;
		}
		if(obj.pos.x > ScrollData.max_x){
			obj.pos.x = ScrollData.max_x;
			return true;
		}
		return false;
	}
}

StageScriptTable = [
	[
		"Stage1_1_0Script",
		"Stage1_2_0Script",
		"Stage1_3_0Script"
	],[
		"Stage2_1_0Script",
		"Stage2_2_0Script",
		"Stage2_3_0Script"
	],[
		"Stage3_1_0Script",
		"Stage3_2_0Script",
		"Stage3_3_0Script"
	],[
		"Stage4_1_0Script",
		"Stage4_2_0Script",
		"Stage4_3_0Script"
	],[
		"Stage5_1_0Script",
		"Stage5_2_0Script",
		"Stage5_3_0Script"
	]
]


function StageSetWorldScript(){
	PlayerStatus.continue_script = StageScriptTable[PlayerStatus.world - 1][PlayerStatus.stage - 1];
	PlayerStatus.continue_type = START_TYPE_BIGIN;
}

function StageStart(){
	// JnXNvg~
	PlayerStatus.warp_type = STAGE_WARP_EMPTY;
	// Xe[W쐬
	StageTaskCreate(null,null);
	// XNvgǂݍ
	var str = PlayerStatus.continue_script;
	var scr = _root[str];
	StageScriptWorkCreate(scr);
	StageScriptRead(scr,STAGE_TASK);
	PlayerCreate(STAGE_TASK,NULL);
	TaskWork.level = LEVEL_PLAYER;
}


function StageSetFlgScript(param,id,task){
	ScrollData.flg = param.flg;
}