function StageObjectAttachCreate(task,param){
	return TaskCreate(
		StageObjectAttachInitalize,
		NULL,
		StageObjectAttachDelete,
		task,PRIO_STAGE,LEVEL_STAGE,param
	);
	
	
}

function StageObjectAttachInitalize(obj,task,param){
	obj.task = task;
	obj.depth = BlockDepthGet();
	obj.mc = _root.sprite.attachMovie(param.asset,"_" + obj.depth.depth, obj.depth.depth);
	obj.mc._xscale = param.scale.x;
	obj.mc._yscale = param.scale.y;

	obj.pos = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.collision = {pos : obj.pos,rect: param.rect,type : param.type,func : null,param : obj};
	CollisionAttach(obj.collision);
	obj.mc._x = obj.pos.x;
	obj.mc._y = obj.pos.y;
}


function StageObjectAttachDelete(obj){
	CollisionRemove(obj.collision);

	BlockDepthPurge(obj.depth);
	obj.mc.removeMovieClip();
}



function StageObjectAttachScript(param,id,task){
	StageObjectAttachCreate(task,param);
}
