/* -----------------------------------------------------------------------------
	㉺ړ֐
	t@C  : updown_foot.as
			: hakuhin (c) 2006/11/26
	
			: ㉺ړ
 ----------------------------------------------------------------------------- */



/* --------------------------------
	^XN
 -------------------------------- */
function UpDownFootCreate(task,param){
	return TaskCreate(
		UpDownFootInitalize,
		UpDownFootExecute,
		UpDownFootDelete,
		task,PRIO_STAGE,LEVEL_STAGE,param
	);
}


// ʏ
function UpDownFootInitalize(obj,task,param){
	obj.task = task;
	
	obj.num = param.num;
	obj.pos = Vec2dClone(param.pos);
	obj.fpos = Vec2dClone(param.pos);
	obj.base = Vec2dClone(param.pos);
	obj.spd = Vec2dCreate(0,0);
	obj.count = param.count;
	obj.length = param.length;

	obj.depth = BlockDepthGet();

	// [N쐬
	obj.mc = _root.sprite.createEmptyMovieClip("updown_foot" + obj.depth.depth, obj.depth.depth);

	var i;
	var w = obj.num * 10;
	var rect = {
		x :  -5,
		y :  -5,
		w :  10,
		h :  10
	};
	
	obj.collision = new Array();
	var i;
	for(i=0;i<obj.num;i++){
		var mc = obj.mc.attachMovie("block_foot","_" + i, i);
		mc._x = -(w / 2) + 10 * i + 5;

		var pos = {x : -(w / 2) + 10 * i + 5 + obj.pos.x, y : obj.pos.y}

		// RWo^
		obj.collision[i] = {pos : pos,rect: rect,type : COLLISION_TYPE_RECT,func : null,param : obj};
		CollisionAttach(obj.collision[i]);
	}
	
	obj.exec = UpDownFootStayInit;
}


// ---------------------------------------
//	ҋ@
// ---------------------------------------
function UpDownFootStayInit(obj){
	var i;
	for(i=0;i<obj.num;i++){
		// RWo^XV
		obj.collision[i].func = UpDownFootHitCheck;
	}
	
	obj.exec = UpDownFootStayExec;
	UpDownFootStayExec(obj);
}

function UpDownFootStayExec(obj){
}


// ---------------------------------------
//	ڐG̃R[obN֐
// ---------------------------------------
function UpDownFootHitCheck(obj){
	var i;
	for(i=0;i<obj.num;i++){
		// RWo^XV
		obj.collision[i].func = null;
	}

	obj.exec = UpDownFootStep1Init;

}

// ---------------------------------------
//	ړ
// ---------------------------------------
function UpDownFootStep1Init(obj){
	obj.frame = 0;
	obj.exec = UpDownFootStep1Exec;
	UpDownFootStep1Exec(obj);

}

function UpDownFootStep1Exec(obj){
	obj.pos.y += obj.length / obj.count;
	if(++ obj.frame > obj.count){
		obj.exec = UpDownFootStep2Init;
	}

}
// ---------------------------------------
//	ړ
// ---------------------------------------
function UpDownFootStep2Init(obj){
	obj.frame = 0;
	obj.exec = UpDownFootStep2Exec;
	UpDownFootStep2Exec(obj);

}

function UpDownFootStep2Exec(obj){
	obj.pos.y -= obj.length / obj.count;
	if(++ obj.frame > obj.count){
		obj.exec = UpDownFootStayInit;
	}

}


// ʏ
function UpDownFootExecute(obj){

	obj.exec(obj);
	obj.spd = Vec2dSub(obj.pos,obj.fpos);

	var i;
	var w = obj.num * 10;
	for(i=0;i<obj.num;i++){
		// RWo^XV
		CollisionRemove(obj.collision[i]);
		obj.collision[i].pos = {x : -(w / 2) + 10 * i + 5 + obj.fpos.x, y : obj.fpos.y};
		CollisionAttach(obj.collision[i]);
	}
	obj.fpos = Vec2dClone(obj.pos);
	

//	obj.pos = Vec2dAdd(obj.pos , obj.spd);
	
	obj.mc._x = Math.floor(obj.pos.x + 0.5);
	obj.mc._y = Math.floor(obj.pos.y + 0.5);

}


function UpDownFootDelete(obj){
	var i;
	for(i=0;i<obj.num;i++){
		CollisionRemove(obj.collision[i]);
	}
	BlockDepthPurge(obj.depth);
	obj.mc.removeMovieClip();
}


/* --------------------------------------------------------------
	XNvg琶
 -------------------------------------------------------------- */
function UpDownFootScript(param,id,task){

	UpDownFootCreate(task,{
		count : param.count,
		pos : param.pos,
		num : param.num,
		length : param.length
	});
}
