/* -----------------------------------------------------------------------------
	x`}[N֐
	t@C  : bench.as
			: hakuhin (c) 2006/02/05
	
			: 	FPS̕\
					^XN̊JnƏIԂCPUgpvZiXNvĝׂ݁A`͏Ȃj
 ----------------------------------------------------------------------------- */

FPS_TASK = null;

FPS_WAIT_TIME	= 1000;		// FPS\XV
CPU_WAIT_COUNT	= 15;		// CPU\XV


function BenchMarkTaskCreate(task,param){
	TaskCreate(BenchMarkInitalize,BenchMarkExecute,BenchMarkDelete,task,PRIO_BENCH_START,LEVEL_SYSTEM,param);
}

function BenchMarkInitalize(obj,task,param){
	obj.task = FPS_TASK = task;
	obj.count = 0;
	obj.now = obj.last = getTimer();
	obj.mc = _root.attachMovie("bench","bench",DEPTH_BENCH);

	obj.mc.fps = "";
	obj.mc.cpu = "";
	obj.cpu_count = 0;
	TaskCreate(CpuStartInitalize,CpuStartExecute,CpuStartDelete,task,PRIO_BENCH_START,LEVEL_SYSTEM,param);
	TaskCreate(CpuEndInitalize,CpuEndExecute,CpuEndDelete,task,PRIO_BENCH_END,LEVEL_SYSTEM,param);
}


function BenchMarkExecute(obj){
	obj.count ++;
	obj.now = getTimer();
	var dif = obj.now - obj.last;
	if (dif >= FPS_WAIT_TIME) {
		obj.mc.fps = Math.floor(obj.count * 1000 / dif) + '/' + FPS;
		obj.last = getTimer();
		obj.count = 0;

	}
}


function BenchMarkDelete(obj){
	obj.mc.removeMovieClip();
	FPS_TASK = null;
}


// ---------------------------------
// x`wb_
// ---------------------------------
function CpuStartInitalize(obj,task,param){
	obj.task = task;
	obj.parent = task.parent.obj;
}

function CpuStartExecute(obj){
	obj.parent.cpu_count = getTimer();
}

function CpuStartDelete(obj){
}


// ---------------------------------
// x`tb_
// ---------------------------------
function CpuEndInitalize(obj,task,param){
	obj.task = task;
	obj.parent = task.parent.obj;
	obj._add = 0;
	obj.count = 0;
}

function CpuEndExecute(obj){
	obj.count ++;
	obj._add += getTimer() - obj.parent.cpu_count;
	if(obj.count >= CPU_WAIT_COUNT){
		obj._add /= 1000 * CPU_WAIT_COUNT / FPS;
		obj.parent.mc.cpu = (Math.floor(obj._add * 1000) / 10) + " %";
		obj._add = 0;
		obj.count = 0;
	}

}

function CpuEndDelete(obj){
}





function BenchMarkOn(){
	if(!FPS_TASK)	BenchMarkTaskCreate(obj.task,null);
}

function BenchMarkOff(){
	if(FPS_TASK)	TaskDelete(FPS_TASK);
}
