/* -----------------------------------------------------------------------------
	n`蔻(`p)
	t@C  : collision.as
			: hakuhin (c)2006/11/01
	
			: n`蔻`p
 ----------------------------------------------------------------------------- */



// n`RWp[^
/*  --------------------- 
param = {
	pref : null,		// AXgiOj
	post : null,		// AXgij

	pos : {x:0,y:0},	// W
	rect : {			// `
		x : 0,
		y : 0,
		w : 0,
		h : 0
	}
}
 --------------------- */

// RWZN^P
COLLISION_SECTOR_WIDTH	= 35;
COLLISION_SECTOR_HEIGHT = 35;

COLLISION_TYPE_RECT		 = 1;	// `
COLLISION_TYPE_FOOT		 = 2;	// 




COLLISION_WORK = null;

// RW[N
function CollisionWorkCreate(w,h){
	var i,j;
	var w_num = Math.ceil(w / COLLISION_SECTOR_WIDTH) + 3;
	var h_num = Math.ceil(h / COLLISION_SECTOR_HEIGHT) + 3;
	
	COLLISION_WORK = new Array();
	for(j=0;j<h_num;j++){
		COLLISION_WORK[j] = new Array();
		for(i=0;i<w_num;i++){
			// _~[AXg쐬
			var obj = {
				start : {pref : null},
				end   : {post : null}
			};
			obj.start.post = obj.end;
			obj.end.pref = obj.start;

			COLLISION_WORK[j][i] = obj;
		}
	}
}
// RW[Nj
function CollisionWorkDelete(){
	delete COLLISION_WORK;
	COLLISION_WORK = null;
}

// RWe[uɓo^
function CollisionAttach(obj){
	// YZN^
	var w = Math.floor(obj.pos.x / COLLISION_SECTOR_WIDTH);
	var h = Math.floor(obj.pos.y / COLLISION_SECTOR_HEIGHT);

	var sector = COLLISION_WORK[h][w];

	var pref = sector.start;
	var post = pref.post;

	// AXgɌ
	pref.post = obj;
	post.pref = obj;
	obj.pref = pref;
	obj.post = post;
	
	return obj;
}

// RWe[uO
function CollisionRemove(obj){
	var pref = obj.pref;
	var post = obj.post;
	// AXgO
	pref.post = post;
	post.pref = pref;
}



// ---------------------------------------
// RWo^(XNvg)
// ---------------------------------------
COLLISION_SCRIPT_WORK = new Array();	// ޔpz

function CollisionAttachScript(param,id,task){
	var list = CollisionAttach({
		pos  : param.pos,
		rect : param.rect,
		type : param.type,
		func : null,
		id   : id,
		param: {spd : Vec2dCreate(0,0)}
	});

	COLLISION_SCRIPT_WORK.push(list);
}