/* -----------------------------------------------------------------------------
	L[{[h
	t@C  : key.as
			: hakuhin (c) 2006/01/31
	
			: L[{[hp֐
 ----------------------------------------------------------------------------- */


KEY_MENU_FIRST_WAIT = 0.5;		// j[~
KEY_MENU_LOOP_WAIT  = 0.075;	// j[[v~
KEY_PRECEDE_TIME    = 0.2;		// s


KEY_PLAYER_NUM = 2;		// L
KEY_ATTACK_NUM = 3;		// U{^


// L[tO
KEY_UP		= 0x01;		// 
KEY_DOWN	= 0x02;		// 
KEY_LEFT	= 0x04;		// 
KEY_RIGHT	= 0x08;		// E
KEY_A		= 0x10;		// UA
KEY_B		= 0x20;		// UB
KEY_C		= 0x40;		// ⏕
KEY_PAUSE	= 0x80;		// |[Y

KEY_AB		= KEY_A | KEY_B;		// A+B
KEY_WALK	= KEY_LEFT | KEY_RIGHT;	// tO
KEY_ALL		= 0xFF;					// StO



KeyCodeArray = [
	KEY_UP,
	KEY_DOWN,
	KEY_LEFT,
	KEY_RIGHT,
	KEY_B,
	KEY_A,
	KEY_PAUSE
];

KEY_CODE_ARRAY_MAX = KeyCodeArray.length;

KEY_TASK = null;


// Cvbgnf[^
_global.InputKey = new Array();
var i;
for(i=0;i<KEY_PLAYER_NUM;i++){
	InputKey[i] = 0;
}

// gKnf[^
_global.KeyData = new Array();
for(i=0;i<KEY_PLAYER_NUM;i++){
	KeyData[i] = 0;
}

function KeyTaskCreate(task,param){
	return TaskCreate(KeyInitalize,KeyExecute,KeyDelete,task,PRIO_KEY,LEVEL_SYSTEM,param);
}
 
 
function KeyInitalize(obj,task,param){
	var i;
	obj.player = param;
	obj.task = KEY_TASK = task;
	// L[f[^
	obj.menu_count;
	obj.pre_count = new Array();
	for(i=0;i<KEY_CODE_ARRAY_MAX;i++){
		obj.pre_count[i] = 0;
	}
	obj.key = {
		Dat : 0,
		Trg : 0,
		Menu : 0,
		Pre : 0
	}
}

function KeyExecute(obj){
	var i;
	var _key = obj.key;
	var input = InputKey[obj.player];
	for(i=0;i<KEY_CODE_ARRAY_MAX;i++){
		
		_key.Trg &= ~KeyCodeArray[i];
		_key.Menu &= ~KeyCodeArray[i];
		
		// L[ꂽ
		if(input & KeyCodeArray[i]){
			// O񉟂ĂȂ΃gK[
			if(!(_key.Dat & KeyCodeArray[i])){
				_key.Trg |= KeyCodeArray[i];
				_key.Menu |= KeyCodeArray[i];
				obj.menu_count = KEY_MENU_FIRST_WAIT;

				obj.pre_count[i] = KEY_PRECEDE_TIME;
				_key.Pre |= KeyCodeArray[i];

			}
			
			obj.menu_count -= FRAME_TIME;
			if(obj.menu_count < 0.0){
				_key.Menu |= KeyCodeArray[i];
				obj.menu_count = KEY_MENU_LOOP_WAIT;
			}

			_key.Dat |= KeyCodeArray[i];
		}else{
			_key.Dat &= ~KeyCodeArray[i];
		}

		obj.pre_count[i] -= FRAME_TIME;
		if(obj.pre_count[i] < 0.0){
			_key.Pre &= ~KeyCodeArray[i];
			obj.pre_count[i] = 0;
		}
		
		if(!(_key.Dat & KeyCodeArray[i])){
			_key.Pre &= ~KeyCodeArray[i];
		}
	}
	
	KeyData[obj.player] = _key;

}


function KeyDelete(obj){
	KEY_TASK = null;
}



function KeyClear(){
	var i;
	var input = KEY_TASK.obj.key;
//	input.Dat = 0;
	input.Trg = 0;
	input.Menu = 0;
	input.Pre = 0;
	for(i=0;i<KEY_CODE_ARRAY_MAX;i++){
		KEY_TASK.obj.pre_count[i] = 0;
	}

	KEY_TASK.obj.menu_count = 0;
}