/* -----------------------------------------------------------------------------
	p[eBNp֐
	t@C  : particle.as
			: hakuhin (c) 2006/03/12
	
			: p[eBNp֐
 ----------------------------------------------------------------------------- */


/* -----------------------------------------------------------
	p[eBN^XN
 	order = {
		depth    : 0,		// p[eBN[x
		res      : null,	// \[X
		ptc_init : null,	// p[eBN֐
		ptc_exec : null,	// p[eBNړ֐
		ptc_del  : null,	// p[eBNj֐

		// ^XNp -------------------------------
		emt_init : null,	// G~b^֐
		emt_exec : null,	// G~b^ړ֐
		emt_del  : null,	// G~b^j֐
		gen_num  : 1,		// 
		gen_time : 1,		// Ԋu
		emt_time : 100,		// G~b^I
		kill_time: 10,		// 
		param    : null		// ̑̃p[^
	};
	ParticleTaskCreate(task,param);
 ----------------------------------------------------------- */
function ParticleTaskCreate(task,level,param){
	return TaskCreate(
		ParticleTaskInit,
		ParticleTaskExec,
		ParticleTaskDel,
		task,PRIO_PLAYER,level,param
	);
}

function ParticleTaskInit(obj,task,param){
	obj.task = task;
	obj.work = ParticleCreate(param);
	obj.emt_time = param.emt_time;
	obj.kill_time = param.kill_time;
	obj.gen_time = param.gen_time;
	obj.gen_count = 0;
	obj.gen_num = param.gen_num;
	obj.emt_init = param.emt_init;
	obj.emt_exec = param.emt_exec;
	obj.emt_del  = param.emt_del ;
	obj.depth = param.depth;
	obj.param = param.param;
	obj.emt_init(obj,obj.work.emt_mc);
	
	var i;
	for(i=0;i<obj.gen_num;i++){
		ParticleGenerate(obj.work);
	}
}

function ParticleTaskExec(obj){
	if(obj.emt_time  > 0){
		obj.emt_time --;
		obj.gen_count ++;
		if(obj.gen_count > obj.gen_time){
			var i;
			for(i=0;i<obj.gen_num;i++){
				ParticleGenerate(obj.work);
			}
			obj.gen_count = 0;
		}
	}else{
		obj.kill_time --;
		if(obj.kill_time < 0){
			TaskDelete(obj.task);
			return;
		}
	}
	obj.emt_exec(obj,obj.work.emt_mc);
	ParticleExecute(obj.work);
}


function ParticleTaskDel(obj){
	obj.emt_del(obj,obj.work.emt_mc);
	ParticleDestory(obj.work);
}





/* -----------------------------------------------------------
	p[eBN[N쐬
	order = {
		depth    : 0,		// p[eBN[x
		res      : null,	// \[X
		ptc_init : null,	// p[eBN֐
		ptc_exec : null,	// p[eBNړ֐
		ptc_del  : null,	// p[eBNj֐
	};
	ParticleCreate(param);
 ----------------------------------------------------------- */
function ParticleCreate(param){
	var emt_mc = param.target.createEmptyMovieClip("emt" + param.depth, param.depth);

	var tank = {pref : null};
	var end  = {post : null};
	tank.post = end;
	end.pref = tank;

	var work = {
		res		 : param.res,		// \[X
		emt_mc	 : emt_mc,			// G~b^
		tank     : tank,			// p[eBN^N
		ptc_init : param.ptc_init,	// p[eBN֐
		ptc_exec : param.ptc_exec,	// p[eBNs֐
		ptc_del  : param.ptc_del 	// p[eBNI֐
	};
	return work;
}


/* -----------------------------------------------------------
	p[eBN[Ns
 ----------------------------------------------------------- */
function ParticleExecute(work){
	var pref =work.tank.post;
	for(;;){
		var post = pref.post;
		if(post == null)	break;
		var ptc = pref.mc;
		work.ptc_exec(work.emt_mc,ptc);
		AnmCmdPlay(ptc);
		ptc.time --;
		if(ptc.time < 0){
			ParticleDelete(work,pref);
		}
		pref = post;
	}
}


/* -----------------------------------------------------------
	p[eBN[Nj
 ----------------------------------------------------------- */
function ParticleDestory(work){
	var tank = work.tank;
	var i;
	while(true){
		var post = tank.post;
		if(post.post == null)	break;
		ParticleDelete(work,post);
	}
	work.emt_mc.removeMovieClip();
}


/* -----------------------------------------------------------
	p[eBNq쐬
 ----------------------------------------------------------- */
function ParticleGenerate(work){
	var pref = work.tank;
	var post = pref.post;
	var depth = work.emt_mc.getNextHighestDepth();
	var obj = {
		mc : work.emt_mc.attachMovie(work.res,"_" + depth,depth),
		time : 0,
		pref : pref,
		post : post
	};
	
	pref.post = obj;
	post.pref = obj;
	

	work.ptc_init(work.emt_mc,obj.mc);
}


/* -----------------------------------------------------------
	p[eBNI
 ----------------------------------------------------------- */
function ParticleDelete(work,obj){
	var pref = obj.pref;
	var post = obj.post;
	
	pref.post = post;
	post.pref = pref;
	
	work.ptc_del(work.emt_mc,obj.mc);
	obj.mc.removeMovieClip();
}
