/* -----------------------------------------------------------------------------
	^XNVXe
	t@C  : task.as
			: hakuhin (c) 2006/07/31
 ----------------------------------------------------------------------------- */

TaskWork = null;

/* -----------------------------------------------------------
	 ^XNVXeN
	Ԃl		[NIuWFNg
----------------------------------------------------------- */
function TaskInitalize(){
	TaskWork = {
		start : {pref : null},
		end   : {post : null},
		level : 0	// sx
	};
	TaskWork.start.post = TaskWork.end;
	TaskWork.end.pref = TaskWork.start;
	
	#include "composition"
	{
		TaskWork.count = 0;
	}
}

/* -----------------------------------------------------------------------
	^XNs
	01		[NIuWFNg
 ----------------------------------------------------------------------- */
function TaskExecute(){
	TaskWork.head = TaskWork.start.post;
	for(;;){
		if(TaskWork.head.post == null)			break;
		if(TaskWork.head.level >= TaskWork.level){
			TaskWork.head.exec(TaskWork.head.obj);
		}
		TaskWork.head = TaskWork.head.post;
	}
}

/* -----------------------------------------------------------------------
	^XNVXej
	01		[NIuWFNg
 ----------------------------------------------------------------------- */
function TaskDestroy(TaskWork){
	delete TaskWork;
	TaskWork = null;
}


/* -----------------------------------------------------------------------
	^XNo^
	01 [NIuWFNg
	02 ֐
	03 s֐
	04 j֐
	05 e^XNANULLŒʏ^XN
	06 DxiႢl珇ԂɎs
	07 |[Yx(level萔l̒Ⴂƒ~
	08 p[^	 (IuWFNg`œn
	Ԃl	^XN[N
 ----------------------------------------------------------------------- */
function TaskCreate(init_func,exec_func,del_func,parent,prio,level,param){
	var pref;
	var post;
	// Dʒu ------------------------
	if(prio < 64){
		post = TaskWork.start.post;
		for(;;){
			if(post.post == NULL)		break;
			if(prio <= post.prio)		break;
			post = post.post;
		}
		pref = post.pref;
	}else{
		pref = TaskWork.end.pref;
		for(;;){
			if(pref.pref == NULL)		break;
			if(prio >= pref.prio)		break;
			pref = pref.pref;
		}
		post = pref.post;
	}

	// ^XN[N -----------------------
	var my = {
		pref    : pref,			// O^XN
		post    : post,			// ^XN
		obj     : new Object(),	// IuWFNg
		parent  : parent,		// e
		level   : level,		// x
		prio    : prio,			// Dx
		exec    : exec_func,	// s֐
		del     : del_func		// I֐
	};

	// q^XNXg ---------------
	my.child = [
		{pref:null,task:null},
		{post:null,task:null}
	];
	my.child[0].post = my.child[1];
	my.child[1].pref = my.child[0];
	
	// eɎq^XNo^ -----------------
	if(parent){
		var c_pref = parent.child[0];
		var c_post = c_pref.post;
		var list = my.cld_list = {
			pref : c_pref,
			post : c_post,
			task : my
		};
		c_pref.post = list;
		c_post.pref = list;
	}
	
	// Xgɓo^ -----------------------
	pref.post = my;
	post.pref = my;
	
	// ֐
	init_func(my.obj,my,param);

	#include "composition"
	{
		TaskWork.count ++;
		trace(" :" + TaskWork.count);
	}

	return my;
}

/* -----------------------------------------------------------------------
	^XNj
	01 [NIuWFNg
	02 ^XNCfbNX
 ----------------------------------------------------------------------- */
function TaskDelete(task){
	// q^XNȂe烊XgO
	if(task.parent){
		var list = task.cld_list;
		var pref = list.pref;
		var post = list.post;
		pref.post = post;
		post.pref = pref;
		delete list;
	}

	// q^XN΂ׂĔj
	var list = task.child[0].post;
	for(;;){
		var post = list.post;
		if(post == null)	break;
		TaskDelete(list.task);
		list = post;
	}

	// ^XNXgO
	var pref = task.pref;
	var post = task.post;
	pref.post = post;
	post.pref = pref;

	// sȂwb_߂
	if(TaskWork.head == task){
		TaskWork.head = pref;
	}
	

	// j֐
	task.del(task.obj);

	#include "composition"
	{
		TaskWork.count --;
		trace("j :" + TaskWork.count)
	}
	// j
	delete task.obj;
	delete task;
}


/* -----------------------------------------------------------------------
	^XNɕtꂽq^XNj
	01 [NIuWFNg
	02 ^XNCfbNX
 ----------------------------------------------------------------------- */
function TaskDeleteChild(task){
	// q^XN΂ׂĔj
	var list = task.child[0].post;
	for(;;){
		var post = list.post;
		if(post == null)	break;
		TaskDelete(list.task);
		list = post;
	}

}